#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const int INF = 2e9;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);
const int LOG = 31;

vector<int> cnt[2];
unordered_map<ll, int> mem;
int last = -1;

inline bool check(vector<int> a, int b) {
	for (int i = 0; i < (int)a.size(); i++) {
		a[i] ^= b;

		if (i && a[i - 1] > a[i]) return 0;
	}

	return 1;
}

inline ll pack(int d, int l, int r) {
	return ((ll)d << 32) + ((ll)l << 21) + r;
}

int mote(const vector<int> &a, int d, int l, int r) {
	if (d < 0 || r - l < 2) return 0;

	ll key = pack(d, l, r);
	int hasKey = mem.count(key);

	if (hasKey && l <= last && last < r) {
		int val = mem[key];

		if (val == 0 || val == 1) {
			cnt[val][d]--;
		}
	} else if (hasKey) {
		int val = mem[key];

		if (val < 2) {
			return val;
		} else {
			return val - 3;
		}
	}

	vector<int> tmp(r - l);

	for (int i = l; i < r; i++) {
		tmp[i - l] = (a[i] >> d) & 1;
	}

	tmp.resize(unique(all(tmp)) - tmp.begin());

	if ((int)tmp.size() > 2) return (mem[key] = -1);
	if ((int)tmp.size() == 1) return (mem[key] = mote(a, d - 1, l, r) + 3) - 3;

	int m = l;

	while (m < r && ((a[m] >> d) & 1) == tmp[0]) m++;

	int m1 = mote(a, d - 1, l, m), m2 = mote(a, d - 1, m, r);

	if (m1 == -1 || m2 == -1) return (mem[key] = -1);

	if (tmp[0] == 0) {
		cnt[0][d]++;
		return (mem[key] = m1 | m2);
	} else {
		cnt[1][d]++;
		return (mem[key] = m1 | m2 | (1 << d));
	}
}

inline int getAns(const vector<int> &a) {
	// if (check(a, 0)) return 0;

	fill(all(cnt[0]), 0);
	fill(all(cnt[1]), 0);
	int ans = mote(a, LOG - 1, 0, (int)a.size());

	for (int i = 0; i < LOG; i++) {
		if (cnt[0][i] && cnt[1][i]) return -1;
	}

	// if (check(a, ans)) return ans;
	return ans;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

// #ifdef GA_ROI
// 	freopen("/home/roi/prjs/file.in", "r", stdin);
// 	freopen("/home/roi/prjs/file.out", "w", stdout);
// #else
	freopen("order.in", "r", stdin);
	freopen("order.out", "w", stdout);
// #endif

	int n;
	cin >> n;

	vector<int> a(n);
	cnt[0].resize(LOG);
	cnt[1].resize(LOG);

	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	cout << getAns(a) << "\n";

	int q;
	cin >> q;

	while (q--) {
		int p, v;
		cin >> p >> v;
		p--;

		a[p] = v;

		cout << getAns(a) << "\n";
	}

	return 0;
}
