#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const int INF = 2e9;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);
const int LOG = 31;

inline bool check(vector<int> a, int b) {
	for (int i = 0; i < (int)a.size(); i++) {
		a[i] ^= b;

		if (i && a[i - 1] > a[i]) return 0;
	}

	return 1;
}

inline int getAns(const vector<int> &a) {
	for (int i = 0; i < 1000; i++) {
		if (check(a, i)) {
			return i;
		}
	}

	return -1;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

#ifdef GA_ROI
	freopen("/home/roi/prjs/file.in", "r", stdin);
	freopen("/home/roi/prjs/file.out", "w", stdout);
#else
	freopen("order.in", "r", stdin);
	freopen("order.out", "w", stdout);
#endif

	int n;
	cin >> n;

	vector<int> a(n);

	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	cout << getAns(a) << "\n";

	int q;
	cin >> q;

	while (q--) {
		int p, v;
		cin >> p >> v;
		p--;

		a[p] = v;

		cout << getAns(a) << "\n";
	}

	return 0;
}
