#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<set>

using namespace std;
int mat[1000][1000];
int n, m;
bool used[1000];
void dj()
{
    int dist[n];
    int sq[n];
    for (int i = 0; i < n; ++i)
    {
        dist[i] = 1e9;
        sq[i] = -1;
    }
    dist[0] = 0;
    sq[0] = 0;
    while (true)
    {
        int mn = 1e9;
        int vt = -1;
        for (int i = 0; i < n; ++i)
        {
            if (used[i]) continue;
            if (dist[i] < mn)
            {
                mn = dist[i];
                vt = i;
            }
        }
        if (mn == 1e9) break;
        used[vt] = true;
        for (int i = 0; i < n; ++i)
        {
            if (!used[i] && mat[vt][i] != -1)
            {
                if (dist[i] > dist[vt] + mat[vt][i] || (dist[i] == dist[vt] + mat[vt][i] && sq[i] < sq[vt] + mat[vt][i] * mat[vt][i]))
                {
                    dist[i] = dist[vt] + mat[vt][i];
                    sq[i] = sq[vt] + mat[vt][i] * mat[vt][i];
                }
            }
        }
    }
    cout << dist[n - 1] << " " << sq[n - 1] << endl;
}
int main()
{
    cin >> n >> m;
    for (int i = 0; i < 1000; ++i)
    {
        for (int j = 0; j < 1000; ++j)
        {
            mat[i][j] = -1;
        }
    }
    for (int i = 0; i < m; ++i)
    {
        int a;
        cin >> a;
        int u, v, t;
        cin >> u >> t >> v;
        if (mat[u - 1][v - 1] == -1) mat[u - 1][v - 1] = t;
        else mat[u - 1][v - 1] = min(mat[u - 1][v - 1], t);
    }
    dj();
}
