# include <iostream>
# include <cstdio>
# include <vector>
# include <cstring>

using namespace std;

const int MAX_N = 1e6;
int n;
int a[MAX_N];

vector<int> get(int l, int r, int curr = 30)
{
    if (curr == -1)
    {
        return vector<int> (31, 2);
    }
    vector<int> res(31, -1);
    int frst = -1;
    if (a[l] & (1 << curr))
    {
        bool flag = false;
        for (int i = l; i < r; i++)
        {
            if ((a[i] & (1 << curr)) == 0)
            {
                if (!flag)
                {
                    frst = i;
                    flag = true;
                }
            }
            else
            {
                if (flag)
                {
                    return res;
                }
            }
        }
        if (frst == -1)
        {
            res[curr] = 2;
        }
        else
        {
            res[curr] = 1;
        }
    }
    else
    {
        bool flag = false;
        for (int i = l; i < r; i++)
        {
            if ((a[i] & (1 << curr)))
            {
                if (!flag)
                {
                    frst = i;
                    flag = true;
                }
            }
            else
            {
                if (flag)
                {
                    return res;
                }
            }
        }
        if (frst == -1)
        {
            res[curr] = 2;
        }
        else
        {
            res[curr] = 0;
        }
    }
    if (frst == -1)
    {
        vector<int> o = get(l, r, curr - 1);
        o[curr] = 2;
        return o;
    }
    vector<int> o = get(l, frst, curr - 1), s = get(frst, r, curr - 1);
    if (o[0] == -1 || s[0] == -1)
    {
        res[0] = -1;
        return res;
    }
    for (int i = 0; i < curr; i++)
    {
        if ((o[i] == 0 && s[i] == 1) || (o[i] == 1 && s[i] == 0))
        {
            res[0] = -1;
            return res;
        }
        if (o[i] == 2)
        {
            res[i] = s[i];
            continue;
        }
        if (s[i] == 2)
        {
            res[i] = o[i];
            continue;
        }
        if (o[i] == 1 && s[i] == 1) res[i] = 1;
        else res[i] = 0;
    }
    return res;
}

int ans()
{
    vector<int> all = get(0, n);
    if (all[0] == -1) return -1;
    int res = 0;
    for (int i = 0; i <= 30; i++)
    {
        if (all[i] == 1)
        {
            res |= (1 << i);
        }
    }
    return res;
}

int main()
{
   // freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    cout << ans() << "\n";
    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        int p, u;
        cin >> p >> u;
        --p;
        a[p] = u;
        cout << ans() << "\n";
    }
    return 0;
}
