#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 2e5 + 100, inf = 1e9 + 100, mod = 1e9 + 993;

ll fen[maxn], n;

void inc(int i, ll v){
    for (; i < n; i = (i | (i + 1)))
        fen[i] += v;
}

int sum(int i){
    ll v = 0;
    for (; i >= 0; i = (i & (i + 1)) - 1)
        v += fen[i];
    return v;
}

int mas[maxn];

int main(){
    #ifdef ONPC
    ifstream cin("a.in");
    ofstream cout("a.out");
    #else
    ifstream cin("sum.in");
    ofstream cout("sum.out");
    #endif // ONPC
    ios::sync_with_stdio(0);
    n = maxn - 100;
    for (ll i = 1; i <= n; i++)
        inc(i - 1, i * i);
    for (ll i = 1; i <= n; i++){
        int l = 0, r = n + 1;
        while (r - l > 1){
            ll m = (l + r) / 2;
            if (sum(m - 1) - sum(m - 2) >= i * i)
                r = m;
            else
                l = m;
        }
        mas[i] = r;
    }
    ll a1, a2;
    cin >> a1 >> a2;
    cout << a1 + a2;
}

/*#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 2e5 + 100, inf = 1e9 + 100, mod = 1e9 + 993;


struct treap{
    int v, x, y, sz;
    treap *l, *r;
};

typedef treap * ptr;

ptr create(int v, int x){
    ptr t = new treap;
    t->v = v;
    t->x = x;
    t->y = rand();
    t->sz = 1;
    t->l = nullptr;
    t->r = nullptr;
    return t;
}

int sz(ptr t){
    return t == nullptr ? 0 : t->sz;
}

void upd(ptr &t){
    if (t != nullptr)
        t->sz = 1 + sz(t->l) + sz(t->r);
}

void split(ptr t, ptr &l, ptr &r, int key){
    if (t == nullptr){
        l = nullptr;
        r = nullptr;
        return;
    }
    if (t->x <= key)
        split(t->l, t->l, r, key), l = t;
    else
        split(t->r, l, t->r, key), r = t;
    upd(l);
    upd(r);
}

void merge(ptr &t, ptr l, ptr r){
    if (l == nullptr){
        t = r;
        return;
    }
    if (r == nullptr){
        t = l;
        return;
    }
    if (l->y <= r->y)
        merge(l->r, l->r, r), t = l;
    else
        merge(r->l, l, r->l), t = r;
    upd(t);
}

ptr root = nullptr;

int main()
{
    #ifdef ONPC
    ifstream cin("a.in");
    ofstream cout("a.out");
    #else
    ifstream cin("sum.in");
    ofstream cout("sum.out");
    #endif // ONPC
    ios::sync_with_stdio(0);
    int a, b;
    cin >> a >> b;

}
*/
