#define _CRT_SECURE_NO_DEPRECATE

#include<cstring>
#include<cmath>
#include<string>
#include<vector>
#include<map>
#include<map>
#include<set>
#include<iostream>
#include<algorithm>

using namespace std;
typedef long long ll;

void solve();
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	solve();
}

inline int sgn(ll a) { if (a < 0) return -1; if (a > 0) return 1; return 0; }
bool intriangle(pair<ll, ll> a, pair<ll, ll> b, pair<ll, ll> c, pair<ll, ll> d) {
	pair<ll, ll> AD(d.first - a.first, d.second - a.second);
	pair<ll, ll> AA(b.first - a.first, b.second - a.second);
	pair<ll, ll> BD(d.first - b.first, d.second - b.second);
	pair<ll, ll> BB(c.first - b.first, c.second - b.second);
	pair<ll, ll> CD(d.first - c.first, d.second - c.second);
	pair<ll, ll> CC(a.first - c.first, a.second - c.second);
	return sgn(AD.first * AA.second - AD.second * AA.first) == sgn(BD.first * BB.second - BD.second * BB.first) &&
		sgn(CD.first * CC.second - CD.second * CC.first) == sgn(BD.first * BB.second - BD.second * BB.first);
}

double waytosg(pair<ll, ll> a, pair<ll, ll> b, pair<ll, ll> c) {
	pair<ll, ll> CA(c.first - a.first, c.second - a.second);
	pair<ll, ll> AB(b.first - a.first, b.second - a.second);
	pair<ll, ll> CB(c.first - b.first, c.second - b.second);
	ll sc = abs(AB.first * CA.second - CA.first * AB.first);
	double rs = sc;
	rs /= sqrt(AB.first * AB.first + AB.second * AB.second);
	if (0 >= (CA.first * CA.second + AB.first * AB.second))
		return sqrt(CA.first * CA.first + CA.second * CA.second);
	if (0 >= (CB.first * CB.second + AB.first * AB.second))
		return sqrt(CA.first * CA.first + CA.second * CA.second);
	return rs;
}

string temp;
void solve() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	pair<int, int> p[70];
	for (int i = 0; i < n; ++i)
		cin >> p[i].first >> p[i].second;
	int q;
//	cout << waytosg(p[0], p[1], p[2]) << endl;
//	cout << waytosg(p[0], p[1], p[3]) << endl;
//	exit(0);
	cin >> q;
	if (n > 20) {
		while (q--) {
			bool loop = true;
			for (int i = 0; loop && i < n; ++i)
				for (int j = i + 1; loop && j < n; ++j){
						int k = -1;
						for (int c = 0; c < n; ++c) {
							if (c != i && c != j) {
								if (k == -1)k = c;
								else if (waytosg(p[i], p[j], p[c]) <= waytosg(p[i], p[j], p[k]))
									k = c;
							}
						}
						cout << "? 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
						cin >> temp;
						if (temp == "Yes") {
							cout << "! 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
							loop = false;
						}
					}
			if (loop) {
				exit(228);
			}
		}
		exit(0);
	}
	while (q--) {
		bool loop = true;
		for (int i = 0; loop && i < n; ++i)
			for (int j = i + 1; loop && j < n; ++j)
				for (int k = j + 1; loop && k < n; ++k) {
					bool ok = true;
					for (int c = 0; ok && c < n; ++c) {
						if (c != i && c != j && c != k && intriangle(p[i], p[j], p[k], p[c]))
							ok = false;
					}
					if (ok) {
						cout << "? 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
						cin >> temp;
						if (temp == "Yes") {
							cout << "! 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
							loop = false;
						}
					}
				}
	}
	exit(0);

}

