#include <bits/stdc++.h>

using namespace std;

struct node
{
    node *p, *n;
    int len;
    bool ch;
    explicit node(int len = 0, bool ch = 0) : len(len), ch(ch), p(0), n(0) {}
    bool cbc() const
    {
        if (n)
            if (n->len > len)
                return 1;
        if (p)
            if (p->len > len)
                return 1;
        return 0;
    }
    void refr()
    {
        ch = 0;
        if (n)
        {
            n->ch = 0;
            len += n->len;
            if (n->n)
                n->n->p = this;
            n = n->n;
        }
        if (p)
        {
            p->ch = 0;
            len += p->len;
            if (p->p)
                p->p->n = this;
            p = p->p;
        }
    }
};

bool solve(string s, string t)
{
    vector<int> sect(1, 1);
    vector<bool> ch(1, s[0] != t[0]);
    int n = s.length();
    for (int i = 1; i < n; i++)
    {
        if (s[i] != s[i - 1])
        {
            sect.push_back(0);
            ch.push_back(s[i] != t[i]);
        }
        else if (t[i] != t[i - 1])
            return 0;
        sect.back()++;
    }
    node *B, *E;
    B = E = new node(sect[0], ch[0]);
    for (int i = 1; i < sect.size(); i++)
    {
        if (ch[i] && ch[i - 1])
            return 0;
        //cerr << sect[i] << " " << ch[i] << "\n";
        node *nE = new node(sect[i], ch[i]);
        E->n = nE;
        nE->p = E;
        E = nE;
    }
    queue<node*> bfs;
    for (node* N = B; N != 0; N = N->n)
    {
        //cerr << N->cbc() << " " << N->ch << "\n";
        if (N->cbc() && N->ch)
        bfs.push(N);
    }
    //cerr << bfs.size() << "\n";
    while(!bfs.empty())
    {
        node *v = bfs.front();
        bfs.pop();
        if (v->ch == 0)
            continue;
        if (v->p == B)
            B = v;
        v->refr();
        if (v->n)
            if (v->n->cbc() && v->n->ch)
                bfs.push(v->n);
        if (v->p)
            if (v->p->cbc() && v->p->ch)
                bfs.push(v->p);
    }
    int cnt = 0;
    for (node *N = B; N != 0; N = N->n)
    {
        //cerr << N->len << " " << N->ch << "\n";
        if (N->ch)
            cnt++;
    }
    //cerr << cnt;
    return (cnt == 0);
}

int main()
{
    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        string s, t;
        cin >> s >> t;
        if (solve(s, t))
            cout << "Yes\n";
        else
            cout << "No\n";
    }
    return 0;
}
