#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <bitset>

using namespace std;

int main()
{
    int n;
    cin >> n;

    vector < bitset<30> > arr(n);
    for(int i = 0; i < n; i++) {
        int tmp;
        cin >> tmp;
        arr[i] = bitset<30>(tmp);
    }

    int q;
    cin >> q;
    vector <int> stat(30);
    vector <int> ans;
    for(int i = 0; i <= q; i++) {
        stat.assign(30, 2);
        bool ok = true;
        for(int j = 1; j < n; j++) {
            for(int k = 29; k >= 0; k--) {
                if(arr[j][k] && !arr[j - 1][k]) {
                    if(stat[k] == 1) ok = false;
                    stat[k] = 0;
                    break;
                }
                else if(!arr[j][k] && arr[j - 1][k]) {
                    if(stat[k] == 0) ok = false;
                    stat[k] = 1;
                    break;
                }
            }

            /*cout << "Stat is: " << endl;
            for(auto j: stat) cout << j << " ";
            cout << endl;*/
        }
        if(ok) {
            bitset<30> nowans(0);
            for(int k = 0; k < 30; k++) if(stat[k] == 1) nowans[k] = true;
            ans.push_back((int)nowans.to_ulong());
        }
        else
            ans.push_back(-1);

        //change
        if(i < q) {
            int pos, val;
            cin >> pos >> val;
            arr[pos - 1] = bitset<30>(val);
        }
    }

    for(auto j: ans) cout << j << endl;
    return 0;
}
