#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const long long MAXN = 200005;
const long long INF = 1500000000;

pair <long long, long long> can[MAXN];
vector <long long> tm;

int main()
{
    ios_base::sync_with_stdio(false);

    long long n;
    cin >> n;
    tm.resize(n + 1);
    for(long long i = 1; i <= n; i++) cin >> tm[i];
    for(long long i = 1; i < n; i++) {
        cin >> can[i].first >> can[i].second;
    }

    long long maxr = 0;
    for(int i = 1; i < n; i++) maxr = max(maxr, can[i].second);

    for(int i = 1; i <= n; i++) {
        long long l = -1, r = maxr;
        while(r > l + 1) {
            long long j = (l + r) / 2;
            bool ok = true;
            //to left
            int now = j;
            for(int k = i - 1; k >= 1; k--) {
                if(now >= can[k].first && now <= can[k].second) continue;
                if(now < can[k].first && now + tm[k + 1] >= can[k].first) {
                    now = can[k].first;
                    continue;
                }
                ok = false;
                break;
            }
            //to right
            now = j;
            for(int k = i + 1; k <= n; k++) {
                if(now >= can[k - 1].first && now <= can[k - 1].second) continue;
                if(now < can[k - 1].first && now + tm[k - 1] >= can[k - 1].first) {
                    now = can[k - 1].first;
                    continue;
                }
                ok = false;
                break;
            }
            //check
            if(ok) {
                r = j;
            }
            else {
                l = j;
            }
        }
        cout << r << endl;
    }

    return 0;
}
