#include <iostream>
#include <vector>
#include <set>
#include <bitset>

using namespace std;

const int maxn = 2280;
const int inf = 1e9;
vector<pair<int, int>> g[maxn];
int d[maxn];
int ans[maxn];
int n, m;
set<pair<int, int>> q;

int main()
{
    cin >> n >> m;
    for (int i = 0; i < m; ++i)
    {
        int s;
        cin >> s;
        int fr, to, t;
        cin >> fr >> t >> to;
        g[fr - 1].push_back({to - 1, t});
    }
    for (int i = 0; i < n; ++i)
        d[i] = inf;
    d[0] = 0;
    q.insert({0, 0});
    while (!q.empty())
    {
        int v = q.begin()->second;
        q.erase(q.begin());
        for (int i = 0; i < g[v].size(); ++i)
        {
            int to = g[v][i].first;
            int cost = g[v][i].second;
            if (d[v] + cost < d[to])
            {
                q.erase({d[to], to});
                d[to] = d[v] + cost;
                q.insert({d[to], to});
                ans[to] = max(ans[to], ans[v] + cost * cost);
            }
        }
    }
    cout << d[n - 1] << " " << ans[n - 1];
    return 0;
}
