#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#define TASK "trains"
#define inb push_back
#define X first
#define Y second
#define LINF 9e18

const int N = 1e3 + 5, M = 1e5 + 5;
int n, m;
vector<pii> a[M];
pair<ll, ll> d[N];
vector<pii> g[N];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	scanf("%d%d", &n, &m);
	int k;
	for (int i = 0; i < m; ++i)
	{
		scanf("%d", &k);
		a[i].resize(k + 1);
		for (int j = 0; j < k; ++j)
			scanf("%d%d", &a[i][j].X, &a[i][j].Y), g[a[i][j].X].inb({ i, j });
		scanf("%d", &a[i][k].X), g[a[i][k].X].inb({ i, k });
	}
	for(int i = 2; i <= n; ++i)
		d[i] = { LINF, LINF };
	set<pair<pair<ll, ll>, int> > s;
	s.insert({ d[1], 1 });
	while (s.size())
	{
		pair<pair<ll, ll>, int> c = *s.begin();
		s.erase(c);
		int v = c.Y;
		for (int i = 0; i < g[v].size(); ++i)
		{
			int u = g[v][i].X;
			ll x = a[u][g[v][i].Y].Y;
			for (int j = g[v][i].Y + 1; j < a[u].size(); ++j)
			{
				if (d[v].X + x < d[a[u][j].X].X || d[v].X + x == d[a[u][j].X].X && d[v].Y + x * x > d[a[u][j].X].Y)
				{
					s.erase({ d[a[u][j].X], a[u][j].X });
					d[a[u][j].X] = { d[v].X + x, d[v].Y + x * x };
					s.insert({ d[a[u][j].X], a[u][j].X });
				}
				x += a[u][j].Y;
			}
		}
	}
	cout << d[n].X << ' ' << d[n].Y;
}