#include <bits/stdc++.h>

using namespace std;

struct state {
    char c;
    int len;
    int ind;

    bool operator <(const state& arg) const {
        if (len != arg.len) return len < arg.len;
        return ind < arg.ind;
    }
};


void solve() {
    string s, t;
    cin >> s >> t;
    int n = s.length();
    vector<state> st;
    st.push_back(state{s[0], 1, 0});
    s += '#';
    for (int i = 1; i < s.size(); i++) {
        if (s[i] == s[i - 1]) {
            st[st.size() - 1].len++;
        } else {
            st.push_back(state{s[i], 1, i});
        }
    }
    st.pop_back();
    if (st.size() == 1 && s != t) {
        cout << "No\n";
        return;
    }
    while (st.size() > 1) {
        bool changed = false;
        vector<state> ns;
        for (int i = 0; i < st.size(); i++) {
            if (st[i].c == '-') {
                if (i == 0) {
                    if (st[i].len < st[i + 1].len) {
                        st[i].c = '+';
                        changed = true;
                    }
                } else if (i == n - 1) {
                    if (st[i].len < st[i - 1].len) {
                        st[i].c = '+';
                        changed = true;
                    }
                } else {
                    if (st[i].len < st[i + 1].len) {
                        st[i].c = '+';
                        changed = true;
                    }
                    if (st[i].len < st[i - 1].len) {
                        st[i].c = '+';
                        changed = true;
                    }
                }
            }
        }
        if (!changed) {
            break;
        } else {
            ns.clear();
            ns.push_back(st[0]);
            for (int i = 1; i < st.size(); i++) {
                if (st[i].c == ns.back().c) {
                    ns.back().len += st[i].len;
                } else {
                    ns.push_back(st[i]);
                }
            }
            st = ns;
        }
    }
    if (st.size() > 1) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int T;
    cin >> T;
    for (int i = 0; i < T; i++) {
        solve();
    }
}
