#include <bits/stdc++.h>

using namespace std;

pair<int, int> bits[30];
int n;

int get_b(int n, int number)
{
    return (n >> number) & 1;
}

void add(int a, int b)
{
    int j = 30;
    while (j >= 0 && get_b(a, j) == get_b(b, j))
        j--;
    if (j >= 0)
    {
        if (get_b(a, j) == 0)
            bits[j].first++;
        else
            bits[j].second++;
    }
}

void remove(int a, int b)
{
    int j = 30;
    while (j >= 0 && get_b(a, j) == get_b(b, j))
        j--;
    if (j >= 0)
    {
        if (get_b(a, j) == 0)
            bits[j].first--;
        else
            bits[j].second--;
    }
}

int count()
{
    if (n == 1)
        return 0;
    int res = 0;
    for (int i = 0; i < 30; i++)
    {
        if (bits[i].second > 0 && bits[i].first > 0)
            return -1;
        if (bits[i].second > 0)
            res += (1 << i);
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin >> n;
    vector<int> our(n);
    for (int i = 0; i < n; i++)
        cin >> our[i];
    for (int i = 0; i < n - 1; i++)
        add(our[i], our[i + 1]);
    cout << count() << "\n";
    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        if (a == 0)
        {
            remove(our[0], our[1]);
            add(b, our[1]);
        }
        else if (a == n - 1)
        {
            remove(our[n - 2], our[n - 1]);
            add(our[n - 2], b);
        } else
        {
            remove(our[a - 1], our[a]);
            remove(our[a], our[a + 1]);
            add(our[a - 1], b);
            add(b, our[a + 1]);
        }
        our[a] = b;
        cout << count() << "\n";
    }
}