#include <bits/stdc++.h>

using namespace std;

#define f first
#define s second

int n, m;
long long cost = 1e9;
vector<pair<int, int> > a;
vector<int> c;

void solve1()
{
    int l = a[0].f, r = a[0].s;
    vector<pair<int, bool> > dp(m + 1, {0, true});
    for (int i = m - r + 1; i <= m; ++i){
        dp[i].s = false;
    }
    for (int i = 1; i <= m; ++i){
        for (int j = i - l; j >= max(i - r, 0); --j){
            if (!dp[j].s){
                continue;
            }
            dp[i].f = max(dp[i].f, dp[j].f + 1);
        }
    }
    long long min_prof = 1e18;
    for (int i = m - r + 1; i <= m; ++i){
        min_prof = min(min_prof, i * cost - c[0] * dp[i].f);
    }
    cout << min_prof;
}

void solve2()
{
    vector<long long> value(n);
    for (int i = 0; i < n; ++i){
        value[i] = cost * a[i].f - c[i];
    }
    vector<long long> dp(m + 1, 0);
    for (int i = 1; i <= m; ++i){
        for (int j = 0; j < n; ++j){
            if (a[j].f > i){
                continue;
            }
            dp[i] = max(dp[i], dp[i - a[j].f] + value[j]);
        }
    }
    cout << *max_element(dp.begin(), dp.end());
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin >> n >> m;
    a.resize(n);
    c.resize(n);
    bool l_is_r = true;
    for (int i = 0; i < n; ++i){
        cin >> a[i].f >> a[i].s >> c[i];
        if (a[i].f != a[i].s){
            l_is_r = false;
        }
    }
    if (n == 1){
        solve1();
    }
    if (l_is_r){
        solve2();
    }
    return 0;
}
