#include <bits/stdc++.h>
using namespace std;

struct segtree{
    segtree *l = 0, *r = 0;
    int lb, rb, t, s = 0;
    segtree(int _lb, int _rb){
        lb = _lb, rb = _rb;
        t = (lb+rb)/2;
    }
    void check(){
        if(lb != rb && !l){
            l = new segtree(lb, t);
            r = new segtree(t+1, rb);
        }
    }
    void add(int k, int x){
        check();
        s += x;
        if(lb != rb){
            if(k <= t) l->add(k, x);
            else r->add(k, x);
        }
    }
    int sum(int lq, int rq){
		if(lq <= rb && rb <= rq) return s;
		if(lb <= rq && lq <= rb) return l->sum(lq, rq) + r->sum(lq, rq);
		return 0;
	}
};

const int lim = 1e9;

int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);

    if(sizeof(segtree*) == 4) cout << "grisha-pipsha";

    segtree p(0, lim);

    int useless = 12312;

    for(int i = 0; i < 500000; i++){
        p.add(rand()%lim, rand()%10);
		useless += p.sum(0, 0);
	}

    cerr << useless;

    int a, b;
    cin >> a >> b;

    cout << a+b;

    return 0;
}
