#include <bits/stdc++.h>
#define ll long long

using namespace std;

struct segm_set
{
    int l, r;
    ll sum;
};

bool operator < (const segm_set &a, const segm_set &b)
{
    return a.l < b.l;
}

struct super
{
    int l, r;
    ll sum;
};

bool operator < (const super &a, const super &b)
{
    if (a.sum != b.sum)
    {
        return a.sum > b.sum;
    }
    else
    {
        return a.l < b.l;
    }
}

const int N = 1e6 + 7;

vector <int> pos[N];


int main()
{
    ios::sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    vector <int> a(n), x(n), b(m), y(m);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++)
    {
        cin >> x[i];
    }
    for (int i = 0; i < m; i++)
    {
        cin >> b[i];
    }
    for (int i = 0; i < m; i++)
    {
        cin >> y[i];
    }
    for (int i = 0; i < m; i++)
    {
        pos[b[i]].push_back(i);
    }
    vector <ll> pref(m);
    ll sum = 0;
    for (int i = 0; i < m; i++)
    {
        sum += y[i];
        pref[i] = sum;
    }
    ll sa = 0;
    for (int i = 0; i < n; i++)
    {
        sa += x[i];
    }
    ll ans = sa;
    int la = 0, ra = n - 1;
    int lb = -1, rb = -1;
    ll sb = 0;
    for (int i = 0; i < m; i++)
    {
        sb += y[i];
    }
    if (sb > ans)
    {
        ans = sb;
        la = -1, ra = -1;
        lb = 0, rb = m - 1;
    }
    int lim = n;
    for (int i = 0; i < n; i++)
    {
        set <segm_set> s;
        set <super> q;
        s.insert({0, m - 1, sum});
        q.insert({0, m - 1, sum});
        ll kok = 0;
        for (int j = i; j < lim; j++)
        {
            kok += x[j];
            if (j == lim - 1)
            for (auto c : pos[a[j]])
            {
                auto it = s.upper_bound({c, (int) 1e9, (int) 1e9});
                if (it == s.begin())
                {
                    continue;
                }
                it--;
                if (it->r < c)
                {
                    continue;
                }
                int l = it->l, r = it->r;
                q.erase({it->l, it->r, it->sum});
                s.erase(it);
                if (l != c)
                {
                    ll kek = (pref[c - 1] - (l ? pref[l - 1] : 0));
                    s.insert({l, c - 1, kek});
                    q.insert({l, c - 1, kek});
                }
                if (r != c)
                {
                    ll kek = (pref[r] - pref[c]);
                    s.insert({c + 1, r, kek});
                    q.insert({c + 1, r, kek});
                }
            }
            if (q.size() > 0)
            {
                if (kok + q.begin()->sum > ans)
                {
                    ans = kok + q.begin()->sum;
                    la = i, ra = j;
                    lb = q.begin()->l;
                    rb = q.begin()->r;
                }
            }
        }
        for (int k = lim; k < n; k++)
        {
            if (a[k] == a[i])
            {
                lim = k;
                break;
            }
        }
    }
    cout << ans << '\n';
    cout << la + 1 << ' ' << ra + 1 << '\n';
    cout << lb + 1 << ' ' << rb + 1 << '\n';
}
