#include <iostream>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <climits>
#include <vector>
#include <functional>

using namespace std;

typedef unsigned int index;

int take(index, index, int **, size_t*);

void rcnt(index i, index j, int **d, size_t *go)
{
	d[i][j] = min(take(i, j - 1, d, go), take(i + (1 << (j - 1)), j - 1, d, go));
	go[i] = j + 1;
}

int take(index i, index j, int **d, size_t *go)
{
	if (j >= go[i])
	{
		rcnt(i, j, d, go);
	}
 	return d[i][j];
}

int get(index l, size_t r, int **d, size_t *go, index *pws)
{
	return min(take(l, pws[r - l], d, go), take((index)r - (1 << pws[r - l]), pws[r - l], d, go));
}

int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
	assert(freopen("anti.in", "r", stdin));
	assert(freopen("anti.out", "w", stdout));
#endif
	ios::sync_with_stdio(false);
	size_t n, a;
	cin >> n >> a;
	vector<pair<pair<size_t, size_t>, int>> dos(n);
	for (auto &i: dos)
	{
		cin >> i.first.first >> i.first.second >> i.second;
	}
	int **d = new int*[a + 1];
	size_t *go = new size_t[a + 1];
	index *pws = new index[a + 1];
	for (index i = 0; i <= a; i++)
	{
		pws[i] = -1;
		d[i] = new int[23];
		go[i] = 1;
	}
	pws[1] = 0;
	for (index i = 1; i <= a; i++)
	{
		if (pws[i] != (index)-1)
		{
			if (2 * i <= a)
				pws[2 * i] = pws[i] + 1;
		}
		else
		{
			pws[i] = pws[i - 1];
		}
	}
	d[a][0] = (int)a;
	for (index i = (index)a - 1; i != (index)-1; i--)
	{
		d[i][0] = (int)i;
		for (index j = 0; j < n; j++)
		{
			if (i + dos[j].first.second <= a)
			{
				d[i][0] = max(d[i][0], get(i + (index)dos[j].first.first, i + dos[j].first.second + 1, d, go, pws));
			}
		}
	}
	for (index i = 0; i <= a; i++)
	{
		go[i] = 1;
	}
	int sv = d[0][0];
	for (index i = 0; i <= a; i++)
	{
		if (d[i][0] > sv)
		{
			d[i][0] = 1000000000;
		}
		else
		{
			d[i][0] = -1000000000;
		}
	}
	d[sv][0] = 0;
	for (index i = (index)a - 1; i != (index)-1; i--)
	{
		for (index j = 0; j < n; j++)
		{
			if (i + dos[j].first.second <= a)
			{
				d[i][0] = max(d[i][0], get(i + (index)dos[j].first.first, i + dos[j].first.second + 1, d, go, pws) - dos[j].second);
			}
		}
	}

	cout << sv * (long long)1e9 + d[0][0] << endl;
}
