#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <string>
#include <stack>
using namespace std;

const int maxn = 1000005;
bool ism[maxn] = {0};
int dl[maxn] = {0};
int nex[maxn] = {0};
int pred[maxn] = {0};
char polog[maxn] = {0};
stack<int> men;

bool obied(int v,int yk)
{
    if(nex[v] > yk || nex[v] < 0 || nex[nex[v]] < 0)
        return false;
    if(ism[v] == ism[nex[v]])
        return false;
    if(ism[v] && dl[v] < dl[nex[v]])
        return true;
    if(!ism[v] && dl[v] > dl[nex[v]])
        return true;
    return false;
}

void obrpos(int yk)
{
    int v = men.top();
    men.pop();
    //cout << v << ' ';
    if(!obied(v,yk))
        return;
    if(ism[v])
    {
        polog[v] = polog[nex[v]];
        ism[v] = false;
        dl[v] += dl[nex[v]];
        if(pred[v] >= 0 && nex[pred[v]] == v)
        {
            dl[v] += dl[pred[v]];
            int p = pred[v];
            pred[v] = pred[pred[v]];
            nex[p] = -1;
        }
        int n = nex[v];
        nex[v] = nex[nex[v]];
        nex[n] = -1;
        if(nex[v] <= yk)
            pred[nex[v]] = v;
        if(pred[v] >= 0)
            nex[pred[v]] = v;
    }
    else
    {
        v = nex[v];
        polog[v] = polog[pred[v]];
        ism[v] = false;
        dl[v] += dl[pred[v]];
        if(nex[v] <= yk)
        {
            dl[v] += dl[nex[v]];
            int n = nex[v];
            nex[v] = nex[nex[v]];
            nex[n] = -1;
        }
        int p = pred[v];
        pred[v] = pred[pred[v]];
        nex[p] = -1;
        if(nex[v] <= yk)
            pred[nex[v]] = v;
        if(pred[v] >= 0)
            nex[pred[v]] = v;
    }
    if(obied(v,yk))
        men.push(v);
    if(pred[v] >= 0 && obied(pred[v],yk))
        men.push(pred[v]);
}
int main()
{
    freopen("storage.in","r",stdin);
    freopen("storage.out","w",stdout);
    int n;
    cin >> n;
    for(int i = 0; i < n; ++i)
    {
        string s;
        string t;
        cin >> s >> t;
        int yk = 0;
        for(int i1 = 0; i1 < s.size();++i1)
        {
            if(i1 == 0)
            {
                polog[yk] = s[i1];
                dl[yk] = 1;
                nex[yk] = yk+1;
                pred[yk] = yk-1;
            }
            else
            {
                if(s[i1] != s[i1-1])
                    ++yk;
                polog[yk] = s[i1];
                nex[yk] = yk+1;
                pred[yk] = yk-1;
                dl[yk]++;
            }
        }
        bool good = true;
        int yk2 = 0;
        for(int i1 = 0; i1 <= yk; ++i1)
        {
            ism[i1] = (s[yk2] != t[yk2]);
            for(int i2 = 1; i2 < dl[i1]; ++i2)
                if(ism[i1] != (s[yk2+i2] != t[yk2+i2]))
                    good = false;
            yk2+=dl[i1];
        }
        if(!good)
            printf("No\n");
        else
        {
            for(int i1 = 0; i1 <= yk; ++i1)
                if(obied(i1,yk))
                    men.push(i1);
            while(!men.empty())
            {
                obrpos(yk);
            }
            for(int i1 = 0; i1 <= yk; ++i1)
                if(ism[i1])
                    good = false;
            if(good)
                printf("Yes\n");
            else
                printf("No\n");
        }
        for(int i1 = 0; i1 <= yk; ++i1)
            dl[i1] = 0;
    }
    return 0;
}
