#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cstdio>
#include <utility>
#include <algorithm>
#define ll long long
#define pii pair<ll, ll>
using namespace std;
int n, a;
vector<pii> c;
vector<ll> p;

struct tree {
	vector<ll> dp;
	tree(int n) {
		dp.resize(n, 0);
	}
	ll get(int i) {
		return dp[i];
	}
	ll upd(int l, int r, ll newe) {
		for (int i = l; i < r; i++) {
			dp[i] = max(dp[i], newe);
		}
	}
};
ll price = int(1e9);
int main() {
	cout.precision(30);
	//freopen("test.in", "r", stdin);
	//freopen("test.out", "w", stdout);
	cin >> n;
	cin >> a;
	c.resize(n);
	p.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> c[i].first >> c[i].second >> p[i];
	}
	
	//tree dp(a + 1);
	vector<ll> dp(a + 1, 0);
	dp[0] = 0;
	for (int i = a; i > -1; i--) {
		for (int j = 0; j < n; j++) {
			int l = c[j].first, r = c[j].second;
			if (i + r > a) continue;
			ll tmp = price * price;
			for (int plus = l; plus <= r; plus++) {
				tmp = min(tmp, dp[i + plus] + price * plus - p[j]);
			}
			dp[i] = max(dp[i], tmp);
		}
	}
	cout << dp[0];
	return 0; 
}