#include <iostream>
#include <vector>

using namespace std;

bool isSorted(vector<short>& numbers) {
    for(short c = 0; c < numbers.size() - 1; c++) {
        if(numbers[c] > numbers[c + 1]) return false;
    }
    return true;
}
void allXor(vector<short>& numbers, short value) {
    for(short c = 0; c < numbers.size(); c++) {
        numbers[c] ^= value;
    }
}
void proc(vector<short>& numbers) {
    for(short result = 0; result < 1024; result++) {
        vector<short> cp = numbers;
        allXor(cp, result);
        if(isSorted(cp)) {
            cout << result << endl;
            return;
        }
    }
    cout << -1 << endl;
}
int main() {
    short n;
    cin >> n;
    vector<short> nums(n);
    for(short c = 0; c < n; c++) {
        cin >> nums[c];
    }
    proc(nums);
    short count, index, value;
    cin >> count;
    for(short c = 0; c < n; c++) {
        cin >> index >> value;
        nums[index - 1] = value;
        proc(nums);
    }
}
