#include <iostream>
#include <vector>
#include <string>
#include <fstream>

using namespace std;

typedef long long ll;

struct edge
{
	int v, color, time;
};

const int N = 20000;
vector<edge> g[N];
int d[N], p[N], pr[N], used[N];
vector<int> way[N];

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int n, m;
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; i++)
	{
		int k, l, r, t;
		scanf("%d%d", &k, &l);
		for (int j = 0; j < k; j++)
		{
			scanf("%d%d", &t, &r);
			edge u;
			u.v = r;
			u.color = i + 1;
			u.time = t;
			g[l].push_back(u);
			l = r;
		}
	}
	way[1].push_back(-1);
	for (int i = 2; i <= n; i++)
		d[i] = LONG_MAX;
	for (int q = 1; q <= n; q++)
	{
		int ind = -1, min = LONG_MAX;
		for (int j = 1; j <= n; j++)
			if (!used[j] && d[j] < min)
			{
				min = d[j];
				ind = j;
			}
		used[ind] = 1;
		if (ind == -1)
			break;
		for (int j = 0; j < g[ind].size(); j++)
		{
			int u = g[ind][j].v, w = g[ind][j].time, e = g[ind][j].color;
			if (d[u] >= d[ind] + w)
			{
				d[u] = d[ind] + w;
				way[u].clear();
				way[u].push_back(e);
				bool f = false;
				for (int k = 0; k < way[ind].size(); k++)
					if (way[ind][k] == -1 || way[ind][k] == e)
					{
						f = true;
						break;
					}
				if (!f)
				{
					p[u] = p[ind] + w * w;
					pr[u] = p[ind];
				}
				else
				{
					int r = (int)sqrt(p[ind] - pr[ind]);
					p[u] = pr[ind] + (r + w) * (r + w);
					pr[u] = pr[ind];
				}
			}
		}
	}
	printf("%d %d", d[n], p[n]);
	return 0;
}