#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const ll maxn = 200101;
const ll inf = numeric_limits<ll>::max() / 2 - 100;
const ll nn = 1e9;
const ll K = 300;
ll n, a;

struct node {
    ll val;
    node *l, *r;

    node() {
        val = 0;
        l = nullptr;
        r = nullptr;
    }
};

node *root = nullptr;

inline ll gett(node *v) {
    if (v == nullptr) return 0;
    return v->val;
}

ll addpos, addval;

void add(node *&v, int vl, int vr) {
    if (v == nullptr) v = new node();
    if (vl + 1 == vr) {
        v->val = addval;
        return;
    }
    int mid = (vl + vr) >> 1;
    if (mid > addpos) add(v->l, vl, mid);
    else add(v->r, mid, vr);
    v->val = min(gett(v->l), gett(v->r) + nn * (mid - vl));
}

ll getl, getr;

ll getmin(node *v, int vl, int vr) {
    if (vl >= getl && vr <= getr)
        return gett(v);
    if (vl >= getr || vr <= getl)
        return inf;
    if (v == nullptr) v = new node();
    int mid = (vl + vr) >> 1;
    ll m1 = getmin(v->l, vl, mid);
    ll m2 = getmin(v->r, mid, vr);
    return min(m1, m2 + nn * (mid - vl));
}

struct exper {
    ll l, r, c;

    exper() {}
};

struct myqueue {
    vector<pair<ll, ll>> st[2];
    ll mydesc = 0;
    ll mysz = 0;

    void push(ll val, bool f) {
        if (st[f].empty()) st[f].push_back({val - (!f) * mydesc * nn, val - (!f) * mydesc * nn});
        else st[f].push_back({val - (!f) * mydesc * nn, min(st[f].back().second, val - (!f) * mydesc * nn)});
        if (!f)
            mydesc++, mysz++;
    }

    ll getmin() {
        ll ans = inf;
        if (!st[0].empty()) ans = st[0].back().second;
        if (!st[1].empty()) ans = min(ans, st[1].back().second);
        if (ans == inf) return 0;
        return ans + mydesc * nn;
    }

    void pop() {
        if (st[1].empty()) {
            while (!st[0].empty()) {
                ll val = st[0].back().first;
                st[0].pop_back();
                push(val, 1);
            }
        }
        st[1].pop_back();
        mysz--;
    }
};

vector<exper> vec;
vector<myqueue> exvec;
ll minans[maxn];

int run() {
    for (int i = 0; i < maxn; ++i) {
        minans[i] = -1;
    }
    cin >> n >> a;
    a++;
    vec.resize(n);
    exvec.resize(n);
    for (int i = 0; i < n; ++i) {
        exvec[i].st[0].reserve(vec[i].r - vec[i].l + 2);
        exvec[i].st[1].reserve(vec[i].r - vec[i].l + 2);
    }
    for (int i = 0; i < n; ++i) {
        cin >> vec[i].l >> vec[i].r >> vec[i].c;
    }
    for (int v = a - 1; v >= 0; v--) {
        for (int i = 0; i < n; ++i) {
            if (vec[i].r - vec[i].l <= K) {
                if (v + vec[i].r + 1 < a) {
                    exvec[i].pop();
                }
                if (v + vec[i].l < a)
                    exvec[i].push(minans[v + vec[i].l], 0);
            }
        }
        ll ans = 0;
        for (int i = 0; i < n; ++i) {
            if (vec[i].r - vec[i].l <= K) {
                if (v + vec[i].r < a) {
                    ll newans = 0;
                    ll myadd = (vec[i].l - 1) * nn;
                    newans = exvec[i].getmin() + myadd;
                    newans -= vec[i].c;
                    ans = max(ans, newans);
                }
            } else {
                if (v + vec[i].r < a) {
                    ll newans = 0;
                    ll myadd = -v * nn;
                    getl = v + vec[i].l;
                    getr = v + vec[i].r + 1;
                    newans = getmin(root, 0, a) + myadd;
                    newans -= vec[i].c;
                    ans = max(ans, newans);
                }
            }
        }
        minans[v] = ans;
        addpos = v;
        addval = ans;
        add(root, 0, a);
        //cerr << v << " " << ans << endl;
        if (v == 0) {
            cout << ans;
        }
    }
    return 0;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    run();
    return 0;
}