#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <stack>
#include <set>
#include <queue>

using namespace std;

const int MX = 4;
set< pair<int, int> > s;
int b;
vector<int> change(MX + 1, 1);
int lvl = 0;

struct vert {
	int l, r, sz, push;
};

vector<vert> arr;
int cnt = 1;

bool add(int is, int val, int pos, int numb) {
	if (val == 0) {
		arr[pos].sz++;
		return 1;
	}
	lvl++;
	if ((arr[pos].push & val) ^ (b & val)) {
		swap(arr[pos].l, arr[pos].r);
		arr[pos].push ^= val;
	}
	if (arr[pos].r == -1) {
		arr.push_back({ -1, -1, 0, b });
		arr[pos].r = cnt++;
	}
	if (arr[pos].l == -1) {
		arr.push_back({ -1, -1, 0, b });
		arr[pos].l = cnt++;
	}

	int l = arr[pos].l, r = arr[pos].r;
	bool ans = 0;
	bool ok = 0;
	if (arr[arr[pos].r].sz == 0 || arr[arr[pos].l].sz == 0) {
		ok = 1;
	}
	if (is & val) {
		if (arr[l].sz <= numb) {
			if (add(is, val >> 1, arr[pos].r, numb - arr[l].sz)) {
				arr[pos].sz++;
				ans = 1;
			}

		}
		else {
			if (numb == 0 && change[lvl] == (1 << lvl)) {
				swap(arr[pos].r, arr[pos].l);
				b ^= val;
				is ^= val;
				arr[pos].push ^= val;
				if (add(is, val >> 1, arr[pos].l, numb - arr[r].sz)) {
					arr[pos].sz++;
					ans = 1;
				}
				else {
					swap(arr[pos].r, arr[pos].l);
					b ^= val;
					is ^= val;
					arr[pos].push ^= val;

				}
			}


		}

	}
	else {
		if (arr[l].sz >= numb) {
			if (add(is, val >> 1, arr[pos].l, numb)) {
				arr[pos].sz++;
				ans = 1;
			}

		}
		else {
			if (numb == arr[r].sz && change[lvl] == 1 << lvl) {
				swap(arr[pos].r, arr[pos].l);
				b ^= val;
				is ^= val;
				arr[pos].push ^= val;
				if (add(is, val >> 1, arr[pos].r, 0)) {
					arr[pos].sz++;
					ans = 1;
				}
				else {
					swap(arr[pos].r, arr[pos].l);
					b ^= val;
					is ^= val;
					arr[pos].push ^= val;

				}
			}

		}
	}

	if (ok && !(arr[arr[pos].r].sz == 0 || arr[arr[pos].r].sz == 0)) {
		change[lvl]--;
	}
	lvl--;
	return ans;

}

void get_out(int is, int val, int pos) {
	if (val == 0) {
		arr[pos].sz--;
		return;
	}
	lvl++;
	if (arr[pos].r == -1) {
		arr.push_back({ -1, -1, 0, b });
		arr[pos].r = cnt++;
	}
	if (arr[pos].l == -1) {
		arr.push_back({ -1, -1, 0, b });
		arr[pos].l = cnt++;
	}
	if (arr[arr[pos].r].sz == 0 || arr[arr[pos].l].sz == 0) {
		change[lvl]--;
	}
	if ((arr[pos].push & val) ^ (b & val)) {
		swap(arr[pos].l, arr[pos].r);
		arr[pos].push ^= val;
	}
	if (is & val) {
		get_out(is, val >> 1, arr[pos].r);
	}
	else {
		get_out(is, val >> 1, arr[pos].l);
	}
	arr[pos].sz--;
	if (arr[arr[pos].r].sz == 0 || arr[arr[pos].l].sz == 0) {
		change[lvl]++;
	}
	lvl--;

	return;
}

int main() {
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	int val = 1 << (MX - 1);
	arr.push_back({ -1, -1, 0, 0 });
	for (int i = 0; i < n; i++) {
		lvl = 0;
		if (!add(a[i] ^ b, 1 << (MX - 1), 0, i)) {
			s.insert({ i, a[i] });
		}
	}
	for (int i = 0; i <= MX; i++)
		change[i] = 1 << i;
	val = 1 << (MX - 1);
	for (int i = 0; i < MX; i++) {
		if ((b & val) && (change[i] == (1 << lvl)))
			b ^= val;
		val >>= 1;
	}
	if (s.empty())
		cout << b << '\n';
	else
		cout << -1 << '\n';

	int q;
	cin >> q;
	while (q--) {
		int pos, is;
		cin >> pos >> is; pos--;
		if (s.find({ pos, a[pos] }) == s.end()) {
			lvl = 0;
			get_out(a[pos] ^ b, 1 << (MX - 1), 0);
		}
		else
			s.erase({ pos, a[pos] });
		a[pos] = is;
		s.insert({ pos, a[pos] });
		while (!s.empty()) {
			auto j = s.begin();
			pair<int, int> v = (*j);
			s.erase(j);
			lvl = 0;
			if (!add(v.second ^ b, 1 << (MX - 1), 0, v.first)) {
				s.insert(v);
				break;
			}
		}
		for (int i = 0; i < MX; i++) {
			if ((b & val) && (change[i] == (1 << lvl)))
				b ^= val;
			val >>= 1;
		}
		if (s.empty())
			cout << b << '\n';
		else
			cout << -1 << '\n';
	}
	return 0;
}