#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <set>
#include <string>
#include <map>
#include <iomanip>
#include <cmath>

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	freopen("sum.in", "r", stdin);
	freopen("sum.out", "w", stdout);
	string a, b;
	cin >> a >> b;
	bool is1 = 0, is2 = 0;
	if (a[0] == '-') { is1 = 1; a.erase(a.begin()); }
	if (b[0] == '-') { is2 = 1; b.erase(b.begin()); }
	if (a.length() > b.length() || (a.length() == b.length() && a >= b)) { swap(a, b); swap(is1, is2); };
	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());
	if (is2) {
		if (!is1 && a == b) {
			cout << 0;
			return 0;
		}
		cout << '-';
		is2 ^= 1;
		is1 ^= 1;
	}
	for (int i = 0; i < a.length(); i++) {
		if (!is1)
			b[i] += a[i] - '0';
		else
			b[i] -= a[i] - '0';
	}
	b += '0';
	for (int j = 0; j < b.length(); j++) {
		for (int i = b.length() - 1; i >= 0; i--) {
			if (b[i] < '0') {
				b[i + 1]--;
				b[i] += 10;
			}
			if (b[i] > '9') {
				b[i + 1]++;
				b[i] -= 10;
			}
		}
	}
	while (b.back() == '0') b.pop_back();
	for (int i = b.length() - 1; i >= 0; i--) {
		cout << b[i];
	}
	return 0;
}