#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <set>
#include <string>
#include <map>
#include <iomanip>
#include <cmath>
#include <ctime>

using namespace std;

const int MX = 1e6;
long long t[4 * MX];
int arr[MX];

void build(int v, int tl, int tr) {
	if (tl == tr)
		t[v] = arr[tl];
	int tm = (tl + tr) >> 1;
	build(v << 1, tl, tm);
	build((v << 1) | 1, tm + 1, tr);
	t[v] = t[2 * v] + t[2 * v + 1];
	return;
}	

long long get(int v, int tl, int tr, int l, int r) {
	if (l > r)
		return 0;
	if (tl == l && r == tr)
		return t[v];
	int tm = (tl + tr) >> 1;
	return get(v << 1, tl, tm, l, min(r, tm)) + get((v << 1) | 1, tm + 1, tr, max(l, tm + 1), r);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	freopen("sequence.in", "r", stdin);
	freopen("sequence.out", "w", stdout);
	srand(time(NULL));
	for (int i = 0; i < MX; i++) {
		arr[i] = rand();
	}
	build(1, 0, MX - 1);
	long long a;
	stack<long long> s;
	while (cin >> a)
		s.push(a);
	while (!s.empty()) { cout << s.top(); s.pop(); };
	for (int q = 0; q < MX; q++) {
		int l = rand() % MX;
		int r = rand() % MX;
		if (l > r)
			swap(l, r);
		int res = get(1, 0, MX - 1, l, r);
	}
	//string a, b;
	//cin >> a >> b;
	//bool is1 = 0, is2 = 0;
	//if (a[0] == '-') { is1 = 1; a.erase(a.begin()); }
	//if (b[0] == '-') { is2 = 1; b.erase(b.begin()); }
	//if (a.length() > b.length() || (a.length() == b.length() && a >= b)) { swap(a, b); swap(is1, is2); };
	//reverse(a.begin(), a.end());
	//reverse(b.begin(), b.end());
	//if (is2) {
	//	if (!is1 && a == b) {
	//		cout << 0;
	//		return 0;
	//	}
	//	cout << '-';
	//	is2 ^= 1;
	//	is1 ^= 1;
	//}
	//for (int i = 0; i < a.length(); i++) {
	//	if (!is1)
	//		b[i] += a[i] - '0';
	//	else
	//		b[i] -= a[i] - '0';
	//}
	//b += '0';
	//for (int j = 0; j < b.length(); j++) {
	//	for (int i = b.length() - 1; i >= 0; i--) {
	//		if (b[i] < '0') {
	//			b[i + 1]--;
	//			b[i] += 10;
	//		}
	//		if (b[i] > '9') {
	//			b[i + 1]++;
	//			b[i] -= 10;
	//		}
	//	}
	//}
	//while (b.back() == '0') b.pop_back();
	//for (int i = b.length() - 1; i >= 0; i--) {
	//	cout << b[i];
	//}
	return 0;
}