#include <iostream>
#include <vector>


using namespace std;


const int INF = 1e9 + 7;


int main()
{
	int n;
	cin >> n;
	int w;
	cin >> w;
	vector<int> cost(w + 1, INF);
	cost[0] = 0;
	for (int j = 0; j < n; j++)
	{
		int l, r, c;
		cin >> l >> r >> c;
		for (int i = 0; i < w; i++)
		{
			cost[i + l] = min(cost[i + l], cost[i] + c);
		}
	}
	long long ans = 0;
	long long C = 1e9;
	for (int i = 0; i < w; i++)
	{
		if (cost[i] != INF)
		{
			ans = max(ans, C * i - cost[i]);
		}
	}
	cout << ans << endl;
}