#include <stdio.h>
#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define fi first
#define se second
#define sz(a) (int)a.size()
#define mp(a, b) make_pair(a, b)

using namespace std;

const int inf = (int)1e9;
const ll oo = (ll)1e18 + 1;

int main()
{
    //freopen("a.in", "r", stdin);
    int n, m;
    scanf("%d %d", &n, &m);
    int a[n], x[n], b[m], y[m];
    rep(i, 0, n)
        scanf("%d", &a[i]);
    rep(i, 0, n)
        scanf("%d", &x[i]);
    rep(i, 0, m)
        scanf("%d", &b[i]);
    rep(i, 0, m)
        scanf("%d", &y[i]);
    ll pref[m + 1];
    pref[0] = 0;
    rep(i, 0, m)
        pref[i + 1] = pref[i] + y[i];
    bool used[n + m + 1];
    vector<int> pos[n + m + 1];
    rep(i, 0, m)
        pos[b[i]].push_back(i);
    set<pair<int, int> > interval;
    map<ll, set<pair<int, int> > > best;
    ll ans = 0;
    int l1 = 0, r1 = 0, l2 = 0, r2 = 0;
    if (pref[m] > ans)
    {
        ans = pref[m];
        l2 = 1; r2 = m;
    }
    rep(i, 0, n)
    {
        fill(used, used + n + m + 1, false);
        interval.clear();
        interval.insert(mp(0, m - 1));
        best.clear();
        best[pref[m] - pref[0]].insert(mp(0, m - 1));
        ll cost = 0;
        rep(j, i, n)
        {
            cost += x[j];
            if (!used[a[j]])
            {
                used[a[j]] = true;
                for (int x : pos[a[j]])
                {
                    auto it = --interval.upper_bound(mp(x, inf));
                    int l = (*it).fi, r = (*it).se;
                    interval.erase(it);
                    best[pref[r + 1] - pref[l]].erase(mp(l, r));
                    if (sz(best[pref[r + 1] - pref[l]]) == 0)
                        best.erase(pref[r + 1] - pref[l]);
                    if (l < x)
                    {
                        interval.insert(mp(l, x - 1));
                        best[pref[x] - pref[l]].insert(mp(l, x - 1));
                    }
                    if (r > x)
                    {
                        interval.insert(mp(x + 1, r));
                        best[pref[r + 1] - pref[x + 1]].insert(mp(x + 1, r));
                    }
                }
            }
            if (sz(best) == 0)
            {
                if (cost > ans)
                {
                    ans = cost;
                    l1 = i + 1; r1 = j + 1;
                    l2 = 0; r2 = 0;
                }
            }
            else
            {
                auto it = --best.end();
                if (cost + it->fi > ans)
                {
                    ans = cost + it->fi;
                    l1 = i + 1; r1 = j + 1;
                    l2 = (*(it->se.begin())).fi + 1; r2 = (*(it->se.begin())).se + 1;
                }
            }
        }
    }
    printf("%lld\n%d %d\n%d %d\n", ans, l1, r1, l2, r2);
    return 0;
}
