#include <iostream>
#include <stack>
#include <vector>
#include <string>
#include <cmath>
#include <stdlib.h>
#include <algorithm>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> llp;
typedef long double ld;

long double pi = 0;

vector<llp> v;
ll n;
vector<ll> ob;

bool isCl(llp p1, llp p2, llp p3) {
	return p1.first * p2.second - p2.first * p1.second + p2.first * p3.second - p3.first * p2.second + p3.first * p1.second - p1.first * p3.second < 0;
}

void find() {
	for (ll st = 0; st < n; st++) {
		vector<pair<ld, ll>> sr;
		for (ll i = st + 1; i < n; i++) {
			sr.push_back({ atan2(v[i].second - v[st].second, v[i].first - v[st].first) , i });
		}

		sort(sr.begin(), sr.end());

		for (ll i = 0; i < sr.size() - 1; i++) {
			cout << "? 3 " << st + 1 << " " << sr[i].second + 1 << " " << sr[i + 1].second + 1 << endl;

			string an;
			cin >> an;
			if (an == "Yes") {
				cout << "! 3 " << st + 1 << " " << sr[i].second + 1 << " " << sr[i + 1].second + 1 << endl;
				return;
			}
		}
	}
}

int main() {
	pi = acos(-1);

	cin >> n;

	v.resize(n);
	for (ll i = 0; i < n; i++) {
		cin >> v[i].first >> v[i].second;
	}


	ll q;
	cin >> q;
	for (ll i = 0; i < q; i++) {
		find();
	}

	return 0;
}