#include <iostream>
#include <vector>

using namespace std;

inline bool check(int l, int r)
{
    cout << "? " << l + 1 << ' ' << r + 1 << endl;
    string res;
    cin >> res;
    return res == "Yes";
}

int n, l, r, now = -1;
vector <int> ans, open;

int main()
{
    cin >> n;
    ans.resize(n, 0);
    l = 1, r = n - 2;
    ans[0] = -1;
    ans[n - 1] = 1;
    open.push_back(0);

    while (l <= r)
    {
        if (now == 0)
        {
            ans[l] = -1;
            open.push_back(l);
            now--;
            l++;
        }
        else
        {
            int ob = open.back();
            if (check(ob, l))
            {
                open.pop_back();
                now++;
                ans[l] = 1;
                l++;
            }
            else
            {
                open.push_back(l);
                now--;
                ans[l] = -1;
                l++;
            }
        }
    }

    cout << "! ";
    for (int i = 0; i < n; i++)
        if (ans[i] == -1)
            cout << '(';
        else
            cout << ')';
    cout << endl;
    return 0;
}
