#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;

struct ex
{
    long long l, r;
    long long c;
};

long long n, a, ans = 2e18;
vector <ex> v;
vector <vector <long long> > dp;

int main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr);

    cin >> n >> a;
    v.resize(n);
    dp.resize(a + 1, vector <long long>(n + 1, 2e18));
    for (int i = 0; i <= n; i++)
        dp[0][i] = 0;

    long long nmin = 2e18;
    for (long long i = 0; i < n; i++)
    {
        cin >> v[i].l >> v[i].r >> v[i].c;
        nmin = min(nmin, v[i].r);
    }

    for (long long i = 1; i <= a; i++)
    {
        long long best = 0;
        for (long long j = 0; j < n; j++)
        {
            for (long long k = max((long long)0, i - v[j].r); k <= i - v[j].l; k++)
            {
                //cout << dp[k][n] + (long long)1e9 * (i - k) - v[j].c << endl;
                dp[i][j] = min(dp[i][j], dp[k][n] + (long long)1e9 * (i - k) - v[j].c);
            }
            if (dp[i][j] < 2e18)
                best = max(best, dp[i][j]);
        }
        if (best != 0)
            dp[i][n] = best;
    }

    //for (int i = 0; i <= a; i++)
    //    cout << dp[i][n] << endl;

    for (long long i = a; i > a - nmin; i--)
        ans = min(ans, dp[i][n]);

    if (ans < 2e18)
        cout << ans;
    else
        cout << 0;
    return 0;
}

/*

1 17
4 6 10

2 11
2 2 100
3 5 5

*/
