#include <bits/stdc++.h>

using namespace std;

const long long FST = 29;
const long long MAXN = (long long)1.1e6;

struct pii
{
    long long first, second;
    pii()
    {
        first = 0;
        second = 0;
    }
    pii(long long f, long long s)
    {
        first = f;
        second = s;
    }
};

long long sup[50][2], a[MAXN], n, b = 0, err = 0;
pii need[MAXN];

pii getdiff(long long a, long long b)
{
    long long l = -1, r = FST + 1;
    long long orx = a ^ b;
    while (r - l > 1)
    {
        long long m = (l + r) >> 1;
        if ((orx >> m) > 0) l = m;
        else r = m;
    }
    if (r == 0) return pii(-1, -1);
    else return pii(l, a > b);
}

void refresh(pii war, bool in)
{
    //cout << war.first << ' ' << war.second << ' ' << in << endl;
    if (war.first + 1)
        {
            long long f = war.first, d2 = 1 << f;
            err -= sup[f][0] && sup[f][1];
            if (b & d2) b -= d2;
            if (in) sup[f][war.second]++;
            else sup[f][war.second]--;
            if (sup[f][0] && sup[f][1]) err++;
            if (sup[f][1]) b += d2;
        }
    //cout << b << endl;
}

int main()
{
    cin >> n;
    for (long long i = 1; i <= n; i++) cin >> a[i];
    for (long long i = 1; i < n; i++) need[i] = getdiff(a[i], a[i+1]);
    for (long long i = 1; i < n; i++)
        if (need[i].first != -1) sup[need[i].first][need[i].second]++;
    for (long long i = 0; i <= FST; i++)
    {
        bool f0 = sup[i][0], f1 = sup[i][1];
        if (f1 && f0) err++;
        if (f1) b += (1 << i);
    }
    if (err) cout << -1 << endl;
    else cout << b << endl;
    /*    for (long long i = 0; i < FST; i++) cout << sup[i][0] << ' ';
        cout << endl;
        for (long long i = 0; i < FST; i++) cout << sup[i][1] << ' ';
        cout << endl;*/
    long long q;
    cin >> q;
    for (long long j = 0; j < q; j++)
    {
        long long i, nw;
        cin >> i >> nw;
        a[i] = nw;
        pii war1 = pii(-1, -1), war2 = pii(-1, -1), war3 = war1, war4 = war2;
        if (i != 1)
        {
            war3 = need[i-1];
            need[i-1] = getdiff(a[i-1], a[i]);
            war1 = need[i-1];
        }
        if (i != n)
        {
            war4 = need[i];
            need[i] = getdiff(a[i], a[i+1]);
            war2 = need[i];
        }
        refresh(war1, 1);
        refresh(war2, 1);
        refresh(war3, 0);
        refresh(war4, 0);
        if (err) cout << -1 << endl;
        else cout << b << endl;
        /*for (long long i = 0; i < FST; i++) cout << sup[i][0] << ' ';
        cout << endl;
        for (long long i = 0; i < FST; i++) cout << sup[i][1] << ' ';
        cout << endl;*/
    }
    return 0;
}
