#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define endl '\n'
#define fi first
#define se second
#define mp make_pair

template <typename T>
istream & operator >> (istream & in, vector <T> & arr)
{
    for (auto & i : arr)
        in >> i;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> & arr)
{
    for (auto i : arr)
        out << i << " ";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p)
{
    in >> p.fi >> p.se;
    return in;
}

const int INF = 1000000000;
vector <vector <pair <int, int> > > g;

signed main()
{
    int n, m;
    cin >> n >> m;
    vector <pair <pair <int, int>, int> > edge;
    for (int itt = 0; itt < m; ++itt)
    {
        int u, v, w;
        cin >> v >> u >> w;
        --v;
        --u;
        edge.push_back(mp(mp(u, v), w));
        edge.push_back(mp(mp(v, u), w));
    }
    vector <pair <int, int> > dist(n, mp(INF, -1));
    dist[0] = mp(0, 0);
    for (int i = 0; i < n * 10; ++i)
    {
        for (int j = 0; j < edge.size(); ++j)
        {
            int v = edge[j].fi.fi, u = edge[j].fi.se;
            int w = edge[j].se;
            if (dist[v].fi + w < dist[u].fi)
            {
                dist[u] = dist[v];
                dist[u].fi += w;
                dist[u].se += w * w;
            }
            else if (dist[v].fi + w == dist[u].fi)
            {
                dist[u].se = max(dist[u].se, dist[v].se + w * w);
            }
        }
    }
    assert(dist[n - 1].fi < INF - INF / 100);
    cout << dist[n - 1].fi << " " << dist[n - 1].se << endl;
    return 0;
}
