#include <iostream>
#include <vector>
#include <algorithm>

const int INF = (int)1e9 + 7;

int main(void) {
	int n;
	std::cin >> n;
	std::vector<int> t(n);
	for (int i = 0; i < n; ++i) {
		std::cin >> t[i];
	}
	std::vector<std::pair<int, int>> a(n - 1);
	for (int i = 0; i < n - 1; ++i) {
		std::cin >> a[i].first >> a[i].second;
	}
	if (n == 1) {
		std::cout << "0\n";
		return 0;
	}
	std::vector<std::pair<int, int>> needL(n), needR(n);
	needL[0] = { -INF, INF };
	needR[n - 1] = { -INF, INF };
	for (int i = 1; i < n; ++i) {
		if (needL[i - 1] == std::make_pair(INF, -INF)) {
			needL[i] = needL[i - 1];
			continue;
		}
		std::pair<int, int> res = { std::max(needL[i - 1].first, a[i - 1].first - t[i]), std::min(needL[i - 1].second, a[i - 1].second) };
		if (res.first > res.second || std::max(needL[i - 1].first, a[i - 1].first) > std::min(needL[i - 1].second, a[i - 1].second)) {
			res = { INF, -INF };
		}
		needL[i] = res;
	}
	for (int i = n - 2; i >= 0; --i) {
		if (needR[i + 1] == std::make_pair(INF, -INF)) {
			needR[i] = needR[i + 1];
			continue;
		}
		std::pair<int, int> res = { std::max(needR[i + 1].first, a[i].first - t[i]), std::min(needR[i + 1].second, a[i].second) };
		if (res.first > res.second || std::max(needR[i + 1].first, a[i].first) > std::min(needR[i + 1].second, a[i].second)) {
			res = { INF, -INF };
		}
		needR[i] = res;
	}
	for (int cur = 0; cur < n; ++cur) {
		std::pair<int, int> res = { std::max(needL[cur].first, needR[cur].first), std::min(needL[cur].second, needR[cur].second) };
		if (res.first > res.second) {
			std::cout << "-1\n";
		} else {
			std::cout << res.first << '\n';
		}
	}
	return 0;
}