#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<fstream>
#include<ctime>
#include<cmath>
#include<algorithm>
#include<cstdlib>
#include<cstdio>
#include<set>
#include<map>
#include<string>
#include<vector>
#include<cstring>
#include<functional>
#include<queue>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define X first
#define Y second
#define all(a) a.begin(), a.end()
#define psh push_back
#define forn(i, n) for(int i = 0; i < (n); ++i)
#define for1(i, n) for(int i = 1; i <= (n); ++i)

const int MAXN = (int)1e5 + 7;
const ll LINF = (ll)1e18 + 7;
const int INF = (int)1e9 + 7;

void file() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
}

vector<pll> g[MAXN];
ll d[MAXN];
ll kv[MAXN];
ll a[MAXN];
ll b[MAXN];
ll pr[MAXN];
int n, m;

ll get(int l, int r) {
	return pr[r] - (l > 0 ? pr[l - 1] : 0);
}

void dj() {
	forn(i, n)
		d[i] = INF;
	set<pair<pll, ll>> s;
	s.insert({ { 0, 0 }, 0 });
	while (!s.empty()) {
		ll t = s.begin()->X.X;
		ll v = s.begin()->X.Y;
		ll k = s.begin()->Y;
		s.erase(s.begin());
		if (d[v] < t || d[v] == t && kv[v] > k)
			continue;
		d[v] = t;
		kv[v] = k;
		for (auto to : g[v]) {
			s.insert({ { to.Y + t, to.X }, k + (ll)to.Y * (ll)to.Y });
		}
	}
}

int main() {
	file();
	cin >> n >> m;
	forn(i, m) {
		int k;
		cin >> k;
		int fr;
		cin >> a[0];
		pr[i] = 0;
		--a[0];
		b[i] = 0;
		ll sum = 0;
		forn(i, k) {
			pr[i + 1] = 0;
			cin >> a[i + 1] >> b[i + 1];
			--a[i + 1];
		}
		for1(i, k) {
			sum += b[i];
			pr[i] = sum;
		}
		forn(i, k + 1) {
			forn(j, k + 1) {
				g[a[i]].psh({ a[j], get(i + 1, j) });
			}
		}
	}
	dj();
	cout << d[n - 1] << " " << kv[n - 1];

	return 0;
}