#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<map>
#include<set>
#include<queue>

using namespace std;
int n;

void bfs(vector < vector<pair<int, int>>>&g) {
	vector<pair<int, int>>dist(n + 1, { 1e9,0 });
	dist[1] = { 0,0 };
	queue<int>q;
	q.push(1);
	while (!q.empty()) {
		int now = q.front();
		q.pop();
		for (auto to : g[now]) {
			if (dist[to.first].first > dist[now].first + to.second) {
				q.push(to.first);
				dist[to.first].second = dist[now].second + to.second*to.second;
				dist[to.first].first = dist[now].first + to.second;
				continue;
			}
			if (dist[to.first].first == dist[now].first + to.second && dist[to.first].second < dist[now].second + to.second*to.second) {
				 dist[to.first].second=dist[now].second + to.second*to.second;
				 dist[to.first].first = dist[now].first + to.second;
				q.push(to.first);
			}
		}
	}
	cout << dist[n].first << ' ' << dist[n].second;
}

int main()
{
	cin >> n;
	int m;
	cin >> m;
	vector < vector<pair<int,int>>>g(n + 1);
	for (int i = 0; i < m; i++) {
		int cnt;
		cin >> cnt;
		int pred;
		cin >> pred;
		for (int j = 0; j <  cnt; j++) {
			int to, price;
			cin >> price >> to;
			g[pred].push_back({ to,price });
			pred = to;
		}
	}
	bfs(g);
	return 0;
}