#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;
#define ff first
#define ss second
#define mp make_pair
#define pb push_back
#define pii pair <int, int>
#define vkal pair <pii, int>
#define kal pair <pii, pair <pii, int> > 

#define int long long
int n, m;
const int INF = 1e9 + 7;
const int INF2 = 1e18 + 7;

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector <vector <vkal> > g(n);
	for (int i = 0; i < m; ++i) {
		int s, v, u, w;
		cin >> s >> v;
		v--;
		for (int j = 0; j < s; ++j) {
			cin >> w >> u;
			u--;
			g[v].pb(mp(mp(u, w), i));
			v = u;
		}
	}


	vector <int> time(n, INF); //best time
    time[0] = 0;
    set <pii> times;
    times.insert(mp(0, 0));
    while (!times.empty()) {
        auto kk = *times.begin();
        times.erase(kk);
        for (auto u : g[kk.ss]) {
            if (time[u.ff.ff] > kk.ff + u.ff.ss) {
                times.erase(mp(time[u.ff.ff], u.ff.ff));
                time[u.ff.ff] = kk.ff + u.ff.ss;
                times.insert(mp(time[u.ff.ff], u.ff.ff));
            }
        }
    }

	vector <map <pii, pii> > tm(n); //best time
	tm[0][mp(-1, 0)] = mp(0, 0);
	set <kal> tms;
	tms.insert(mp(tm[0][mp(-1, 0)], mp(mp(-1, 0), 0)));
	while (!tms.empty()) {
		auto kk = *tms.begin();
		tms.erase(kk);
		if (kk.ff.ff != time[kk.ss.ss])
			continue;
		for (auto u : g[kk.ss.ss]) {
			pii ntm = mp(kk.ff.ff + u.ff.ss, kk.ff.ss - u.ff.ss * u.ff.ss);
			if (ntm.ff != time[u.ff.ff])
				continue;
			pii ntm2 = mp(u.ss, u.ff.ss);
			if (kk.ss.ff.ff == u.ss) {
				ntm.ss -= 2 * u.ff.ss * kk.ss.ff.ss;
				ntm2.ss += kk.ss.ff.ss;
			}
			if (tm[u.ff.ff].count(ntm2) == 0 || ntm < tm[u.ff.ff][ntm2]) {
				tms.erase(mp(tm[u.ff.ff][ntm2], mp(ntm2, u.ff.ff)));
				tm[u.ff.ff][ntm2] = ntm;
				tms.insert(mp(tm[u.ff.ff][ntm2], mp(ntm2, u.ff.ff)));
			}
		}
	}

	pii ans = mp(INF, -INF);
	for (auto i : tm[n - 1])
		ans = min(ans, i.ss);
	cout << ans.ff << ' ' << -ans.ss << endl;
}