#define _CRT_SECURE_NO_WARNINGS

#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int, int> pii;
typedef vector<pii> vpii;

#define X first
#define Y second
#define mk make_pair
#define inb push_back

int solve();

int main()
{
	//ios_base::sync_with_stdio(0);
	//cin.tie(0);
	//cout.tie(0);
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int MAXN = (int)5e4 + 7;

int n;
char ans[MAXN];
set<int> q;
set<pii> mem;
vi st, nn;

bool ask(int l, int r)
{
	cout << "? " << l + 1 << " " << r + 1 << endl;
	string res;
	cin >> res;
	return res[0] == 'Y';
}

bool ask1(int l, int r)
{
	if (mem.find(mk(l, r)) != mem.end())
		return 0;
	cout << "? " << l + 1 << " " << r + 1 << endl;
	string res;
	cin >> res;
	return res[0] == 'Y';
}

int solve()
{
	cin >> n;
	for (int i = 0; i < n; ++i)
	{
		q.insert(i);
	}
	for (int i = 0; i < n - 1; ++i)
	{
		if (q.find(i) != q.end() && ask(i, i + 1))
		{
			q.erase(i), q.erase(i + 1);
			ans[i] = '(', ans[i + 1] = ')';
			if (q.find(i - 1) != q.end())
				st.inb(i - 1);
		}
	}
	while (!q.empty())
	{
		for (auto i : st)
		{
			set<int>::iterator bb = q.find(i);
			if (bb == q.end())
				continue;
			set<int>::iterator ee = bb;
			++ee;
			if (ee == q.end())
				break;
			int pb = *bb;
			int pe = *ee;
			if (ask(pb, pe))
			{
				ans[pb] = '(';
				ans[pe] = ')';
				set<int>::iterator npos = bb;
				--bb;
				q.erase(pe);
				q.erase(pb);
				if (bb != q.end())
					nn.inb(*bb);
				//break;
			}
		}
		swap(st, nn);
		nn.clear();
	}
	if (q.size() >= 2)
		ans[*q.begin()] = '(', ans[*q.rbegin()] = ')';
	cout << "! ";
	for (int i = 0; i < n; ++i)
		cout << ans[i];
	cout << endl;
	return 0;
}