#define _CRT_SECURE_NO_WARNINGS

#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <cassert>
#include <unordered_map>
#include <ctime>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef pair<ll, ll> pll;

#define X first
#define Y second
#define mk make_pair
#define inb push_back
#define all(v) v.begin(), v.end()
#define TIME (double)CLOCKS_PER_SEC / 1000.0 * 60.0

int solve();

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	srand(256);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int MAXN = (int)1e3 + 7;
const int LINF = (int)2e9;

int n, m;
unordered_map < int, int > d[1003];
vector < pair <pair <int, int>, int> > g[1003];
vi xs, cs;

int solve()
{
	cin >> n >> m;
	int it = 0;
	for (int i = 0; i < m; ++i)
	{
		int cnt = 1;
		cin >> cnt;
		int x = -1;
		cin >> x;
		--x;
		int sumlen = 0;
		xs.clear(), cs.clear();
		xs.inb(x);
		for (int j = 0; j < cnt; ++j)
		{
			int c, y;
			cin >> c >> y;
			--y;
			cs.inb(c);
			xs.inb(y);
		}
		for (int j = 0; j < cnt; ++j)
		{
			sumlen = 0;
			int x = xs[j];
			for (int k = j; k < cnt; ++k)
			{
				++it;
				sumlen += cs[k];
				int y = xs[k + 1];
				g[x].inb(mk(mk(sumlen * sumlen, sumlen), y));
				//x = y;
			}
		}
	}
	set< pair <pii, int> > q;
	d[0][0] = 0ll;
	q.insert(mk(mk(0, 0), 0));
	while (!q.empty())
	{
		pair <pii, int> cur = *q.begin();
		int u = -cur.Y;
		int dst = cur.X.X;
		int hap = -cur.X.Y;
		++it;
		if (u == n - 1 || it > 30000000)
			cout << dst << " " << hap << endl, exit(0);
		q.erase(*q.begin());
		for (auto &nv : g[u])
		{
			++it;
			int to = nv.Y;
			int nhap = nv.X.X + hap;
			int ndst = nv.X.Y;
			if (d[to].find(nhap) == d[to].end() || d[to][nhap] > dst + ndst)
			{
				q.erase(mk(mk(d[to][nhap], -nhap), -to));
				d[to][nhap] = dst + ndst;
				q.insert(mk(mk(d[to][nhap], -nhap), -to));
			}
		}
	}
	return 0;
}