#include <bits/stdc++.h>

using namespace std;

#define Y second
#define X first

bool check(vector<pair<char, int>> &need, char nows) {
    stack<pair<char, int>> x;
    for (int i = 0; i < need.size(); ++i) {
        if (x.size() == 0) {
            x.push(need[i]);
        } else if (need[i].X == nows) {
            int cnts = need[i].Y;
            while (x.size() != 0 && (x.top().X == nows || x.top().Y < cnts)) {
                cnts += x.top().Y;
                x.pop();
            }
            x.push({nows, cnts});
        } else {
            int cnts = need[i].Y;
            if (x.size() != 0 && (x.top().X == nows && x.top().Y > cnts)) {
                cnts += x.top().Y;
                x.pop();
            } else {
                x.push({need[i].X, cnts});
                continue;
            }

            while (x.size() != 0 && (x.top().X == nows || x.top().Y < cnts)) {
                cnts += x.top().Y;
                x.pop();
            }
            x.push({nows, cnts});
        }
    }

    return (x.size() == 1 && x.top().X == nows);
}

void solve() {
    string a, b;
    cin >> a >> b;

    vector<pair<char, int>> a1, b1;

    char last = a[0];
    int cnts = 1;
    for (int i = 1; i < a.length(); ++i) {
        if (a[i] != last) {
            a1.push_back({last, cnts});
            last = a[i];
            cnts = 1;
        } else {
            cnts++;
        }
    }
    a1.push_back({last, cnts});

    last = b[0];
    cnts = 1;
    for (int i = 1; i < b.size(); ++i) {
        if (b[i] != last) {
            b1.push_back({last, cnts});
            last = b[i];
            cnts = 1;
        } else {
            cnts++;
        }
    }
    b1.push_back({last, cnts});

    vector<pair<char, int>> ag;
    int j = -1, na = 0, nb = 0;
    for (int i = 0; i < b1.size(); ++i) {
        ag.clear();
        nb += b1[i].Y;
        while (j + 1 < a1.size() && a1[j + 1].Y + na <= nb) {
            j++;
            ag.push_back(a1[j]);
            na += a1[j].Y;
        }
        if (na < nb) {
            cout << "No" << endl;
            return;
        }

        if (!check(ag, b1[i].X)) {
            cout << "No" << endl;
            return;
        }
    }
    cout << "Yes" << endl;
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;

    for (int i = 0; i < n; ++i) {
        solve();
    }

    return 0;
}
