#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <fstream>
#include <algorithm>
#include <cmath>
#include <utility>
#include <queue>
using namespace std;
typedef long long int ll;
#define v vector

#ifdef _MSC_VER
#define DEB(x) cout << x
#else
#define DEB(x)
#endif

void pause() {
#ifdef _MSC_VER
	std::system("pause");
#endif
}

int n, m;
vector<map<int, int>> graph;

int main() {
	cin >> n >> m;
	graph.resize(n);
	for (int i = 0; i < m; i++) {
		int s;
		cin >> s;
		int prev;
		cin >> prev;
		for (int i = 0; i < s; i++) {
			int a, b;
			cin >> a >> b;
			auto res = graph[prev - 1].insert({ b - 1, a });
			if (!res.second) {
				graph[prev - 1][b - 1] = min(graph[prev - 1][b - 1], a);
			}
			prev = b;
		}
	}
	queue<int> q;
	vector<int> used(n, -1);
	q.push(0);
	while (!q.empty()) {
		int ver = q.front();
		q.pop();
		for (auto j : graph[ver]) {
			if (used[j.first] == -1) {
				q.push(j.first);
				used[j.first] = ver;
			}
		}
	}
	ll answ = 0;
	int p = n - 1;
	while (p) {
		answ++;
		p = used[p];
	}
	cout << answ << " " << answ << endl;
	pause();
	return 0;
}