import java.io.*;
import java.util.ArrayList;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
    public class pair {
        int x, y,c;
        public pair(int a,int b,int v){
            x = a;
            y = b;
            c = v;
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        int a = nextInt();
        pair[] q = new pair[n];
        for(int i = 0; i < n; i++){
            q[i] = new pair(nextInt(),nextInt(),nextInt());
        }
        long s = Long.MAX_VALUE;
        int l = 0;
        int r = 0;
        int t = 0;
        long mod = 1000000000;
        while (l + q[0].y <= a){
            l += q[0].x;
            r += q[0].y;
            t++;
            if(r +q[0].y > a){
                s = Math.min(s,(a - q[0].y + 1) * mod - q[0].c * t);
                r = a - q[0].y;
            }
        }
        out.print(s);
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
//            br = new BufferedReader(new FileReader("storage.in"));
//            out = new PrintWriter(new File("storage.out"));
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}