import java.io.*;
import java.util.ArrayList;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
    public class pair {
        int x, y, c;

        public pair(int a, int b, int v) {
            x = a;
            y = b;
            c = v;
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        int a = nextInt();
        int min = Integer.MAX_VALUE;
        pair[] q = new pair[n];
        for (int i = 0; i < n; i++) {
            q[i] = new pair(nextInt(), nextInt(), nextInt());
            min = Math.min(min, q[i].y);
        }
        long s = Long.MAX_VALUE;
        long[] d = new long[a + 1];
        for (int i = 1; i <= a; i++) {
            for (int j = 0; j < n; j++) {
                boolean t = true;
                if (i + q[j].y <= a) {
                    for (int k = q[j].x; k <= q[j].y; k++) {
                        if (d[i + k] > d[i] + (long) 1000000000 * k - q[j].c) {
                            t = false;
                            break;
                        }
                    }
                    if (t) {
                        long p = Long.MAX_VALUE;
                        for (int k = q[j].x; k <= q[j].y; k++) {
                            d[i + k] = d[i] + (long) 1000000000 * k - q[j].c;
                            p = Math.min(p, d[i + k]);
                        }
                    }
                }
            }
        }
        for(int i = a - min; i <= a; i++){
            s = Math.min(s,d[i]);
        }
        out.print(s);
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
//            br = new BufferedReader(new FileReader("storage.in"));
//            out = new PrintWriter(new File("storage.out"));
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}