#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

long long n;
vector<long long> v;
vector<long long> ans(30, 2);

bool in(long long a, long long p) {
    return (a & (1 << p));
}

bool build(long long l, long long r, long long z) {
    if (r <= l)
    while(1) { }
    if (r == l + 1 || z < 0)
        return 1;
    long long changed = 0;
    bool was_changed = false;
    long long last = in(v[l], z);
    for (long long j = l + 1; j < r; ++j) {
       long long cur = in(v[j], z);
       if (cur != last) {
            if (!was_changed) {
                was_changed = true;
                changed = j;
            }
            else
                return 0;
       }
       last = cur;
    }
    if (was_changed) {
        if (ans[z] != 2 && ans[z] != in(v[l], z))
            return 0;
        else
            ans[z] = in(v[l], z);
        bool t1 = build(l, changed, z - 1);
        bool t2 = build(changed, r, z - 1);
        return t1 && t2;
    }
    else
        return build(l, r, z - 1);
}

int main() {
    long long n, q;
    cin >> n;
    v.resize(n);
    for (long long i = 0; i < n; ++i)
        cin >> v[i];
    build(0, n, 29);
    long long res = 0;
    for (long long i = 0; i < ans.size(); ++i)
        if (ans[i] == 1)
            res += (1 << i);
    cout << res << endl;
    cin >> q;
    long long pl, val;
    for (long long k = 0; k < q; ++k) {
        cin >> pl >> val;
        v[pl - 1] = val;
        ans = vector<long long> (30, 2);
        if (build(0, n, 29)) {
            long long res = 0;
            for (long long i = 0; i < ans.size(); ++i)
                if (ans[i] == 1)
                    res += (1 << i);
            cout << res << endl;
        }
        else
            cout << -1 << endl;
    }
}

/*
3
0 1 4
3
2 7
3 3
1 4
*/
