
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

vector<size_t> x;
vector<size_t> y;

size_t sq(size_t a, size_t b, size_t c) {
    return fabs((x[b] - x[a]) * (y[c] - y[a]) - (y[b] - y[a]) * (x[c] - x[a]));
}

bool inside(size_t a, size_t b, size_t c, size_t i) {
    return (sq(a, b, c) == sq(a, b, i) + sq(a, c, i) + sq(b, c, i));
}

int main() {
    size_t n, q;
    cin >> n;
    x.resize(n);
    y.resize(n);
    for (size_t i = 0; i < n; ++i)
        cin >> x[i] >> y[i];
    cin >> q;
    string c;
    for (size_t i = 0; i < q; ++i) {
        bool br = false;
        size_t a1, a2, a3;
        size_t cs = -1;
        bool pass = false;
        for (size_t t1 = 1; t1 <= n; ++t1) {
            for (size_t t2 = t1 + 1; t2 <= n; ++t2) {
                for (size_t t3 = t2 + 1; t3 <= n; ++t3) {
                    cout << "? 3 " << t1 << ' ' << t2 << ' ' << t3 << endl;
                    cin >> c;
                    if (c[0] == 'Y') {
                        pass = true;
                        for (int i = 1; i <= n; ++i)
                            if (i != t1 && i != t2 && i != t3)
                                if (inside(t1 - 1, t2 - 1, t3 - 1, i - 1)) {
                                    pass = false;
                                    break;
                                }
                        if (pass) {
                            cout << "! 3 " << t1 << ' ' << t2 << ' ' << t3 << endl;
                            break;
                        }
                    }
                }
                if (pass) break;
            }
            if (pass) break;
        }
    }
    return 0;
}

/*
6
3 0
0 2
2 4
4 2
5 5
6 1
4
*/
