#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

int main() {
    int q;
    cin >> q;
    for (int e = 0; e < q; ++e) {
        string s, k;
        cin >> s >> k;
        vector<pair<int, char>> t1;
        int i = 0;
        while (i < s.size()) {
            char c = s[i];
            int st = i;
            while (i < s.size() && s[i] == c)
                i++;
            t1.push_back({i - st, c});
        }
        vector<pair<int, char>> t2;
        i = 0;
        while (i < k.size()) {
            char c = k[i];
            int st = i;
            while (i < k.size() && k[i] == c)
                i++;
            t2.push_back({i - st, c});
        }
        int cur_len1 = 0;
        int cur_len2 = 0;
        int j = 0;
        vector<pair<int, char>> st;
        bool pass = true;
        for (int i = 0; i < t1.size(); ++i) {
            bool les = cur_len1 < cur_len2;
            st.push_back(t1[i]);
            cur_len1 += t1[i].first;
            if (cur_len1 > cur_len2) {
                if (les) {
                    pass = false;
                    break;
                }
                else {
                    cur_len2 += t2[j].first;
                    if (cur_len1 > cur_len2) {
                        pass = false;
                        break;
                    }
                    j++;
                }
            }
            char sm = t2[j - 1].second;
            while (st.size() >= j + 1) {
                auto r1 = st[st.size() - 1];
                auto r2 = st[st.size() - 2];
                if (r1.second != sm)
                    swap(r1, r2);
                if (r1.second == r2.second) {
                    st.pop_back();
                    st.pop_back();
                    st.push_back({r1.first + r2.first, r1.second});
                }
                else if (r1.first > r2.first) {
                    st.pop_back();
                    st.pop_back();
                    st.push_back({r1.first + r2.first, r1.second});
                }
                else
                    break;
            }
            while (st.size() >= 2) {
                auto r1 = st[st.size() - 1];
                auto r2 = st[st.size() - 2];
                if (r1.second == r2.second) {
                    st.pop_back();
                    st.pop_back();
                    st.push_back({r1.first + r2.first, r1.second});
                }
                else
                    break;
            }
            if ((cur_len1 == cur_len2) && (st.size() != j || st[st.size() - 1] != t2[j - 1])) {
                pass = false;
                break;
            }
        }
        cout << (pass ? "Yes" : "No") << endl;
    }
}

/*
3
++- +++
++-- ++++
++-+--+- ++++++++
*/

/*
3
++-+-- ++----
++-+-- +++---
-++- -++-
*/
