#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <inttypes.h>
#include <vector>
#include <random>
#include <algorithm>
#include <functional>

int main()
{
    int n, a;
    scanf("%d%d", &n, &a);
    std::vector<int> dp(a+1, -1);
    std::vector<char> is_end(a+1, false);
    dp[0] = 0;
    is_end[0] = true;

    for (int i = 0; i < n; ++i) {
        int l, r, c;
        scanf("%d%d%d", &l, &r, &c);
        for (int j = 0; j+r <= a; ++j) if (dp[j] != -1)
            for (int k = j+l; k <= j+r; ++k)
                if(dp[j] + c > dp[k]) {
                    dp[k] = dp[j] + c;
                    is_end[j] = false;
                    is_end[k] = true;
                }
    }

    for (int i = 0; i <= a; ++i)
        printf("%d ", (int)is_end[i]);
    printf("\n");
    for (int i = 0; i <= a; ++i)
        printf("%u ", dp[i]);
    printf("\n");

    int64_t res = 1LL<<62;
    for (int i = 0; i <= a; ++i)
        if (is_end[i])
            res = std::min(res, int64_t(1e9)*i - dp[i]);

    printf("%lld\n", res);

    return 0;
}
