#include <iostream>
#include <vector>
#include <cmath>
#include <stack>

using namespace std;
struct edge {
    int v, num;
    long long w;
    edge(int a = 0, int b = 0, int c = 0) : v(a), w(b), num(c) {}
};
const long long inf = 1e16;
struct dist {
    long long d, nump, t_last, t_all;
    dist(long long a = inf, long long b = 0, long long c = 0, long long e = 0)
    : d(a), nump(b), t_last(c), t_all(e){}

};
main() {
    int n, m;
    int s1;
    cin >> n >> m;
    vector <int> used(n);
    vector <vector <edge> >g(n);
    for (int i = 0; i < m; i++) {
        int s;
        cin >> s;
        if (i == 0)
            s1 = s;
        int v1;
        cin >> v1;
        v1--;
        for (int j = 0; j < s; j++) {
            int t, v2;
            cin >> t >> v2;
            v2--;
            g[v1].push_back(edge(v2, t, i));
            v1 = v2;
        }

    }
    vector <dist> d(n);
    d[0].d = 0;
    for (int i = 0; i < n; i++) {
        int num = -1;
        for (int j = 0; j < n; j++) {
            if (!used[j] && ((num == - 1) || (d[j].d < d[num].d)))
                num = j;
        }
        used[num] = 1;
        for (edge e : g[num]) {
            if (d[e.v].d > d[num].d + e.w) {
                d[e.v].d = d[num].d + e.w;
                d[e.v].nump = e.num;
                if (d[num].nump == e.num ) {
                    d[e.v].t_all = d[num].t_all;
                    d[e.v].t_last = d[num].t_last;
                    d[e.v].t_all -= d[e.v].t_last * d[e.v].t_last;
                    d[e.v].t_last += e.w;
                    d[e.v].t_all += d[e.v].t_last * d[e.v].t_last;
                    continue;
                }
                else {
                    d[e.v].t_all = d[num].t_all + e.w * e.w;
                    d[e.v].t_last = e.w;
                    continue;
                }

            }
            if (d[e.v].d != d[num].d + e.w)
                    continue;
            long long t1 = 0, t2;
            t1 = d[num].t_all;

            if (d[num].nump == e.num) {
                t2 = d[num].t_last;
                t1 -= t2 * t2;
                t2 += e.w;
            }
            else {
                t2 = e.w;
            }
            t1 += t2 * t2;
            if (t1 > d[e.v].t_all) {
                d[e.v].nump = e.num;
                d[e.v].t_all = t1;
                d[e.v].t_last = t2;
            }
        }
    }
    cout << d[n - 1].d << " " << d[n - 1].t_all;
}

