#include <ctime>
#include <algorithm>
#include <fstream>
#include <vector>

using namespace std;

template<class T> inline void chkmin(T a, T b) { if (a > b) a = b; }

typedef long long ll;

ifstream cin("sequence.in");
ofstream cout("sequence.out");

const int MAXN = 400;

vector<ll> a;
int g[MAXN][MAXN];

int main() {
	srand(time(0));
	ll c;
	while (cin >> c) {
		a.push_back(c);
	}
	reverse(a.begin(), a.end());
	for (ll c : a) {
		cout << c << ' ';
	}
	cout << '\n';
	for (int i = 0; i < MAXN; ++i)
		for (int j = 0; j < MAXN; ++j)
			for (int k = 0; k < MAXN; ++k)
				g[i][j] = rand();
	for (int k = 0; k < MAXN; ++k) {
		for (int i = 0; i < MAXN; ++i) {
			for (int j = 0; j < MAXN; ++j) {
				chkmin(g[i][j], g[i][k] + g[k][j]);
			}
		}
	}
	cout << g[rand() % MAXN][rand() % MAXN];
}

