#include <bits/stdc++.h>

using namespace std;

const int INF = 2 * (int)(1e9);

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> t(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    vector<int> l(n - 1), r(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        cin >> l[i] >> r[i];
    }

    vector<int> pref_min(n, 0);
    vector<int> pref_max(n, INF);
    vector<bool> can_pref(n, true);

    vector<int> suf_min(n, 0);
    vector<int> suf_max(n, INF);
    vector<bool> can_suf(n, true);

    for (int i = 1; i < n; ++i) {
        pref_min[i] = max(pref_min[i - 1], l[i - 1] - t[i]);
        pref_min[i] = max(pref_min[i], 0);

        pref_max[i] = min(pref_max[i - 1], r[i - 1]);

        can_pref[i] = can_pref[i - 1] && ((pref_max[i] >= l[i - 1] && pref_max[i] <= r[i - 1]) || (pref_min[i] <= r[i - 1] && pref_min[i] >= l[i - 1]));
    }

    for (int i = n - 2; i > -1; --i) {
        suf_min[i] = max(suf_min[i + 1], l[i] - t[i]);
        suf_min[i] = max(suf_min[i], 0);

        suf_max[i] = min(suf_max[i + 1], r[i]);

        can_suf[i] = can_suf[i + 1] && ((suf_max[i] >= l[i] && suf_max[i] <= r[i]) || (suf_min[i] <= r[i] && suf_min[i] >= l[i]));
    }

    for (int i = 0; i < n; ++i) {
        if (can_pref[i] && can_suf[i]) {
            cout << max(suf_min[i], pref_min[i]) << "\n";
        } else {
            cout << "-1\n";
        }
    }
}
