#include <fstream>
#include <cstdio>
#include <vector>
#include <stdio.h>
#include <queue>
#include <stack>
#include <string>
#include <algorithm>

//#include <iostream>

using namespace std;


#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;
typedef pair <int, int> pii;
typedef long double ld;

#define all(a) a.begin(), a.end()

int INF = 2 * 1e9;

int main() {
	int n, m;
	cin >> n >> m;
	vector <vector <pii> > g(n);
	for (int i = 0; i < m; i++) {
		int temp;
		cin >> temp;
		int a, b, t;
		cin >> a >> t >> b;
		a--; b--;
		g[a].push_back({ b, t });
		g[b].push_back({ a, t });
	}

	vector <ll> d(n, INF), d2(n, INF);

	d[0] = d2[0] = 0;
	vector <bool> used(n);
	for (int i = 0; i < n; i++) {
		int v = -1;
		for (int j = 0; j < n; j++) {
			if (!used[j] && (v == -1 || d[v] > d[j] || (d[v] == d[j] && d2[v] < d2[j]))) {
				v = j;
			}
		}
		if (d[v] == INF) {
			break;
		}
		used[v] = true;
		for (auto c : g[v]) {
			ll len = c.second;
			int to = c.first;
			if (len + d[v] < d[to] || (len + d[v] == d[to] && d2[v] + len * len > d2[to])) {
				d[to] = d[v] + len;
				d2[to] = d2[v] + len * len;
			}
		}
	}
	cout << d[n - 1] << " " << d2[n - 1];
}