import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class A2 {

	private void solve() throws IOException {
		final int n = nextInt();
		int last = 1;
		String ans = "(";
		for (int i = 1; i < n; i++) {
			out.println("? " + i + " " + (i + 1));
			out.flush();
			last = nextToken().equals("Yes") ? -last : last;
			ans += last == 1 ? "(" : ")";
		}
		out.print("! " + ans);
	}
	
	private final BufferedReader in;
	private final PrintWriter out;
	private StringTokenizer st;
	
	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	
	private A2() throws IOException {
		in = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);
		
		solve();
		
		in.close();
		out.close();
	}
	
	public static void main(final String[] args) throws IOException {
		new A2();
	}

}
