#include <iostream>
#include <string>
#include <vector>
#include <bitset>
using namespace std;

pair <int, int> dots[100113];

int n;

bool good(int i, int j, int k) {
	pair <int, int> a1 = dots[i], b1 = dots[j], c1 = dots[k];

	double k1 = a1.first - b1.first, k2 = b1.first - c1.first, k3 = c1.first - a1.first, bb1, bb2, bb3;

	k1 /= a1.second - b1.second;
	k2 /= b1.second - c1.second;
	k3 /= c1.second - a1.second;

	bb1 = a1.second - a1.first * k1;
	bb2 = b1.second - b1.first * k2;
	bb3 = c1.second - c1.first * k3;

	for (int p = 0; p < n; p++)
		if (p == i || p == j || p == k)
			continue;
		else {
			int x = dots[p].first, y = dots[p].second;

			bool is1 = (k1 * x + bb1) > y;
			bool is2 = (k2 * x + bb2) > y;
			bool is3 = (k3 * x + bb3) > y;

			if (is1 && is2 && is3)
				return 0;
		}

	return 1;
}
void query() {

	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= n; j++)
			if (j == i)
				continue;
			else
				for (int k = 1; k <= n; k++)
					if (k == j || k == i)
						continue;
					else if (good(i, j, k)) {
						
						cout << "? 3 " << i << ' ' << j << ' ' << k << endl;

						string s;

						cin >> s;

						if (s == "Yes") {
							cout << "! 3 " << i << ' ' << j << ' ' << k << endl;
							return;
						}
					}
}

int main() {
	int x, y;

	cin >> n;

	for (int i = 0; i < n; i++) {
		cin >> x >> y;
		dots[i] = make_pair(x, y);
	}

	int q;

	cin >> q;

	for (int i = 0; i < q; i++)
		query();


	return 0;
}