#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <random>
#define X first
#define Y second
typedef long long ll;
using namespace std;
vector<vector<pair<ll,ll > > > gg,rg,g;
struct rebr {
	ll u, v, len, id;
	rebr(ll v, ll u, ll len, ll id) :
		v(v), u(u), len(len), id(id) {}
	const bool operator<(const rebr b) {
		if (b.id != id)
			return id < b.id;
		if (b.v != v)
			return v < b.v;
		return u < b.u;
	}
};
vector<bool> was;
vector<ll> t;
void ts(ll v) {
	was[v] = 1;
	for (ll i = 0; i < g[v].size(); i++)
		if (!was[g[v][i].X])
			ts(g[v][i].X);
	t.push_back(v);
}

vector<rebr> r;
vector<ll> d;
vector<ll> ans;
ll mlb(ll v, ll t) {
	ll l = 0,  r = (ll)rg[v].size()-1;
	if (rg[v].size() == 0)
		return -1;
	while (r - l > 1) {
		ll m = (r + l) / 2;
		if (rg[v][m].X >= t)
			r = m;
		else l = m;
	}
	if (rg[v][l].X == t)
		return l;
	if (rg[v][r].X == t)
		return r;
	return -1;
}
ll dfs(ll v, ll t, ll len) {
	ll ret = len*len + ans[v];
	ll id = mlb(v, t);
	if (id == -1)
		return ret;
	for (ll i = id; i < rg[v].size() && rg[v][i].X == t; i++)
		ret = max(ret, dfs(rg[v][i].Y, t, len + d[v]-d[rg[v][i].Y]));
	return ret;
}

void solve(ll v) {
	for (ll i = 0; i < rg[v].size(); i++) {
		ans[v]=max(ans[v],dfs(rg[v][i].Y, rg[v][i].X, d[v]-d[rg[v][i].Y]));
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ll n, m;
	cin >> n >> m;
	gg.resize(n);
	rg.resize(n);
	g.resize(n);
	ans.resize(n, false);
	d.resize(n, 1e18);
	for (ll i = 0; i < m; i++) {
		ll k;
		cin >> k;
		ll last;
		cin >> last;
		last--;
		for (ll j = 0; j < k; j++) {
			ll t, now;
			cin >> t >> now;
			now--;
			gg[last].emplace_back(now, t);
			rg[now].emplace_back(last, t);
			r.emplace_back(last, now, t, i);
			last = now;
		}
	}
	d[0] = 0;
	vector<ll> dd(n,-1);
	dd[0] = 0;
	set<pair<ll, ll> > st;
	st.insert({ 0,0 });
	while (!st.empty()) {
		ll v = st.begin()->Y;
		st.erase(st.begin());
		for (ll i = 0; i < gg[v].size(); i++) {
			ll to = gg[v][i].X, len = gg[v][i].Y;
			if (d[v] + len < d[to] || (d[v]+len==d[to] && dd[v]+len*len>dd[to])) {
				st.erase({ d[to],to });
				d[to] = d[v] + len;
				dd[to] = dd[v] + len*len;
				st.insert({ d[to],to });
			}
		}
	}
	vector<bool> used(n, false);
	used[n - 1] = 1;
	queue<ll> q;
	q.push(n - 1);
	while (!q.empty()) {
		ll v = q.front();
		q.pop();
		for (ll i = 0; i < rg[v].size(); i++) {
			ll to = rg[v][i].X, len = rg[v][i].Y;
			if (!used[to] && d[to] + len == d[v]) {
				used[to] = 1;
				q.push(to);
			}
		}
	}
	sort(r.begin(), r.end());
	rg.clear();
	rg.resize(n);
	for (ll i = 0; i < r.size(); i++) {
		if (used[r[i].v] && used[r[i].u] && d[r[i].u]-d[r[i].v]==r[i].len) {
			g[r[i].v].push_back({ r[i].u,r[i].id });
			rg[r[i].u].push_back({r[i].id,r[i].v });
		}
	}	
	was.resize(n, false);
	ts(0);
	reverse(t.begin(), t.end());
	for (ll i = 0; i < t.size(); i++)
		solve(t[i]);
	cout << d[n - 1]<<' '<< ans[n - 1];
	return 0;
}