#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::abs;
using std::min;
using std::max;
using std::pair;
using std::swap;
using std::vector;
using std::set;
using std::map;
using std::string;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#ifdef LOCAL
#define dbg(as...) {\
	std::stringstream _ss(#as);\
	vector<string> _v;\
	string _cur, _loc;\
	while (getline(_ss, _cur, ',')) {\
		while (count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
			getline(_ss, _loc, ',');\
			_cur += "," + _loc;\
		}\
		_v.pb(_cur);\
	}\
	err(_v.begin(), as);\
}
#else 
#define dbg(as...) {}
#endif

template<typename T> 
void err(vector<string>::iterator it, T a) {
	cerr << *it << " = " << a << '\n';
}

template<typename T, typename...Ts>
void err(vector<string>::iterator it, T a, Ts...as) {
	cerr << *it << " = " << a << ',';
	err(++it, as...);
}

struct init{
	init() {
		std::iostream::sync_with_stdio(0);
		cin.tie(0);
		cout << std::fixed << std::setprecision(10);
		cerr << std::fixed << std::setprecision(3);
		srand(300);
	}
} init;

const int MAXN = 5e3 + 1;
using myf = ll;
struct point{
	myf x, y;
	int i;
	point() {}
	point (myf _x, myf _y, int _i) : x(_x), y(_y), i(_i) {}
};
struct vc{
	myf x, y;
	vc() {}
	vc (myf _x, myf _y) : x(_x), y(_y) {}
	vc(point a, point b) {
		x = b.x - a.x;
		y = b.y - a.y;
	}
};
myf operator % (vc a, vc b) {
	return a.x * b.y - a.y * b.x;
}
bool check(point a, point b, point c, point o) {
	vc oa(o, a), ob(o, b), oc(o, c);
	return !(oa % ob > 0 && ob % oc > 0 && oc % oa > 0) && !(oa % ob < 0 && ob % oc < 0 && oc % oa < 0);
}
int32_t main() {

	int n;
	cin >> n;
	vector<point> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
		a[i].i = i + 1;
	}

	int q;
	cin >> q;
	while (q--) {
		for (int i = 0; i < n; ++i) 
			for (int j = i + 1; j < n; ++j) 
				for (int k = j + 1; k < n; ++k) {
					bool ok = true;
					for (int other = 0; other < n; ++other) 
						ok &= other == i || other == j || other == k || check(a[i], a[j], a[k], a[other]);
					if (ok) {
						cout << "? 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << std::endl;
						string res;
						cin >> res;
						if (res[0] == 'Y') {
							cout << "! 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << std::endl;
							i = j = k = 1e9;
							break;
						}
					}
				}
		dbg("tiger");
	}


	return 0;
}
