#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::abs;
using std::min;
using std::max;
using std::swap;
using std::pair;
using std::vector;
using std::set;
using std::map;
using std::string;
using std::bitset;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#ifdef LOCAL
#define dbg(as...) {\
	string _cur, _loc;\
	std::stringstream _ss(#as);\
	vector<string> _v;\
	while (getline(_ss,_cur, ',')) {\
		while (count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
			getline(_ss, _loc, ',');\
			_cur += ',' + _loc;\
		}\
		_v.pb(_cur);\
	}\
	err(_v.begin(), as);\
}
#else
#define dbg(as...) {}
#endif

template<typename T> void err(vector<string>::iterator it, T a) {
	cerr << *it << " = " << a << '\n';
}

template <typename T, typename...Ts>
void err(vector<string>::iterator it, T a, Ts...as) {
	cerr << *it << " = " << a << ',';
	err(++it, as...);
}

struct init{
	init() {
		std::iostream::sync_with_stdio(0);
		cin.tie(0);
		cout << std::fixed << std::setprecision(10);
		cerr << std::fixed << std::setprecision(3);
	}
} init;

const int MAXN = 5e3 + 2, INF = 1e9;
#define int ll
int a[MAXN], b[MAXN], x[MAXN], y[MAXN];
int next[MAXN][MAXN + MAXN];
int sum[MAXN];

pair<int, vector<int>>
// void
 solve2(int n, int m) {
	for (int i = 1; i <= m; ++i) {
		sum[i] = sum[i - 1] + y[i];
	}

	for (int i = 1; i <= n + m; ++i) {
		next[m + 1][i] = m;
	}

	for (int i = m; i >= 1; --i) {
		for (int j = 1; j <= n + m; ++j) {
			next[i][j] = next[i + 1][j];
		}
		next[i][b[i]] = i - 1;
	}

	int ans = 0;
	vector<int> wans = {0, 0, 0, 0};
	for (int l1 = 1; l1 <= n; ++l1) {
		for (int l2 = 1; l2 <= m; ++l2) {
			int suma = 0; 
			int r2 = m;
			for (int r1 = l1; r1 <= n; ++r1) {
				suma += x[r1];
				r2 = min(r2, next[l2][a[r1]]);
				if (r2 < l2) break;
				int sumb = sum[r2] - sum[l2 - 1];
				int pot = suma + sumb;
				dbg(l1, r1, suma, l2, r2, sumb, pot)
				if (ans < pot) {
					ans = pot;
					wans = {l1, r1, l2, r2};
				}
			} 
		}
	}

	int pot = std::accumulate(x + 1, x + n + 1, 0);
	if (ans < pot) {
		ans = pot;
		wans = {1, n, 0, 0};
	} 
	pot = std::accumulate(y + 1, y + m + 1, 0);
	if (ans < pot) {
		ans = pot;
		wans = {0, 0, 1, m};
	}
	cout << ans << '\n' << wans[0] << ' ' << wans[1] << '\n' << wans[2] << ' ' << wans[3] << '\n';
	return {ans, wans};
}

pair<int, vector<int>>
// void
 solve1(int n, int m) {
	int ans = 0;
	b[m + 1] = 0;
    vector<int> wans = {0, 0, 0, 0};
    for (int l1 = 1; l1 <= n; ++l1) {
        vector<char> used(n + m + 2);
        used[0] = 1;
        int pot = 0;
        for (int r1 = l1; r1 <= n; ++r1) {
            used[a[r1]] = 1;
            pot += x[r1];
            dbg(l1, r1, pot);
            for (int l2 = 1; l2 <= m; ++l2) {
                for (int r2 = l2; r2 <= m + 1; ++r2) {
                    if (used[b[r2]]) {
                        for (r2 -= 1; r2 >= l2; --r2) {
                            used[b[r2]] = 0;
                            pot -= y[r2];
                        }
                        break;
                    }
                    used[b[r2]] = true;
                    pot += y[r2];
                    dbg(l1, r1, l2, r2, pot);
                    if (pot > ans) {
                        ans = pot;
                        wans = {l1, r1, l2, r2};
                    }
                }
            }
        }
    }
 
    int pot = std::accumulate(x + 1, x + n + 1, 0);
    if (ans < pot) {
        ans = pot;
        wans = {1, n, 0, 0};
    } 
    pot = std::accumulate(y + 1, y + m + 1, 0);
    if (ans < pot) {
        ans = pot;
        wans = {0, 0, 1, m};
    }
 
    // cout << ans << '\n' << wans[0] << ' ' << wans[1] << '\n' << wans[2] << ' ' << wans[3] << '\n';
	return {ans, wans};
 
}

int32_t main() {
	// while (1) {
		int n = rand() % 3 + 1, m = rand() % 3 + 1;
		cin >> n >> m;
		dbg(n, m);
		// vector<char> ua(n + m + 1, 0);
		for (int i = 1; i <= n; ++i){
			// do {a[i] = rand() % (n + m) + 1;} while (ua[a[i]]);
			// ua[a[i]] = 1;
			// dbg(a[i]);
			cin >> a[i];
		}
		for (int i = 1; i <= n; ++i){
			// x[i] = rand() % INF + 1;
			// dbg(x[i]);
			cin >> x[i];
		}
		vector<char> ub(n + m + 1, 0);
		for (int i = 1; i <= m; ++i){
			// do {b[i] = rand() % (n + m) + 1;} while (ub[b[i]]);
			// ub[b[i]] = 1;
			// dbg(b[i]);
			cin >> b[i];
		}
		for (int i = 1; i <= m; ++i) {
			// y[i] = rand() % INF + 1;
			// dbg(y[i]);
			cin >> y[i];
		}
		solve2(n, m);
		// if (n <= 100 && m <= 100) solve1(n, m);
		// else solve2(n, m);
		// auto xx = solve1(n, m);
		// auto yy = solve2(n, m);
		// if (xx.ff != yy.ff) {
			// dbg(xx.ff);
			// for (int i : xx.ss) dbg(i);
			// dbg(yy.ff);
			// for (int i : yy.ss) dbg(i);
			// break;
		// }
	// }

	return 0;
}