#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <string>
#include <stack>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ldouble;

vector<int> V;
int used[35];
int timer = 0;
int N;


int f() {
	timer++;
	int ans = 0;
	for (int i = 0; i < N - 1; i++) {
		int j = 30;
		while (j >= 0 && int((V[i] & (1 << j)) == 0) == int((V[i + 1] & (1 << j)) == 0))
			j--;
		if (j != -1) {
			if (used[j] == timer) {
				if (((V[i] ^ ans) & (1 << j)) == 0)
					continue;
				return -1;
			}
			used[j] = timer;
			if (((V[i]) & (1 << j)) != 0)
				ans |= (1 << j);
		}
	}
	return ans;
}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout);
#endif

	cin >> N;

	for (int i = 0; i < N; i++) {
		int a;
		scanf("%d", &a);
		V.push_back(a);
	}

	cout << f() << "\n";

	int M;
	cin >> M;
	for (int i = 0; i < M; i++) {
		int a, v;
		scanf("%d%d", &a, &v);
		V[a - 1] = v;
		cout << f() << "\n";
	}

	return 0;
}