#include <bits/stdc++.h>

#define mp make_pair

typedef std::pair<int, int> pii;

void get_ans(int n, int* x, int* y, std::vector<int> &obl)
{
    int is_end = 0;
    int now = 1;
    while (!is_end)
    {
        std::cout << "? 3 " << (obl[0] + 1) << " " << (obl[now] + 1) << " " << (obl[now + 1] + 1) << std::endl;
        std::string res;
        std::cin >> res;
        is_end = res == "Yes";
        ++now;
    }    
    --now;
    is_end = 0;
    int v0 = obl[0], v1 = obl[now], v2 = obl[now + 1];
    while (!is_end)
    {
        int v_in = -1;
        for (int i = 0; i < n; ++i)
        {
            if (i != v0 && i != v1 && i != v2)
            {
                long long int sign1 = (long long int)(x[v2] - x[v0]) * (y[i] - y[v0]) - (long long int)(x[i] - x[v0]) * (y[v2] - y[v0]);
                long long int sign2 = (long long int)(x[v1] - x[v0]) * (y[i] - y[v0]) - (long long int)(x[i] - x[v0]) * (y[v1] - y[v0]);
                long long int sign3 = (long long int)(x[v2] - x[v1]) * (y[i] - y[v1]) - (long long int)(x[i] - x[v1]) * (y[v2] - y[v1]);
                long long int sign4 = (long long int)(x[v0] - x[v1]) * (y[i] - y[v1]) - (long long int)(x[i] - x[v1]) * (y[v0] - y[v1]);
                int good1 = (sign1 > 0 && sign2 < 0) || (sign1 < 0 && sign2 > 0);
                int good2 = (sign3 > 0 && sign4 < 0) || (sign3 < 0 && sign4 > 0);
                if (good1 && good2)
                    v_in = i;
            }
        }
        if (v_in == -1)
            is_end = 1;
        else
        {
            std::cout << "? 3 " << (v0 + 1) << " " << (v1 + 1) << " " << (v_in + 1) << std::endl;
            std::string res;
            std::cin >> res;
            if (res == "Yes")
                v2 = v_in;
            else
            {
                std::cout << "? 3 " << (v0 + 1) << " " << (v2 + 1) << " " << (v_in + 1) << std::endl;
                std::string res;
                std::cin >> res;                          
                if (res == "Yes")
                    v1 = v_in;
                else
                    v0 = v_in;
            }
        }
    }
    std::cout << "! 3 " << (v0 + 1) << " " << (v1 + 1) << " " << (v2 + 1) << std::endl;
}

int x0, y_0;

bool cmp(std::pair<pii, int> a, std::pair<pii, int> b)
{
    long long int x1 = a.first.first, x2 = b.first.first;
    int y1 = a.first.second, y2 = b.first.second;    
    if (x2 == x0 && y2 == y_0)
        return false;
    return (long long int)(x1 - x0) * (y2 - y_0) - (long long int)(x2 - x0) * (y1 - y_0) >= 0;
}

int main()
{
    int n;
    std::cin >> n;
    int x[n], y[n];
    std::pair<pii, int> arr[n];
    pii minp = std::mp(1e9 + 1, 1e9 + 1);
    for (int i = 0; i < n; ++i)
    {
        std::cin >> x[i] >> y[i];
        arr[i] = std::mp(std::mp(x[i], y[i]), i);        
        minp = std::min(minp, arr[i].first);
    }    
    x0 = minp.first;
    y_0 = minp.second;
    std::sort(arr, arr + n, cmp);
    std::stack<int> st;
    st.push(arr[0].second);
    for (int i = 1; i < n; ++i)
    {
        int is_end = 0;
        int num = arr[i].second;
        while (st.size() >= 2 && !is_end)
        {
            int num1 = st.top();
            st.pop();
            int num2 = st.top();
            if ((long long int)(x[num] - x[num1]) * (y[num1] - y[num2]) - (long long int)(x[num1] - x[num2]) * (y[num] - y[num1]) < 0)
            {
                is_end = 1;
                st.push(num1);
            }             
        }
        st.push(num);
    }
    std::vector<int> obl;
    while (st.size() > 0)
    {
        obl.push_back(st.top());
        st.pop();
    }
    int q;
    std::cin >> q;
    for (int i = 0; i < q; ++i)
        get_ans(n, x, y, obl);
    return 0;
}