#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
typedef long long ll;
using namespace std;
struct edge {
    ll t, l, u;
    edge(ll _t = 0, ll _l = 0, ll _u = 0) {
        t = _t;
        l = _l;
        u = _u;
    }
};
const int N = 1e6;
int n, m;
vector <edge> v[N];
vector <vector <ll>> dp[N];
vector <ll> mxpref[N];
vector <ll> mxsuf[N];
ll gmx[N];
ll d[N];
vector <ll> pref[N];
unordered_map <int, int> g[N];
int q[N];
bool can[N];
ll inf = 2e18;
unordered_map <int, int> z[N];
bool comp(int x, int y) {
    return d[x] > d[y];
}
int main() {
    srand(time(NULL));
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int s, cur;
        cin >> s >> cur;
        cur--;
        g[i].insert(mp(cur, 0));
        pref[i].pb(0);
        for (int j = 0; j < s; j++) {
            int x, y;
            cin >> x >> y;
            y--;
            v[cur].pb(edge(i, x, y));
            z[cur].insert(mp(i, v[cur].size() - 1));
            vector <ll> r;
            for (int k = 0; k < s - j; k++) r.pb(0);
            dp[cur].pb(r);
            cur = y;
            g[i].insert(mp(cur, j + 1));
            pref[i].pb(pref[i][pref[i].size() - 1] + x);
        }
    }
    fill(d, d + n, inf);
    d[0] = 0;
    set <pair <int, int> > s;
    for (int i = 0; i < n; i++) s.insert(mp(d[i], i));
    while (s.size() > 0) {
        auto it = *(s.begin());
        if (it.first == inf) break;
        for (edge j: v[it.second]) {
            if (d[j.u] > d[it.second] + j.l) {
                s.erase(mp(d[j.u], j.u));
                d[j.u] = d[it.second] + j.l;
                s.insert(mp(d[j.u], j.u));
            }
        }
        s.erase(it);
    }
    fill(can, can + n, false);
    can[n - 1] = true;
    for (int i = 0; i < n; i++) q[i] = i;
    sort(q, q + n, comp);
    for (int i = 0; i < n; i++) {
            //cout << q[i] << endl;
        for (edge j: v[q[i]]) {
            if (can[j.u] && d[j.u] == d[q[i]] + j.l) can[q[i]] = true;
        }
        if (!can[q[i]]) continue;
        for (int j = 0; j < v[q[i]].size(); j++) {
            edge k = v[q[i]][j];
            if (can[k.u] && d[k.u] == d[q[i]] + k.l) {
                if (z[k.u].find(k.t) == z[k.u].end()) {
                        dp[q[i]][j][0] = max(dp[q[i]][j][0], mxpref[k.u][v[k.u].size()] + k.l * k.l);
                        //cout << q[i] << " " <<  dp[q[i]][j][0] << endl;
                }
                else {
                        //cout << q[i] << endl;
                    dp[q[i]][j][0] = max(dp[q[i]][j][0], max(mxpref[k.u][z[k.u][k.t]], mxsuf[k.u][z[k.u][k.t] + 1]) + k.l * k.l);
                    //cout << dp[q[i]][j][0] << endl;
                    for (int r = 0; r < dp[k.u][z[k.u][k.t]].size(); r++) {
                            if (dp[k.u][z[k.u][k.t]][r] == 0) break;
                        dp[q[i]][j][r + 1] = max(dp[q[i]][j][r + 1], dp[k.u][z[k.u][k.t]][r] + k.l * k.l + 2 * k.l * (pref[k.t][g[k.t][q[i]] + r + 2] - pref[k.t][g[k.t][q[i]] + 1]));
                        //cout << dp[k.u][z[k.u][k.t]][r] << " " << dp[q[i]][j][r + 1] << endl;
                    }
                }
            }
        }
        mxpref[q[i]].pb(0);
        for (int j = 0; j < v[q[i]].size(); j++) {
            ll cur = 0;
            if (can[v[q[i]][j].u] && d[v[q[i]][j].u] == d[q[i]] + v[q[i]][j].l) for (int k = 0; k < dp[q[i]][j].size(); k++) {
                cur = max(cur, dp[q[i]][j][k]);
            }
            mxpref[q[i]].pb(max(mxpref[q[i]][j], cur));
        }
        mxsuf[q[i]].resize(mxpref[q[i]].size());
        mxsuf[q[i]][v[q[i]].size()] = 0;
        for (int j = (int)v[q[i]].size() - 1; j >= 0; j--) {
            ll cur = 0;
            if (can[v[q[i]][j].u] && d[v[q[i]][j].u] == d[q[i]] + v[q[i]][j].l) for (int k = 0; k < dp[q[i]][j].size(); k++) {
                cur = max(cur, dp[q[i]][j][k]);
            }
            mxsuf[q[i]][j] = max(mxsuf[q[i]][j + 1], cur);
        }
        //cout << q[i] << " " << mxpref[q[i]][mxpref[q[i]].size() - 1] << endl;
    }
    ll ans = 0;
    for (int j = 0; j < v[0].size(); j++) {
        for (int i = 0; i < dp[0][j].size(); i++) ans = max(ans, dp[0][j][i]);
    }
    cout << d[n - 1] << " "  << ans << endl;
    return 0;
}
