#include <iostream>
#include <vector>
#include <string>
#include <cmath>


using namespace std;


vector <string> a;
int lol[40][2];;


string cs(int n, char c) {
	string res = "";
	for (int i = 0; i < n; ++i) {
		res += c;
	}

	return res;
}


string get_s(int n) {
	if (!n) {
		return "0";
	}

	char c;
	if (n % 2) {
		c = '1';
	}
	else {
		c = '0';
	}

	return get_s(n / 2) + c;
}


pair <int, int> get_lul(string a, string b) {
	for (int i = 0; i < 40; ++i) {
		if (a[i] != b[i]) {
			if (a[i] == '0') {
				return{ i, 0 };
			}
			else {
				return{ i, 1 };
			}
		}
	}
}


int int_by_str() {
	int res = 0;
	for (int i = 0; i < 40; ++i) {
		if (lol[i][1]) res += pow(2, 40 - i - 1);
	}

	return res;
}


bool check() {
	for (int i = 0; i < 40; ++i) {
		if (lol[i][0] * lol[i][1]) {
			return false;
		}
	}

	return true;
}


int main() {
	int n;
	cin >> n;

	int new_elem;
	vector <pair <int, int> > lul(n - 1);

	for (int i = 0; i < n; ++i) {
		cin >> new_elem;
		string new_str = get_s(new_elem);
		new_str = cs(40 - new_str.size(), '0') + new_str;
		a.push_back(new_str);
	}

	pair <int, int> lol_pair;
	for (int i = 0; i < n - 1; ++i) {
		lul[i] = get_lul(a[i], a[i + 1]);
		lol[lul[i].first][lul[i].second]++;
	}

	if (!check()) {
		cout << -1 << endl;
	}
	else {
		cout << int_by_str() << endl;
	}

	int q;
	int p, x;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		cin >> p >> x;
		p--;
		a[p] = get_s(x);
		a[p] = cs(40 - a[p].size(), '0') + a[p];
		if (p < n - 1) {
			lol[lul[p].first][lul[p].second]--;

			lul[p] = get_lul(a[p], a[p + 1]);
			lol[lul[p].first][lul[p].second]++;
		}
		
		if (p) {
			lol[lul[p - 1].first][lul[p - 1].second]--;

			lul[p - 1] = get_lul(a[p - 1], a[p]);
			lol[lul[p - 1].first][lul[p - 1].second]++;
		}


		if (!check()) {
			cout << -1 << endl;
		}
		else {
			cout << int_by_str() << endl;
		}
	}

	return 0;
}