#include <iostream>
#include <vector>

using namespace std;

const long long unit_cost = (long long)1e9;

int main() {
    int n, a;
    cin >> n >> a;
    vector<vector<long long>> d(a + 1, vector<long long>(a + 1, 0));
    vector<int> l(n), r(n), c(n);
    for (int i = 0; i < n; i++)
        cin >> l[i] >> r[i] >> c[i];
    long long ans = 0;
    for (int i = 0; i <= a; i++) {
        for (int j = 0; j <= a; j++) {
            ans = max(ans, d[i][j]);
            if (i == a || j == a) continue;
            for (int k = 0; k < n; k++) {
                if (j + r[k] > a) continue;
                for (int cnt = l[k]; cnt <= r[k]; cnt++) {
                    d[i + 1][j + cnt] = max(d[i + 1][j + cnt], d[i][j] + unit_cost * l[k] - c[k]);
                }
            }
        }
    }
    cout << ans << endl;
    return 0;
}