#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

vector<vector<pair<ll, ll> > > s;
vector<vector<pair<ll, ll> > > lst;
const ll INF = 1e9 + 7;

pair<vector<ll>, vector<ll> > dij(ll st){
    ll n = s.size();
    vector<ll> answer1(n, INF);
    vector<ll> answer2(n, INF);
    answer1[st] = 0;
    answer2[st] = 0;
    set<pair<ll, ll> > mini;
    for (ll i = 0; i < n; i++)
        mini.insert(make_pair(answer1[i], i));
    while (mini.size() > 0){
        pair<ll, ll> v = *(mini.begin());
        mini.erase(v);
        swap(v.first, v.second);
        for (pair<ll, ll> u : lst[v.first]){
            if (answer1[u.first] + u.second <= v.second)
                answer2[v.first] = max(answer2[v.first], answer2[u.first] + u.second * u.second);
        }
        for (pair<ll, ll> u : s[v.first]){
            if (answer1[u.first] > answer1[v.first] + u.second){
                mini.erase(make_pair(answer1[u.first], u.first));
                answer1[u.first] = answer1[v.first] + u.second;
                answer2[u.first] = answer2[v.first] + u.second * u.second;
                mini.insert(make_pair(answer1[u.first], u.first));
            }
            if (answer1[u.first] = answer1[v.first] + u.second)
                answer2[u.first] = max(answer2[u.first], answer2[v.first] + u.second * u.second);
        }
    }
    return make_pair(answer1, answer2);
}


int main()
{
    #ifdef ONLINE_JUDGE
        freopen("test.in", "r", stdin);
    #endif // ONLINE_JUDGE
    ll n, m;
    cin >> n >> m;
    s.resize(n);
    lst.resize(n);
    for (ll i = 0; i < m; i++){
        ll k;
        cin >> k;
        ll a, b, c;
        cin >> a;
        for (ll j = 0; j < k; j++){
            cin >> b >> c;
            s[a - 1].push_back(make_pair(c - 1, b));
            lst[c - 1].push_back(make_pair(a - 1, b));
            a = c;
        }
    }
    pair<vector<ll>, vector<ll> > dist = dij(0);
    cout << dist.first[n - 1] << " " << dist.second[n - 1] << endl;
    return 0;
}
