#include <bits/stdc++.h>

#define ll long long

using namespace std;

const int maxN = 10000;

int arr1[maxN];
int brr1[maxN];
int arr2[maxN];
int brr2[maxN];

bool used[maxN * 2];

int main()
{
    #ifdef DEBUG
        freopen("in.in", "r", stdin);
        //freopen("in.out", "w", stdout);
    #endif // DEBUG

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    for(int i = 0; i < n; i++) cin >> arr1[i];
    for(int i = 0; i < n; i++) cin >> brr1[i];
    for(int i = 0; i < m; i++) cin >> arr2[i];
    for(int i = 0; i < m; i++) cin >> brr2[i];

    ll ans = -1;
    int la1, la2, ra1, ra2;
    for(int l1 = 0; l1 < n; l1++)
    {
        ll sum1 = 0, sum2 = 0;
        for(int r1 = l1; ; r1++)
        {
            int l2 = 0, r2 = 0;
            while(l2 < m)
            {
                if(r2 < l2) r2 = l2;

                while(r2 < m && !used[arr2[r2]]) sum2 += brr2[r2], used[arr2[r2]] = 1, r2++;

                if(ans < sum1 + sum2)
                {
                    ans = sum1 + sum2;
                    la1 = l1;
                    ra1 = r1;
                    la2 = l2;
                    ra2 = r2;
                }

                if(r2 > l2)
                {
                    sum2 -= brr2[l2];
                    used[arr2[l2]] = 0;
                }

                l2++;
            }


            if(r1 == n || used[arr1[r1]])
            {
                for(int k = r1 - 1; k >= l1; k--) used[arr1[k]] = 0;
                break;
            }
            sum1 += brr1[r1];
            used[arr1[r1]] = 1;
        }
    }

    cout << ans << endl;
    if(ra1 - la1 > 0) cout << la1 + 1 << " " << ra1 << endl;
    else cout << "0 0" << endl;

    if(ra2 - la2 > 0) cout << la2 + 1 << " " << ra2 << endl;
    else cout << "0 0" << endl;

    return 0;
}
