#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <map>
#include <string>
#include <set>
#include<math.h>


using namespace std;

typedef long long ll;

#define X first
#define Y second

const int MAXN = (int)1e5 + 7;
const double eps = (double)1e-5;


int n, m;

vector<pair<int, int>> g[MAXN];

vector<pair<int, int>> gg[MAXN];

int d[MAXN];

bool used[MAXN];

int mini[1003][1003];

vector<int> p[MAXN];

int dp[MAXN];

void dij(int u)
{
	set<pair<int, int>> q;
	used[u] = 1;
	d[u] = 0;
	q.insert({ d[u], u });
	while (q.size())
	{
		int v = q.begin()->Y;
		q.erase(q.begin());
		for (int i = 0; i < g[v].size(); i++)
		{
			int to = g[v][i].X;
			int len = g[v][i].Y;
			if (d[to] > d[v] + len)
			{
				q.erase({ d[to], to });
				d[to] = d[v] + len;
				p[to].clear();
				p[to].push_back(v);
				q.insert({ d[to], to });
			}
			else
				if (d[to] == d[v] + len)
					p[to].push_back(v);
		}
	}
}

void dfs(int v, int q)
{
	if (dp[v] > q)
		return;
	dp[v] = max(dp[v], q);
	for (int i = 0; i < gg[v].size(); i++)
	{
		int to = gg[v][i].X;
		if (dp[to] < q + gg[v][i].Y * gg[v][i].Y)
			dfs(to, q + gg[v][i].Y * gg[v][i].Y);
	}
}


int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> m;
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= n; j++)
			mini[i][j] = (int)1e9 + 7;

	for (int i = 0; i < m; i++)
	{
		int cnt, x, y, z;
		cin >> cnt;
		cin >> x >> y >> z;
		g[x].push_back({ z, y });
		mini[x][z] = min(mini[x][z], y);
	}
	for (int i = 1; i <= n; i++)
		d[i] = (int)1e9 + 7;
	dij(1);
	cout << d[n];
	for (int i = 1; i <= n; i++)
	{
		for (int j = 0; j < p[i].size(); j++)
		{
			int from = p[i][j];
			gg[from].push_back({ i, mini[from][i] });
		}
	}

	dfs(1, 0);
	cout << ' ' << dp[n];

}