#include <iostream>
#include <vector>
#include <cassert>
#include <string>
using namespace std;
struct p {
	long long x, y;
	p(){}
	p(p a, p b) {
		x = b.x - a.x;
		y = b.y - a.y;
	}
	long long operator*(p a) {
		return x * a.x + y * a.y;
	}
	long long operator%(p a) {
		return x * a.y - y * a.x;
	}
};

int main()
{
	int n;
	cin >> n;
	vector<p> g(n);
	for (int i = 0; i < n; ++i)
		cin >> g[i].x >> g[i].y;
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		bool f = true;
		for (int i = 0; i < n && f; ++i) {
			for (int j = i + 1; j < n && f; ++j) {
				for (int k = j + 1; k < n && f; ++k) {
					bool nf = true;
					for (int l = 0; l < n && nf; ++l) {
						if (l != i && l != j && l != k) {
							p oa(g[l], g[i]), ob(g[l], g[j]), oc(g[l], g[k]);
							double sum = atan2(oa % ob, oa * ob) + atan2(ob % oc, ob * oc) + atan2(oc % oa, oc * oa);
							if (abs(sum) > 1)
								nf = false;
						}
					}
					if (nf) {
						cout << "? 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
						string ans;
						cin >> ans;
						if (ans == "Yes") {
							cout << "! 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
							f = false;
						}
					}
				}
			}
		}
	}
}
