/** БАЖНОЕ РЕШЕНИЕ. ИСПРАВЛЕНИЮ НЕ ПОДЛЕЖИТ. ЛЕЖИТ ЗДЕСЬ КАК ДАНЬ ИСТОРИИ В ПАМЯТЬ О КРИВЫХ ГРИШИНЫХ ЛАПАХ */

#include <bits/stdc++.h>

using namespace std;
const int MAXN = 1007;
vector<int> x, y;
long long area(int a, int b, int c)
{
	return 1LL * (x[b] - x[a]) * (y[c] - y[a]) - 1LL * (x[c] - x[a]) * (y[b] - y[a]);
}
bool cmp(int x, int y)
{
	return area(0, x, y) >= 0;
}
int calcLeft(vector<int> &p, int x, int y)
{
	int res1 = 0, res2 = 0;
	for (int i = 0; i < (int)p.size(); i++)
	{
		long long carea = area(x, y, p[i]);
		if (carea > 0) res1++;
		if (carea < 0) res2++;
	}
	return min(res1, res2);
}
vector<int> convexHull(vector<int> a)
{
	int minX = x[a[0]], minY = y[a[0]];
	for (int i = 0; i < (int)a.size(); i++)
	{
		minX = min(minX, x[a[i]]);
		minY = min(minY, y[a[i]]);
	}
	for (int i = 0; i < (int)a.size(); i++)
	{
		x[a[i]] -= minX;
		y[a[i]] -= minY;
	}
	sort(a.begin(), a.end(), cmp);
	vector<int> st;
	for (int i = 0; i < (int)a.size(); i++)
	{
		while ((int)st.size() >= 2 && area(st[(int)st.size() - 2], st[(int)st.size() - 1], a[i]) <= 0) st.pop_back();
		st.push_back(a[i]);
	}
	for (int i = 0; i < (int)a.size(); i++)
	{
		x[a[i]] += minX;
		y[a[i]] += minY;
	}
	return st;
}
int main()
{
	int n;
	cin >> n;
	x.resize(n + 1);
	y.resize(n + 1);
	for (int i = 1; i <= n; i++)
	{
		cin >> x[i] >> y[i];
	}
	int q;
	cin >> q;
	for (int qq = 1; qq <= q; qq++)
	{
    	vector<int> active;
    	for (int i = 1; i <= n; i++)
    	{
    		active.push_back(i);
    	}
    	while ((int)active.size() > 3)
    	{
    		int u = active[0], v = active[1];
    		while (calcLeft(active, u, v) == 0) v++;
    		vector<int> goLeft, goRight;
    		for (int i = 0; i < (int)active.size(); i++)
    		{
    			long long curArea = area(u, v, active[i]);
    			if (curArea >= 0)
    			{
    				goLeft.push_back(active[i]);
    			}
    			if (curArea <= 0)
    			{
    				goRight.push_back(active[i]);
    			}
    		}
    		vector<int> leftHull = convexHull(goLeft);
    		cout << "? " << leftHull.size() << " ";
    		for (int i = 0; i < (int)leftHull.size(); i++)
    		{
    			cout << leftHull[i] << " ";
    		}
    		cout << endl;
    		string ans;
    		cin >> ans;
    		if (ans == "Yes")
    		{
    			active = goLeft;
    		}
    		else
    		{
    			active = goRight;
    		}
    	}
    	cout << "! 3 " << active[0] << " " << active[1] << " " << active[2] << endl;
	}
	return 0;
}
