#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1000000;
int n;
int a[MAXN];
const int MAXB = 30;

int cnt[2][MAXB];

int bit(int x, int b) {
    return (x >> b) & 1;
}

void rem(int ind) {
    int b = MAXB - 1;
    while (b >= 0 && bit(a[ind], b) == bit(a[ind + 1], b)) {
        b--;
    }

    if (b != -1) {
        int b1 = bit(a[ind], b);
        int b2 = bit(a[ind + 1], b);

        if (b1 < b2) {
            cnt[0][b]--;
        } else {
            cnt[1][b]--;
        }
    }
}

void add(int ind) {
    int b = MAXB - 1;
    while (b >= 0 && bit(a[ind], b) == bit(a[ind + 1], b)) {
        b--;
    }

    if (b != -1) {
        int b1 = bit(a[ind], b);
        int b2 = bit(a[ind + 1], b);

        if (b1 < b2) {
            cnt[0][b]++;
        } else {
            cnt[1][b]++;
        }
    }
}

int solve() {
    int ans = 0;
    for (int b = 0; b < MAXB; b++) {
        if (cnt[0][b] > 0 && cnt[1][b] > 0) {
            return -1;
        }
        if (cnt[0][b] == 0 && cnt[1][b] == 0) {
            continue;
        }
        if (cnt[0][b] > 0) {
            continue;
        } else {
            ans |= 1 << b;
        }
    }
    return ans;
}

int main() {
    scanf("%d", &n);
    for (int i = 0; i < n; i++) {
        scanf("%d", &a[i]);
    }

    for (int i = 0; i < n - 1; i++) {
        add(i);
    }

    cout << solve() << '\n';

    int q;
    scanf("%d", &q);
    for (int i = 0; i < q; i++) {
        int p, v;
        scanf("%d%d", &p, &v);
        p--;
        if (p != 0) {
            rem(p - 1);
        }
        if (p != n - 1) {
            rem(p);
        }

        a[p] = v;

        if (p != 0) {
            add(p - 1);
        }
        if (p != n - 1) {
            add(p);
        }

        cout << solve() << '\n';
    }

    return 0;
}