#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<set>

using namespace std;
#define x first
#define y second
int vect(pair<int, int> a, pair<int, int> b)
{
    return a.x * b.y - a.y * b.x;
}
bool cmp(pair<pair<int, int>, int> a, pair<pair<int, int>, int> b)
{
    int d = vect(a.x, b.x);
    if (d == 0)
    {
        return a.x < b.x;
    }
    else return d > 0;
}

int area(vector<pair<pair<int, int>, int>> &v)
{
    int ans = 0;
    int n = v.size();
    for (int i = 0; i < n; ++i)
    {
        int j = (i + 1) % n;
        ans += abs(vect(v[i].x, v[j].x));
    }
    return ans;
}

int main()
{
    int n;
    cin >> n;
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> v[i].x >> v[i].y;
    }
    int q;
    cin >> q;
    for (int i2 = 0; i2 < q; ++i2)
    {
        vector<int> bst;
        int ar = -1;
        for (int i3 = 0; i3 < (1 << n); ++i3)
        {
            int i1 = i3;
            vector<pair<pair<int, int>, int>> vt;
            for (int j = 0; j < n; ++j)
            {
                if (i1 % 2 == 1) vt.push_back({v[j], j});
                i1 /= 2;
            }
            if (vt.size() < 3) continue;
            int mn = 0;
            for (int i = 0; i < vt.size(); ++i)
            {
                if (vt[i] < vt[mn]) mn = i;
            }
            pair<int, int> p = vt[mn].x;
            for (int i = 0; i < vt.size(); ++i)
            {
                vt[i].x.x -= p.x;
                vt[i].x.y -= p.y;
            }
            sort(vt.begin(), vt.end(), cmp);
            cout << "? " << vt.size() << " ";
            for (int i = 0; i < vt.size(); ++i)
            {
                cout << vt[i].y + 1 << " ";
            }
            cout << endl;
            string rs;
            cin >> rs;
            if (rs == "Yes")
            {
                if (ar == -1 || ar > area(vt))
                {
                    ar = area(vt);
                    bst.clear();
                    for (int i = 0; i < vt.size(); ++i) bst.push_back(vt[i].y);
                }
            }
        }
        cout << "! " << bst.size() << " ";
        for (int i = 0; i < bst.size(); ++i)
        {
            cout << bst[i] + 1 << " ";
        }
        cout << endl;
    }
}
