#include <bits/stdc++.h>

#define pub push_back
#define ll long long
#define mp make_pair
#define all(a) a.begin(), a.end()
#define x first
#define y second

const int INF = (int)1e9 + 7;
const ll LINF = (ll)4e18 + 7;

using namespace std;

struct reb{
    int to, c, num;
    reb() {}
    reb(int x1, int y1, int c1){
        to = x1;
        c = y1;
        num = c1;
    }
};

const int dd = 1007;

int n, m;
vector<reb> g[dd];
vector<reb> g2[dd];
vector<reb> gr[dd];
int d[2][dd];
ll dp[dd];
set<pair<int, int> > se;

void relax1(int v){
    for (auto to : g[v]){
        if (d[0][to.to] > d[0][v] + to.c){
            se.erase(mp(d[0][to.to], to.to));
            d[0][to.to] = d[0][v] + to.c;
            se.insert(mp(d[0][to.to], to.to));
        }
    }
}

void dij1(){
    for (int i = 0; i < n; i++) d[0][i] = INF;
    d[0][0] = 0;
    se.insert(mp(d[0][0], 0));
    while(se.size()){
        auto now = *se.begin();
        se.erase(se.begin());
        relax1(now.y);
    }
}

void relax2(int v){
    for (auto to : gr[v]){
        if (d[1][to.to] > d[1][v] + to.c){
            se.erase(mp(d[1][to.to], to.to));
            d[1][to.to] = d[1][v] + to.c;
            se.insert(mp(d[1][to.to], to.to));
        }
    }
}

void dij2(){
    for (int i = 0; i < n; i++) d[1][i] = INF;
    d[1][n - 1] = 0;
    se.insert(mp(0, n - 1));
    while(se.size()){
        auto now = *se.begin();
        se.erase(se.begin());
        relax2(now.y);
    }
}

void dfs(int v){
    dp[v] = -LINF;
    if (v == n - 1) dp[v] = 0;
    for (auto to : g2[v]) dfs(to.to), dp[v] = max(dp[v], dp[to.to] + (ll)to.c * to.c);
}

vector<pair<pair<int, int>, int> > re[dd];

const bool is_testing = 0;
int main(){
    srand('W' + 'I' + 'N');
    if (is_testing){
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    } else {

    }
    scanf("%d %d", &n, &m);
    for (int i = 0; i < m; i++){
        int sz;
        scanf("%d", &sz);
        int last;
        scanf("%d", &last); last--;
        for (int j = 0; j < sz; j++){
            int vv, tt;
            scanf("%d %d", &tt, &vv);
            vv--;
            g[last].pub(reb(vv, tt, i));
            gr[vv].pub(reb(last, tt, i));
            re[i].pub(mp(mp(last, vv), tt));
            last = vv;
        }
    }
    dij1(); dij2();
    for (int i = 0; i < m; i++){
        vector<pair<int, int> > was;
        for (int j = (int)re[i].size() - 1; j >= 0; j--){
            int a = re[i][j].x.x, b = re[i][j].x.y, c = re[i][j].y;
            if (d[0][a] + c + d[1][b] == d[0][n - 1]){
                was.pub(mp(b, c));
                int sum = 0;
                for (int s = (int)was.size() - 1; s >= 0; s--)
                    sum += was[s].y, g2[a].pub(reb(was[s].x, sum, i));
            } else was.clear();
        }
    }
    int aha = 0;
    for (int i = 0; i < n; i++) aha += g2[i].size();
    if (aha > 1e3) assert(0);
    dfs(0);
    cout << d[0][n - 1] << ' ' << dp[0];
}
