#include <bits/stdc++.h>

#define ll long long
#define all(a) a.begin(), a.end()

using namespace std;

struct bigInt{
    string s;
    bool zn;
    bigInt() { s = "", zn = 0; }
    bigInt(string ss, bool zz) { s = ss, zn = zz; }

    void read(){
        cin >> s;
        if (s[0] == '-'){
            reverse(all(s));
            s.pop_back();
            reverse(all(s));
            zn = 1;
        }
    }

    void print(){
        if (zn) cout << "-";
        cout << s;
    }

    bool operator< (bigInt nxt){
        if (s.size() > nxt.s.size()) return 0;
        if (s.size() < nxt.s.size()) return 1;
        return s < nxt.s;
    }

    bigInt operator- (const bigInt nxt) const {
        string ans;
        bool zn = 0;
        if (bigInt(s, zn) < nxt){
            zn = 1;
            int need = 0;
            for (int i = 1; i <= nxt.s.size(); i++){
                int c1 = 0, c2 = 0;
                if ((int)s.size() - i >= 0) c1 = s[(int)s.size() - i] - '0';
                if ((int)nxt.s.size() - i >= 0) c2 = nxt.s[(int)nxt.s.size() - i] - '0';
                int now = c2 - c1 - need; need = 0;
                if (now < 0) now += 10, need = 1;
                ans += (char)(now + '0');
            }
        } else {
            int need = 0;
            for (int i = 1; i <= s.size(); i++){
                int c1 = 0, c2 = 0;
                if ((int)s.size() - i >= 0) c1 = s[(int)s.size() - i] - '0';
                if ((int)nxt.s.size() - i >= 0) c2 = nxt.s[(int)nxt.s.size() - i] - '0';
                int now = c1 - c2 - need; need = 0;
                if (now < 0) now += 10, need = 1;
                ans += (char)(now + '0');
            }
        }
        while(ans.size() && ans.back() == '0') ans.pop_back();
        reverse(all(ans));
        return bigInt(ans, zn);
    }

    bigInt operator+ (const bigInt nxt) const {
        if (zn == nxt.zn){
            bool zna = 0;
            string ans;
            if (zn) zna = 1;
            int d = 0;
            int len = max((int)s.size(), (int)nxt.s.size());
            for (int i = 1; i <= len; i++){
                int c1 = 0, c2 = 0;
                if ((int)s.size() - i >= 0) c1 = s[(int)s.size() - i] - '0';
                if ((int)nxt.s.size() - i >= 0) c2 = nxt.s[(int)nxt.s.size() - i] - '0';
                int now = c1 + c2 + d; d = 0;
                if (now > 9) d = 1, now -= 10;
                ans += (char)('0' + now);
            }
            if (d) ans += (char)('1');
            reverse(all(ans));
            return bigInt(ans, zna);
        }
        if (zn){
            return nxt - bigInt(s, zn);
        } else {
            return bigInt(s, zn) - nxt;
        }
    }

};

bigInt a, b;

bool is_testing = 0;
int main(){
    if (is_testing){
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    } else {
        freopen("sum.in", "r", stdin);
        freopen("sum.out", "w", stdout);
    }
    a.read();
    b.read();
    (a + b).print();
}
