# include <iostream>
# include <cstdio>
# include <string>
# include <vector>
# include <algorithm>

using namespace std;

int main()
{
    freopen("sum.in", "r", stdin);
    freopen("sum.out", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    string s1, s2;
    cin >> s1 >> s2;
    vector<int> f, s;
    for (int i = 0; i < (int)s1.size(); i++)
    {
        f.push_back(s1[i] - '0');
    }
    for (int i = 0; i < (int)s2.size(); i++)
    {
        s.push_back(s2[i] - '0');
    }
    reverse(f.begin(), f.end());
    reverse(s.begin(), s.end());
    while (f.size() < s.size()) f.push_back(0);
    while (s.size() < f.size()) s.push_back(0);
    vector<int> ans(f.size(), 0);
    vector<int> per(f.size() + 1, 0);
    int n = f.size();
    for (int i = 0; i < n; i++)
    {
        ans[i] = f[i] + s[i] + per[i];
        per[i + 1] += ans[i] / 10;
        ans[i] %= 10;
    }
    if (per[n] != 0)
    {
        ans.push_back(per[n]);
    }
    reverse(ans.begin(), ans.end());
    for (int i : ans) cout << i;
    cout << "\n";
    return 0;
}
