#include <bits/stdc++.h>

#define re return
#define sz(a) (int)a.size()
#define mp make_pair
#define forn(i, n) for (int i = 0; i < n; i++)

typedef long long ll;
using namespace std;
const int ma = 1024 * 1024;

int n,q;
int v[1000000];

struct trie {
	int go[2], mi, ma;
	bool ok;
	int ps, kn;
	int h;
	set<int> term;
	trie() {
		mi = int(1e9);
		ma = -1;
		go[0] = go[1] = -1;
		ok = true;
		term.clear();
		ps = 0;
		kn = 0;
		h = 0;
	}
};

vector<trie> we;

int answer() {
	if (!we[0].ok) re -1;
	re we[0].ps;
}

void relax(int nu, int h) {
	we[nu].mi = int(1e9);
	we[nu].ma = -1;
	forn (i, 2) {
		if (we[nu].go[i] != -1 && we[we[nu].go[i]].mi < we[nu].mi)
			we[nu].mi = we[we[nu].go[i]].mi;
		if (we[nu].go[i] != -1 && we[we[nu].go[i]].ma > we[nu].ma)
			we[nu].ma = we[we[nu].go[i]].ma;
	}
	we[nu].ok = true;
	forn (i, 2)
		if (we[nu].go[i] != -1 && we[we[nu].go[i]].ok == false)
			we[nu].ok = false;
	int c = 2;
	if (we[nu].go[0] != -1 && we[nu].go[1] != -1 && 
		we[we[nu].go[0]].ma != -1 && we[we[nu].go[1]].ma != -1) {
		if (we[we[nu].go[0]].mi > we[we[nu].go[1]].ma)
			c = 1;
		else
			if (we[we[nu].go[1]].mi > we[we[nu].go[0]].ma)
			c = 0;
			else
				we[nu].ok = false;
		if ((we[we[nu].go[0]].ps ^ we[we[nu].go[1]].ps) & (
			we[we[nu].go[0]].kn & we[we[nu].go[1]].kn))
			we[nu].ok = false;
	}
	we[nu].ps = 0;
	we[nu].kn = 0;
	if (we[nu].go[0] != -1) {
		we[nu].ps |= we[we[nu].go[0]].ps;
		we[nu].kn |= we[we[nu].go[0]].kn;
	}
	if (we[nu].go[1] != -1) {
		we[nu].ps |= we[we[nu].go[1]].ps;
		we[nu].kn |= we[we[nu].go[1]].kn;
	}
	if (c == 1)
		we[nu].ps |= (1 << h);
	if (c < 2)
		we[nu].kn |= (1 << h);
}

void add_(int h, int c, int pos, int nu) {
	if (h == -1) {
		we[nu].term.insert(pos);
		if (we[nu].mi > pos)
			we[nu].mi = pos;
		if (we[nu].ma < pos)
			we[nu].ma = pos;
		we[nu].ok = true;
		re;
	}
	int ch = 0;
	if (c & (1 << h))
		ch = 1;
	if (we[nu].go[ch] == -1) {
		we.push_back(trie());
		we[nu].go[ch] = sz(we) - 1;
	}

	add_(h - 1, c, pos, we[nu].go[ch]);
	relax(nu, h);
}

void del_(int h, int c, int pos, int nu) {
	if (h == -1) {
		we[nu].term.erase(pos);
		we[nu].mi = int(1e9);
		we[nu].ma = -1;
		if (we[nu].term.begin() != we[nu].term.end()) {
			we[nu].mi = (*we[nu].term.begin());
			we[nu].ma = (*we[nu].term.rbegin());
		}
		we[nu].ok = true;
		re;
	}
	int ch = 0;
	if (c & (1 << h))
		ch = 1;
	if (we[nu].go[ch] == -1) {
		we.push_back(trie());
		we[nu].go[ch] = sz(we) - 1;
	}
	del_(h - 1, c, pos, we[nu].go[ch]);
	relax(nu, h);
	
}
int main() {
	//iostream::sync_with_stdio(0);
	scanf("%d", &n);
	we.push_back(trie());
	forn (i, n) {
		scanf("%d", &v[i]);
		add_(29, v[i], i, 0);
		cout << "\n";
	}	
	printf("%d\n", answer());
	scanf("%d", &q);
	forn (i, q) {
		int p, a;
		scanf("%d%d", &p, &a);
		p--;
		del_(29, v[p], p, 0);
		v[p] = a;
		add_(29, v[p], p, 0);
		//cout << "\n";
		printf("%d\n", answer());
	}
	return 0;
}