#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <utility>
#include <string>
using namespace std;

#define int int64_t

/*

ifstream fin("input.txt");
ofstream fout("output.txt");


ifstream fin("input.txt");
ofstream fout("output.txt");

*/


ifstream fin("input.txt");
ofstream fout("output.txt");

bool solve(char start, string &s, bool flag1, bool flag2) {
	if (s[0] != start && !flag1 || s.back() != start && !flag2)
		return false;
	vector<int> a;
	if (flag1 && s[0] != start)
		a.push_back(0);
	int i = 0;
	while (i < s.size()) {
		a.push_back(0);
		while (i < s.size() && s[i] == s[i + 1]) {
			a.back()++;
			i++;
		}
		a.back()++;
		i++;
	}
	if (flag2 && s.back() != start)
		a.push_back(0);

	int n = a.size();
	vector<pair<bool, int> > dp(n + 1);
	dp[1] = { true, a[0] };

	vector<int> sum(n + 1);
	for (int i = 0; i < n; i++)
		sum[i + 1] = sum[i] + a[i];

	for (int i = 3; i <= n; i++) {
		if (dp[i - 2].first) {
			if (dp[i - 2].second > a[i - 2] || a[i - 1] > a[i - 2])
				dp[i] = { true, sum[i] };
			else {
				dp[i] = { false, a[i - 1] - a[i - 2] + 1 };
			}
		}
		else {
			if (a[i - 1] > a[i - 2]) {
				if (a[i - 1] + a[i - 2] >= dp[i - 2].second)
					dp[i] = { true, sum[i] };
				else
					dp[i] = { false, dp[i - 2].second - (a[i - 1] + a[i - 2]) };
			}
			else {
				dp[i] = { false, max(a[i - 2] - a[i - 1] + 1, dp[i - 2].second - (a[i - 1] + a[i - 2])) };
			}
		}
	}

	return dp[n].first;
}

char dif(char c) {
	if (c == '+')
		return '-';
	else
		return '+';
}

signed main() {
	int q;
	fin >> q;
	for (int qq = 0; qq < q; qq++) {
		string s, t;
		fin >> s >> t;
		vector<int> inds1, inds2;

		for (int i = 1; i < s.size(); i++) {
			if (s[i] != s[i - 1])
				inds1.push_back(i);
		}

		for (int i = 1; i < s.size(); i++) {
			if (t[i] != t[i - 1])
				inds2.push_back(i);
		}

		int i = 0, j = 0;
		bool flag = true;
		while (i < inds2.size()) {
			while (j < inds1.size() && inds1[j] < inds2[i])
				j++;
			if (inds1[j] != inds2[i])
				flag = false;
			i++;
		}
		
		if (!flag)
			fout << "No" << endl;
		else {
			vector<string> parts;
			int i = 0, j = 0;
			inds2.push_back(t.size());
			while (i < inds2.size()) {
				parts.push_back("");
				while (j < s.size() && j < inds2[i])
					parts.back().push_back(s[j++]);
				i++;
			}

			char start = t[0];
			bool ans = true;
			for (int i = 0; i < parts.size(); i++) {
				bool flag1 = (i == 0), flag2 = (i == (int)parts.size() - 1);
				bool cur = solve(start, parts[i], flag1, flag2);
				ans = (ans & cur);
				start = dif(start);
			}

			if (ans)
				fout << "Yes" << endl;
			else
				fout << "No" << endl;
		}
	}
}