#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <utility>
#include <string>
using namespace std;

#define int int64_t

/*

ifstream fin("input.txt");
ofstream fout("output.txt");


ifstream fin("internship.in");
ofstream fout("internship.out");

*/

ifstream fin("internship.in");
ofstream fout("internship.out");

signed main() {
	int n, m;
	fin >> n >> m;
	vector<int> a(n), x(n), b(m), y(m);
	for (int i = 0; i < n; i++) {
		fin >> a[i];
		a[i]--;
	}

	for (int i = 0; i < n; i++)
		fin >> x[i];

	for (int i = 0; i < m; i++) {
		fin >> b[i];
		b[i]--;
	}

	for (int i = 0; i < m; i++)
		fin >> y[i];

	vector<int> asum(n + 1), bsum(m + 1);
	for (int i = 0; i < n; i++)
		asum[i + 1] = asum[i] + x[i];
	
	for (int i = 0; i < m; i++)
		bsum[i + 1] = bsum[i] + y[i];

	int max_sum = 0, a1, b1, a2, b2;

	for (int i1 = 0; i1 < n; i1++) {
		for (int j1 = i1; j1 <= n; j1++) {
			for (int i2 = 0; i2 < m; i2++) {
				for (int j2 = i2; j2 <= m; j2++) {
					set<int> s;
					bool is_good = true;
					for (int t = i1; t < j1; t++) {
						if (s.find(a[t]) != s.end())
							is_good = false;
						s.insert(a[t]);
					}
					for (int t = i2; t < j2; t++) {
						if (s.find(b[t]) != s.end())
							is_good = false;
						s.insert(b[t]);
					}
					if (max_sum < asum[j1] - asum[i1] + bsum[j2] - bsum[i2] && is_good) {
						max_sum = asum[j1] - asum[i1] + bsum[j2] - bsum[i2];
						a1 = i1;
						b1 = j1;
						a2 = i2;
						b2 = j2;
					}
				}
			}
		}
	}

	fout << max_sum << endl;
	if (a1 == b1) {
		a1 = -1;
		b1 = 0;
	}
	if (a2 == b2) {
		a2 = -1;
		b2 = 0;
	}
	fout << a1 + 1 << " " << b1 << endl;
	fout << a2 + 1 << " " << b2 << endl;

	return 0;
}