#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <utility>
#include <string>
using namespace std;

#define int int64_t

/*

ifstream fin("input.txt");
ofstream fout("output.txt");


ifstream fin("internship.in");
ofstream fout("internship.out");

*/

ifstream fin("internship.in");
ofstream fout("internship.out");

signed main() {
	int n, m;
	fin >> n >> m;
	vector<int> a(n), x(n), b(m), y(m);
	for (int i = 0; i < n; i++) {
		fin >> a[i];
		a[i]--;
	}

	for (int i = 0; i < n; i++)
		fin >> x[i];

	for (int i = 0; i < m; i++) {
		fin >> b[i];
		b[i]--;
	}

	for (int i = 0; i < m; i++)
		fin >> y[i];

	vector<int> asum(n + 1), bsum(m + 1);
	for (int i = 0; i < n; i++)
		asum[i + 1] = asum[i] + x[i];
	
	for (int i = 0; i < m; i++)
		bsum[i + 1] = bsum[i] + y[i];

	int g_sum = 0, a1, b1, a2, b2;

	for (int i1 = 0; i1 < n; i1++) {
		for (int j1 = i1; j1 <= n; j1++) {
			vector<int> used(n + m);
			for (int i = i1; i < j1; i++)
				used[a[i]]++;

			bool is_good = true;
			for (auto x : used) {
				if (x > 1)
					is_good = false;
			}

			int sum1 = asum[j1] - asum[i1];
			if (is_good) {
				int from = 0, to = 0, max_sum = 0;
				int j = 0;
				while (j < m) {
					int k = j;
					while (k < m && !used[b[k]])
						k++;
					int cur_sum = bsum[k] - bsum[j];
					if (cur_sum > max_sum) {
						max_sum = cur_sum;
						from = j;
						to = k;
					}
					j = k + 1;
				}

				if (g_sum < max_sum + sum1) {
					g_sum = max_sum + sum1;
					a1 = i1, b1 = j1, a2 = from, b2 = to;
				}
			}
		}
	}

	fout << g_sum << endl;
	if (a1 == b1) {
		a1 = -1;
		b1 = 0;
	}
	if (a2 == b2) {
		a2 = -1;
		b2 = 0;
	}
	fout << a1 + 1 << " " << b1 << endl;
	fout << a2 + 1 << " " << b2 << endl;

	return 0;
}