#include <bits/stdc++.h>

using namespace std;

#define pb push_back

typedef long long ll;

const int N = 1000001, A = 1000001, K = 23, M = 1 << K;
const ll Inf = 1e18 + 7, inf = 1e9;

int n, a;

ll d[A];
ll l[N], r[N], c[N];

ll tree[M];

void change(int i, ll key){
    tree[i] = key;
    i /= 2;
    for (; i > 0; i /= 2)
        tree[i] = min(tree[i * 2], tree[i * 2 + 1]);
}

ll getmin(int i, int tl, int tr, int l, int r){
    if (l <= tl && tr <= r)
        return tree[i];
    if (tl >= r || tr <= l)
        return Inf;
    int tm = (tl + tr) / 2;
    return min(getmin(i * 2, tl, tm, l, r), getmin(i * 2 + 1, tm, tr, l, r));
}

int main()
{
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> a;
    for (int i = 0; i < n; i++)
        cin >> l[i] >> r[i] >> c[i];
    d[0] = 0;
    for (int i = 0; i < M; i++)
        tree[i] = Inf;
    change(M / 2, n * inf);
    for (int i = 1; i <= a; i++){
        d[i] = d[i - 1];
        for (int j = 0; j < n; j++){
            if (i < r[j])
                continue;
            ll q = getmin(1, 0, M / 2, i - r[j], i - l[j] + 1) - ll(n - i) * inf - c[j];
            d[i] = max(d[i], q);
        }
        change(M / 2 + i, d[i] + (n - i) * inf);
    }
    /*for (int i = 0; i <= a; i++)
        cout << d[i] << endl;
    cout << endl;*/
    cout << d[a];
    return 0;
}
