#include<bits/stdc++.h>

using namespace std;

#define f first
#define s second

struct point{
    int x, y;
    point(){}
    point(int x, int y):
        x(x), y(y){}
};

struct vect{
    int x, y;
    vect(){}
    vect(point p1, point p2){
        x = p2.x - p1.x;
        y = p2.y - p1.y;
    }
};

int vec(vect v1, vect v2){
    return v1.x * v2.y - v1.y * v2.x;
}

int vec(point p1, point p2, point p3){
    return vec(vect(p1, p2), vect(p1, p3));
}

int scal(vect v1, vect v2){
    return v1.x * v2.x + v1.y * v2.y;
}

int n;
vector<point> d;
vector<int> v;
point p3;

bool cmp1(int a, int b){
    return d[a].x < d[b].x || (d[a].x == d[b].x && d[a].y < d[b].y);
}

bool cmp2(int a, int b){
    if(a == v[0]){
        return true;
    }
    return vec(d[v[0]], d[a], d[b]) > 0;
}

bool cmp3(int a, int b){
    return vec(p3, d[a], d[b]) > 0;
}

vector<int> conv(int m){
    ++m;
    vector<int> c;
    c.resize(m);
    for(int i = 0; i < m; ++i){
        c[i] = v[i];
    }
    sort(c.begin(), c.end(), cmp2);
    vector<int> ans;
    ans.push_back(c[0]);
    c.push_back(c[0]);
    for(int i = 1; i < c.size(); ++i){
        while(ans.size() >= 2){
            if(vec(d[ans[ans.size() - 2]], d[ans.back()], d[c[i]]) <= 0){
                ans.pop_back();
            }
            else{
                break;
            }
        }
        ans.push_back(c[i]);
    }
    ans.pop_back();
    return ans;
}

int32_t main(){
    cin >> n;
    d.resize(n);
    for(int i = 0; i < n; ++i){
        cin >> d[i].x >> d[i].y;
    }
    v.resize(n);
    for(int i = 0; i < n; ++i){
        v[i] = i;
    }
    sort(v.begin(), v.end(), cmp1);
    int q;
    cin >> q;
    for(int z = 0; z < q; ++z){
        int l = 1, r = n-1;
        while(r - l > 1){
            int m = (l+r)>>1;
            vector<int> c = conv(m);
            cout << "? " << c.size() <<  ' ';
            for(int i = 0; i < c.size(); ++i){
                cout << c[i]+1 << ' ';
            }
            cout << endl;
            string s;
            cin >> s;
            if(s == "Yes"){
                r = m;
            }
            else{
                l = m;
            }
        }
        vector<int> v2;
        v2.resize(l+1);
        for(int i = 0; i < l+1; ++i){
            v2[i] = v[i];
        }
        p3 = d[v[r]];
        sort(v2.begin(), v2.end(), cmp3);
        int l2 = 0, r2 = l;
        while(r2 - l2 > 1){
            int m = (l2 + r2)>>1;
            cout << "? " << 3 << ' ' << v2[0]+1 << ' ' << v[r]+1 << ' ' << v2[m]+1 << endl;
            string s;
            cin >> s;
            if(s == "Yes"){
                r2 = m;
            }
            else{
                l2 = m;
            }
        }
        cout << "! " << 3 << ' ' << v2[r2-1]+1 << ' ' << v[r]+1 << ' ' << v2[r2]+1 << endl;
    }
}
