#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXA = 1200000;
const int MAXN = 105;
const long long COST = 1000000000;

long long garant[MAXA];
int l[MAXN], r[MAXN], c[MAXN];

int main()
{
    int n, a;
    cin >> n >> a;
    for(int i = 0; i < n; i++) cin >> l[i] >> r[i] >> c[i];

    for(int i = 0; i < MAXA; i++) garant[i] = 0;

    long long minimal;
    for(int i = 1; i <= a; i++) {
        for(int j = 0; j < n; j++)
        {
            if(i - r[j] < 0) continue;
            minimal = COST * COST;
            for(int k = l[j]; k <= r[j]; k++) minimal = min(minimal, garant[i - k] + k * COST - c[j]);
            garant[i] = max(garant[i], minimal);
        }
        //cout << maxsp[i] << endl;
    }

    long long maxinc = 0;
    for(long long i = 0; i <= a; i++) {
        maxinc = max(maxinc, garant[i]);
    }
    cout << maxinc;
    return 0;
}
