#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 505;

int n, m;
int disa[MAXN], disb[MAXN];
long long rata[MAXN], ratb[MAXN];
int rel[MAXN];

vector <int> ok;

int main()
{
    cin >> n >> m;
    for(int i = 0; i < n; i++) cin >> disa[i];
    for(int i = 0; i < n; i++) cin >> rata[i];
    for(int i = 0; i < m; i++) cin >> disb[i];
    for(int i = 0; i < m; i++) cin >> ratb[i];

    //relative
    for(int i = 0; i < n; i++) {
        rel[i] = -1;
        for(int j = 0; j < m; j++) if(disb[j] == disa[i]) rel[i] = j;
    }

    long long opt = 0;
    long long la = -1, lb = -1, ra = -1, rb = -1;

    //no a courses
    long long noaratb = 0;
    for(int i = 0; i < m; i++) noaratb += ratb[i];
    if(noaratb > opt) {
        opt = noaratb;
        lb = 0;
        rb = m - 1;
    }

    //go
    for(int i = 0; i < n; i++) for(int j = i; j < n; j++) {
        ok.assign(m, 1);
        for(int k = i; k <= j; k++) if(rel[k] != -1) ok[rel[k]] = 0;
        //calcans
        long long nowrata = 0;
        for(int k = i; k <= j; k++) nowrata += rata[k];

        long long nowratb = 0;
        long long nowl = -1, nowr = -1;
        long long loc = 0;
        long long locl = 0;
        //calc brat
        for(int k = 0; k < m; k++) {
            if(ok[k] == 1) loc += ratb[k];
            else {
                if(loc > nowratb) {
                    nowratb = loc;
                    nowl = locl;
                    nowr = k - 1;
                }
                loc = 0;
                locl = k + 1;
            }
        }
        if(loc > nowratb) {
            nowratb = loc;
            nowl = locl;
            nowr = m - 1;
        }

        if(nowrata + nowratb > opt) {
            opt = nowrata + nowratb;
            la = i;
            ra = j;
            lb = nowl;
            rb = nowr;
        }

        //cout << "Now: " << i << " " << j << " " << nowrata + nowratb << endl;
    }

    cout << opt << endl;
    cout << la + 1 << " " << ra + 1 << endl;
    cout << lb + 1 << " " << rb + 1 << endl;
    return 0;
}
