#include <iostream>
#include <fstream>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;

const ll INF = (ll) 1e9;
const ll BIG_INF = (ll) 1e18;

struct Exp {
    int l, r, c;
};
//
//struct Tree {
//    int maxi;
//    int tl, tr;
//    bool isBuffed;
//    int buf;
//    Tree *left, *right;
//    Tree(int key, int pos) :
//            maxi(key),
//            tl(pos),
//            tr(pos),
//            isBuffed(false),
//            buf(INF),
//            left(nullptr),
//            right(nullptr) { }
//    Tree(Tree *lt, Tree *rt);
//};
//
//int getMax(Tree *tree) {
//    if (!tree) {
//        return INF;
//    }
//    return tree->maxi;
//}
//
//int getR(Tree *tree) {
//    if (!tree) {
//        return -INF;
//    }
//    return tree->tr;
//}
//
//int getL(Tree *tree) {
//    if (!tree) {
//        return INF;
//    }
//    return tree->tl;
//}
//
//Tree::Tree(Tree *lt, Tree *rt) {
//    left = lt;
//    right = rt;
//    tl = max(getL(lt), getL(rt));
//    tr = max(getR(lt), getR(rt));
//    maxi = max(getMax(lt), getMax(rt));
//    isBuffed = false;
//    buf = INF;
//}

vector<int> buf;
//
//Tree *build(int l, int r) {
//    if (l == r) {
//        return new Tree(buf[l], l);
//    }
//    return new Tree(build(l, (l + r) / 2), build((l + r) / 2 + 1, r));
//}
//
//void addMax(Tree *tree, int val) {
//    if (!tree) {
//        return;
//    }
//    tree->isBuffed = true;
//    tree->buf = max(tree->buf, val);
//    tree->maxi = max(tree->maxi, tree->buf);
//}
//
//void push(Tree *tree) {
//    if (!tree) {
//        return;
//    }
//    if (tree->isBuffed) {
//        tree->isBuffed = true;
//        addMax(tree->left, tree->buf);
//        addMax(tree->right, tree->buf);
//        tree->buf = INF;
//    }
//}
//
//int getMax(Tree *tree, int l, int r) {
//    if (!tree || tree->tl > r || tree->tr < l || l > r) {
//        return INF;
//    }
//    if (tree->tl == l && tree->tr == r) {
//        return tree->maxi;
//    }
//    push(tree);
//    return max(getMax(tree->left, l, min(r, getR(tree->left))),
//                getMax(tree->right, max(getR(tree->right), l), r));
//}
//
//void update(Tree *tree, int l, int r, int val) {
//    if (!tree || tree->tl > r || tree->tr < l || l > r) {
//        return;
//    }
//    if (tree->tl == l && tree->tr == r) {
//        addMax(tree, val);
//        return;
//    }
//    push(tree);
//    update(tree->left, l, min(r, getR(tree->left)), val);
//    update(tree->right, max(l, getL(tree->right)), r, val);
//}

int main() {
    freopen("anti.in", "r", stdin);
    freopen("anti.out", "w", stdout);
    int n, a;
    cin >> n >> a;
    int minR = INF;
    vector<Exp> e(n);
    for (int i = 0; i < n; ++i) {
        cin >> e[i].l >> e[i].r >> e[i].c;
        minR = min(minR, e[i].r);
    }
    buf.resize(a + 2, -1);
    buf[0] = 0;
    vector<vector<int>> deBuf(a + 2);
    deBuf[1].push_back(0);
    ll ans = BIG_INF;
    multiset<int> minNow;
    for (int i = 0; i <= a; ++i) {
        for (auto old : deBuf[i]) {
            if (minNow.find(old) != minNow.end()) {
                minNow.erase(minNow.find(old));
            }
        }
        if (buf[i] != -1) {
            minNow.insert(buf[i]);
        }
        if (minNow.empty()) {
            continue;
        }
        int here = *minNow.rbegin();
        int maxBuf = 0;
        int cost = INF;
        int ind = -1;
        for (int j = 0; j < n; ++j) {
            int tol = i + e[j].l,
                    tor = i + e[j].r;
            if (tor > a) {
                continue;
            } else {
                int nb = (a - i - e[j].r) / minR * minR + e[j].r;
                if (nb > maxBuf) {
                    maxBuf = nb;
                    cost = e[j].c;
                    ind = j;
                } else if (nb == maxBuf && e[j].c < cost) {
                    cost = e[j].c;
                    ind = j;
                }
            }
        }
        if (ind == -1) {
            ans = min(ans, i * INF - here);
        } else {
            int tol = i + e[ind].l,
                tor = i + e[ind].r;
            if (buf[tol] < here + e[ind].c) {
                buf[tol] = here + e[ind].c;
                deBuf[tor].push_back(here + e[ind].c);
            }
        }
    }
    cout << ans << "\n";
    return 0;
}