#include<iostream>
#include<vector>
#include<string>

#define int long long

using namespace std;

const int bits = 30;
const int maxn = 1e6;

int32_t main() {
	//freopen("input.in", "r", stdin);
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	int q;
	cin >> q;
	for (int cq = -1; cq < q; cq++) {
		if (cq != -1) {
			int p, v;
			cin >> p >> v;
			p--;
			a[p] = v;
		}
		vector<pair<int, int> > segm(1, { 0, n });
		int ans = 0;
		bool ok = true;
		for (int i = bits - 1; i >= 0 && ok; i--) {
			bool rev = false;
			bool t1 = false;
			int sz = segm.size();
			for (int c = 0; c < sz && ok; c++) {
				if (segm[c].second - segm[c].first == 1)
					continue;
				int l = segm[c].first, r = segm[c].second;
				bool lb = ((a[l] >> i) & 1), rb = ((a[r - 1] >> i) & 1);
				bool crev = lb > rb;
				if (!t1) {
					rev = crev;
					t1 = true;
				}
				else if (crev != rev) {
					ok = false;
					break;
				}
				bool was = false;
				int m = 0;
				for (int j = l; j < r; j++) {
					bool cb = ((a[j] >> i) & 1);
					if (was) {
						if (cb != rb) {
							ok = false;
							break;
						}
					}
					else {
						if (cb != lb) {
							m = j;
							j--;
							was = true;
						}
					}
				}
				if (m == 0)
					continue;
				else {
					segm[c].second = m;
					segm.push_back({ m, r });
				}
			}
			ans |= rev * (1 << i);
		}
		if (ok)
			cout << ans << "\n";
		else
			cout << "-1\n";
	}
}