#include <iostream>
#include <vector>
#include <string>

#define ll long long
using namespace std;

ll q;
vector<pair<ll, int>> symb;
vector<pair<ll, int>> symbi;

int main() {
    cin >> q;
    for (int r = 0; r < q; r++) {
        string s, t;
        cin >> s >> t;
        if (s == t) {
            printf("Yes\n");
            continue;
        }
        symb.push_back(make_pair(1, ((s[0] == '+') ? 1 : 0)));
        int last = 0, lasti = 0;
        for (int j = 1; j < s.size(); j++) {
            if (s[j] == s[last]) {
                symb[lasti].first++;
            } else {
                symb.push_back(make_pair(1, ((s[last] == '-') ? 1 : 0)));
                last = j;
                lasti++;
            }
        }
        symbi.push_back(make_pair(1, ((t[0] == '+') ? 1 : 0)));
        last = 0, lasti = 0;
        for (int j = 1; j < s.size(); j++) {
            if (t[j] == t[last]) {
                symbi[lasti].first++;
            } else {
                symbi.push_back(make_pair(1, ((t[last] == '-') ? 1 : 0)));
                last = j;
                lasti++;
            }
        }
        int k = 0, n = symb.size() - 1;
        for (int i = 0; i < n; i++) {
            if (symb[i] == symbi[k]) {
                k++;
                continue;
            }
            if (symb[i].second == symbi[k].second) {
                if (symb.size() - i > 2) {
                    if ((symb[i].first + symb[i + 1].first + symb[i + 2].first) <= symbi[k].first &&
                            (symb[i].first > symb[i + 1].first || symb[i+2].first > symb[i + 1].first)) {
                        symb[i].first += symb[i + 1].first + symb[i + 2].first;
                        symb.erase(symb.begin() + i + 1, symb.begin() + i + 3);
                        n -= 2;
                        i -= 1;
                    }
                } else {
                    if ((symb[i].first + symb[i + 1].first) <= symbi[k].first && symb[i].first > symb[i + 1].first) {
                        symb[i].first += symb[i + 1].first;
                        symb.erase(symb.begin() + i + 1);
                        n -= 1;
                    }
                }
            }

        }
        k = symbi.size() - 1;
        for (int i = symb.size() - 1; i >= 0; i--) {
            if (symb[i] == symbi[k]) {
                k--;
                continue;
            }
            if (symb[i].second == symbi[k].second) {
                if (i > 2) {
                    if ((symb[i].first + symb[i - 1].first + symb[i - 2].first) <= symbi[k].first &&
                            (symb[i].first > symb[i - 1].first || symb[i-2].first > symb[i - 1].first )) {
                        symb[i].first += symb[i - 1].first + symb[i - 2].first;
                        symb.erase(symb.begin() + i - 2, symb.begin() + i);
                        i -= 2;
                    }
                } else {
                    if ((symb[i].first + symb[i - 1].first) <= symbi[k].first && symb[i].first > symb[i - 1].first) {
                        symb[i].first += symb[i - 1].first;
                        symb.erase(symb.begin() + i);
                        i -= 1;
                    }
                }
            }


        }
        bool f=false;
        if (symb.size()==symbi.size()){
            f=true;
            for (int i=0;i<symb.size();i++){
                if (symb[i]!=symbi[i]){
                    f=false;
                }
            }
        }
        if (f){
            printf("Yes\n");
        }else{
            printf("No\n");
        }
        symb.erase(symb.begin(), symb.end());
        symbi.erase(symbi.begin(), symbi.end());
    }


    return 0;
}