#include <bits/stdc++.h>
using namespace std;

#define int long long

const int inf = 1e9, maxn = 1e6+5;

struct segtree{
    int lb, rb, t;
    int mn = inf*inf;
    segtree *l, *r;
    segtree(int lq, int rq){
        lb = lq, rb = rq;
        if(lb != rb){
            t = (lb+rb)/2;
            l = new segtree(lb, t);
            r = new segtree(t+1, rb);
        }
    }
    void upd(int k, int x){
        if(lb == rb) mn = x;
        else{
            if(k <= t) l->upd(k, x);
            else r->upd(k, x);
            mn = min(l->mn, r->mn);
        }
    }
    int rmq(int lq, int rq){
        if(lq <= lb && rb <= rq) return mn;
        if(rq < lb || lq > rb) return inf*inf;
        return min(l->rmq(lq, rq), r->rmq(lq, rq));
    }
};

int dp[maxn], l[maxn], r[maxn], c[maxn];

main(){
    ios::sync_with_stdio(0);
    cin.tie(0);

    int m, n;
    cin >> m >> n;

    for(int i = 0; i < m; i++)
        cin >> l[i] >> r[i] >> c[i];

    segtree q(0, n);

    for(int i = n; i >= 0; i--){
        dp[i] = 0;
        for(int j = 0; j < m; j++){
            if(i+r[j] > n) continue;
            //cerr << i << " " << j << " " << q.rmq(i+l[j], i+r[j]) << " " << i+l[j] << " " << i+r[j] << endl;
            dp[i] = max(dp[i], q.rmq(i+l[j], i+r[j]) - inf*i - c[j]);
        }
        q.upd(i, dp[i]+inf*i);
        //cerr << i << " " << dp[i] << " " << q.rmq(n, n) << endl;
    }

    cout << dp[0];

    return 0;
}
