#include <bits/stdc++.h>

#define size(a) (int(a.size()))

using namespace std;

typedef long long llong;
const llong inf = (llong) 1e9 + 7ll;
static char buff[(int) 1e6 + 17];
const int maxn = (int) 1e6 + 17;

int n, m;
int a[maxn], b[maxn], pos[maxn];
llong x[maxn], y[maxn], yy[maxn];

bool read()
{
    if (scanf("%d %d", &n, &m) != 2)
        return false;

    for (int i = 0; i < n; ++i)
        scanf("%d", &a[i]), --a[i];

    for (int i = 0; i < n; ++i)
        scanf("%lld", &x[i]);

    for (int i = 0; i < m; ++i)
        scanf("%d", &b[i]), --b[i];

    for (int i = 0; i < m; ++i)
        scanf("%lld", &y[i]);

    return true;
}

void solve()
{
    memset(pos, -1, sizeof(pos));

    for (int i = 0; i < m; ++i)
    {
        pos[b[i]] = i;
        yy[i] = (i == 0 ? 0 : yy[i - 1]) + y[i];
    }

    llong ans = yy[m - 1];
    int a_l = -1, a_r = -1;
    int b_l = 0, b_r = m - 1;

    for (int l = 0; l < n; ++l)
    {
        set< pair<int, int> > st;
        st.insert(make_pair(0, m - 1));
        multiset< pair<llong, pair<int, int> > > sums;
        sums.insert(make_pair(yy[m - 1], make_pair(0, m - 1)));
        llong sum = 0;

        for (int r = l; r < n; ++r)
        {
            sum += x[r];

            if (pos[a[r]] != -1)
            {
                int j = pos[a[r]];
                auto cur = *(--st.upper_bound(make_pair(j, (int) inf)));
                st.erase(cur);
                sums.erase(sums.find(make_pair(yy[cur.second] - (cur.first == 0 ? 0 : yy[cur.first - 1]), cur)));

                if (cur.first <= j - 1)
                {
                    st.insert(make_pair(cur.first, j - 1));
                    sums.insert(make_pair(yy[j - 1] - (cur.first == 0 ? 0 : yy[cur.first - 1]), make_pair(cur.first, j - 1)));
                }

                if (j + 1 <= cur.second)
                {
                    st.insert(make_pair(j + 1, cur.second));
                    sums.insert(make_pair(yy[cur.second] - yy[j], make_pair(j + 1, cur.second)));
                }
            }

            if (!sums.empty())
            {
                if (ans < sum + sums.rbegin()->first)
                    ans = sum + sums.rbegin()->first, a_l = l, a_r = r, b_l = sums.rbegin()->second.first, b_r = sums.rbegin()->second.second;
            }
            else
            {
                if (ans < sum)
                    ans = sum, a_l = l, a_r = r, b_l = b_r = -1;
            }
        }
    }

    printf("%lld\n", ans);
    printf("%d %d\n%d %d\n", a_l + 1, a_r + 1, b_l + 1, b_r + 1);
}

int main()
{
#ifdef SEREZHKA
    freopen("file.in", "r", stdin);
#endif // SEREZHKA

    while (read())
        solve();

    return 0;
}
