#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const ll maxn = 5001;

const ll MAX_MEM = 4e8;

char mem[MAX_MEM];
int mpos = 0;

void *operator new(size_t n) {
    if (mpos + n >= MAX_MEM) mpos = 1e8;
    void *ans = mem + mpos;
    mpos += n;
    return ans;
}

void operator delete(void *) {}

int a[maxn];
int x[maxn];
int b[maxn];
int y[maxn];
ll prefy[maxn];
int bmap[maxn * 2];

inline ll getprefy(ll l, ll r) {
    if (l != 0) return prefy[r] - prefy[l - 1];
    else return prefy[r];
}

int run() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        bmap[a[i]] = -1;
    }
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
        bmap[b[i]] = i;
    }
    for (int i = 0; i < m; ++i) {
        cin >> y[i];
        prefy[i] = y[i];
        if (i != 0) prefy[i] += prefy[i - 1];
    }
    ll ans = prefy[m - 1];
    int ansl1 = -1, ansl2 = 0, ansr1 = -1, ansr2 = m - 1;
    vector<ll> mypergavno(n);
    for (int i = 0; i < n; ++i) {
        mypergavno[i] = i;
    }
    srand('k' + 'a' + 's' + 's' + 'i' + 'h' + 'i' + 'n' + '-' + 'n' + 'y' + 'a' + 's' + 'h' + 'a');
    random_shuffle(mypergavno.begin(), mypergavno.end());
    for (auto i : mypergavno) {
        if (clock() * 1000 / CLOCKS_PER_SEC > 1950) break;
        set<int> st;
        set<pair<ll, pair<int, int>>> vals;
        vals.insert({getprefy(0, m - 1), {0, m - 1}});
        ll curs = 0;
        for (int j = i; j < n; ++j) {
            curs += x[j];
            if (bmap[a[j]] != -1) {
                ll curp = bmap[a[j]];
                auto it = st.lower_bound(curp);
                ll curr = m;
                if (it != st.end()) curr = *it;
                ll curl = -1;
                if (it != st.begin()) curl = *--it;
                vals.erase({getprefy(curl + 1, curr - 1), {curl + 1, curr - 1}});
                vals.insert({getprefy(curl + 1, curp - 1), {curl + 1, curp - 1}});
                vals.insert({getprefy(curp + 1, curr - 1), {curp + 1, curr - 1}});
                st.insert(curp);
            }
            auto maxit = vals.end();
            maxit--;
            if (ans < maxit->first + curs) {
                ans = maxit->first + curs;
                ansl1 = i;
                ansr1 = j;
                ansl2 = maxit->second.first;
                ansr2 = maxit->second.second;
            }
        }
    }
    if (ansl2 > ansr2) ansl2 = ansr2 = -1;
    cout << ans << endl << ansl1 + 1 << " " << ansr1 + 1 << endl << ansl2 + 1 << " " << ansr2 + 1 << endl;
    return 0;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    run();
    return 0;
}