#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;
typedef pair<int, int> pii;

int n;
vector<int> t;
vector<int> ls, rs;

vector<bool> bad_right;
vector<int> min_right;

vector<bool> bad_left;
vector<int> min_left;

vector<int> diff_right;
vector<int> diff_left;

void calc_bad() {
    min_right.resize(n + 100, INT_MAX);
    bad_right.resize(n);
    for (int i = n - 2; i >= 0; i--) {
        min_right[i] = rs[i];
        if (i + 1 < n - 1)
            min_right[i] = min(min_right[i], min_right[i + 1]);
    }
    for (int i = n - 2; i >= 0; i--) {
        if (ls[i] > min_right[i + 1]) {
            bad_right[i] = true;
        }
        if (bad_right[i + 1])
            bad_right[i] = true;
    }


    min_left.resize(n + 100, INT_MAX);
    bad_left.resize(n);
    for (int i = 0; i < n - 1; i++) {
        min_left[i] = rs[i];
        if (i - 1 >= 0)
            min_left[i] = min(min_left[i], min_left[i - 1]);
    }
    for (int i = 1; i < n; i++) {
        if (ls[i] > min_left[i - 1]) {
            bad_left[i] = true;
        }
        if (bad_left[i - 1])
            bad_left[i] = true;
    }
}

void calc_diff() {
    diff_right.resize(n + 100);
    for (int i = n - 2; i >= 0; i--) {
        diff_right[i] = ls[i] - t[i];
        if (i + 1 < n)
            diff_right[i] = max(diff_right[i], diff_right[i + 1]);
    }

    diff_left.resize(n + 100);
    for (int i = 0; i < n - 1; i++) {
        diff_left[i] = ls[i] - t[i];
        if (i - 1 >= 0)
            diff_left[i] = max(diff_left[i], diff_left[i - 1]);
    }
}

bool check(int x, int v) {
    if (bad_right[v] || x > min_right[v])
        return false;

    if (v > 0) {
        if (bad_left[v - 1] || x > min_left[v - 1])
            return false;
    }

    return true;
}

int calc(int v) {
    int timer = 0;
    int add = 0;

    /*
    for (int i = v + 1; i < n; i++) {
        if (timer + t[i - 1] < ls[i - 1])
            add = max(add, ls[i - 1] - t[i - 1]);
        timer = max(timer, ls[i - 1]);
    }
     */

    add = diff_right[v];

    timer = add;
    for (int i = v - 1; i >= 0; i--) {
        if (timer + t[i + 1] < ls[i])
            add = max(add, ls[i] - t[i + 1]);
        timer = max(timer, ls[i]);
    }

    return add;
}

int main() {
    scanf("%d", &n);
    t.resize(n);
    for (int i = 0; i < n; i++)
        scanf("%d", &t[i]);
    ls.resize(n - 1);
    rs.resize(n - 1);
    for (int i = 0; i < n - 1; i++)
        scanf("%d%d", &ls[i], &rs[i]);

    calc_bad();
    calc_diff();

    for (int i = 0; i < n; i++) {
        int maybe = calc(i);
        if (!check(maybe, i))
            maybe = -1;
        printf("%d\n", maybe);
    }
}