#include <iostream>
#include <vector>
#include <cstdio>


using namespace std;


const int INF = 1e9 + 7;
const int V = 2e5 + 7;
int left_dp[V][2];
int right_dp[V][2];
int t[V];
int w[V][2];


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> t[i];
		left_dp[i][0] = INF;  left_dp[i][1] = 0;
		right_dp[i][0] = INF; right_dp[i][1] = 0;
	}
	for (int i = 0; i < n - 1; i++)
	{
		cin >> w[i][0] >> w[i][1];
	}
	left_dp[0][0] = 0;      left_dp[0][1] = INF;
	right_dp[n - 1][0] = 0; right_dp[n - 1][1] = INF;
	for (int i = 1; i < n; i++)
	{
		//cerr << i << endl;
		left_dp[i][0] = (left_dp[i - 1][0] > w[i - 1][0] ? left_dp[i - 1][0] : max(w[i - 1][0] - t[i], 0));
		left_dp[i][1] = min(w[i - 1][1], left_dp[i - 1][1]);
		if (left_dp[i - 1][1] < w[i - 1][0])
		{
			left_dp[i][0] = 2 * INF;
		}
	}
	for (int i = n - 2; i >= 0; i--)
	{
		//cerr << i << endl;
		right_dp[i][0] = (right_dp[i + 1][0] > w[i][0] ? right_dp[i + 1][0] : max(w[i][0] - t[i], 0));
		right_dp[i][1] = min(w[i][1], right_dp[i + 1][1]);
		if (right_dp[i + 1][1] < w[i][0])
		{
			right_dp[i][0] = 2 * INF;
		}
	}
	for (int i = 0; i < n; i++)
	{
		if (left_dp[i][0] > left_dp[i][1] || right_dp[i][0] > right_dp[i][1])
		{
			cout << -1 << '\n';
			continue;
		}
		int ans = max(left_dp[i][0], right_dp[i][0]);
		if (ans <= left_dp[i][1] && ans <= right_dp[i][1])
		{
			cout << ans << '\n';
		}
		else
		{
			cout << -1 << '\n';
		}
	}
	cout.flush();
}