#include <stdio.h>
#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define fi first
#define se second
#define sz(a) (int)a.size()
#define mp(a, b) make_pair(a, b)

using namespace std;

const int N = 2000000 + 1;
const int inf = (int)1e9;
const ll oo = (ll)1e18 + 1;

struct exper
{
    int l, r, cost;
    exper() {}
    exper(int l, int r, int cost) : l(l), r(r), cost(cost) {}
    void read() { scanf("%d %d %d", &l, &r, &cost); }
};

bool operator < (exper e1, exper e2)
{
    return e1.r < e2.r;
}

int cnt_v = 1;
ll tree[N * 4];

void build(int n)
{
    while (cnt_v < n)
        cnt_v <<= 1;
    rep(i, 0, n)
        tree[cnt_v - 1 + i] = 1LL * i * inf;
    repb(i, cnt_v - 2, -1)
        tree[i] = min(tree[(i << 1) + 1], tree[(i << 1) + 2]);
}

void upd(int x, ll v)
{
    if (tree[cnt_v - 1 + x] > v + 1LL * x * inf)
        return;
    tree[cnt_v - 1 + x] = v + 1LL * x * inf;
    x += (cnt_v - 1);
    while (x)
    {
        x = ((x - 1) >> 1);
        tree[x] = min(tree[(x << 1) + 1], tree[(x << 1) + 2]);
    }
}

ll get(int x, int lx, int rx, int l, int r)
{
    if (lx >= r || l >= rx)
        return oo;
    else if (lx >= l && rx <= r)
        return tree[x];
    else
        return min(get((x << 1) + 1, lx, (lx + rx) >> 1, l, r), get((x << 1) + 2, (lx + rx) >> 1, rx, l, r));
}

int main()
{
    //freopen("a.in", "r", stdin);
    int n, X;
    scanf("%d %d", &n, &X);
    exper a[n];
    rep(i, 0, n)
        a[i].read();
    sort(a, a + n);
    build(X + 1);
    //ll dp;
    /*repb(j, X, -1)
    {
        dp = 0;
        rep(i, 0, n)
            if (j + a[i].r <= X)
                dp = max(dp, get(0, 0, cnt_v, j + a[i].l, j + a[i].r + 1) - (1LL * j * inf + a[i].cost));
            else
                break;
        upd(j, dp);
    }*/
    rep(i, 0, n)
        repb(j, X, -1)
            if (j + a[i].r <= X)
                upd(j, get(0, 0, cnt_v, j + a[i].l, j + a[i].r + 1) - (1LL * j * inf + a[i].cost));
    /*rep(i, 0, X + 1)
        cout << tree[cnt_v - 1 + i] - 1LL * i * inf << " ";
    cout << endl;*/
    printf("%lld\n", tree[cnt_v - 1]);
    return 0;
}
