#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstdlib>
#include <stack>
using namespace std;
#define forn(a, b) for (int i = a; i < b; ++i)
#define fore(i, a, b) for (int i = a; i < b; ++i)
#define all(a) a.begin(), a.end()
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define x first
#define y second
typedef long long ll;
typedef long double ld;
bool get(vector <pair<bool, int>>::iterator a, vector <pair<bool, int>>::iterator b, bool aim) {
    stack <pair<bool, int>> st;
    for (auto i = a; i != b + 1; ++i) {
        if (i->x != aim) {
            if (!st.empty()) {
                if (st.top().y > i->y)
                    st.top().y += i->y;
                else
                    st.push(*i);
            } else {
                st.push(*i);
            }
        } else {
            if (!st.empty()) {
                if (st.top().x == aim)
                    st.top().y += i->y;
                else
                    st.push(*i);
            } else {
                st.push(*i);
            }
        }
        if (st.top().x == aim) {
            pair<bool, int> v = mp(st.top().x, st.top().y);
            st.pop();
            while (!st.empty() && (st.top().y < v.y || st.top().x == aim)) {
                v.y += st.top().y;
                st.pop();
            }
            st.push(v);
        }
    }
    return !(st.size() != 1 || st.top().x != aim);
}
void solve() {
    vector <pair<bool, int>> a;
    vector <pair<bool, int>> b;
    string ia, ib;
    cin >> ia >> ib;
    a.pb(mp(bool(ia[0] == '+'), 1));
    b.pb(mp(bool(ib[0] == '+'), 1));
    forn (1, ia.size()) {
        bool type = ia[i] == '+';
        if (a.back().x == type)
            ++a[a.size() - 1].y;
        else
            a.pb(mp(type, 1));
    }
    /*forn (1, ib.size()) {
        bool type = ib[i] == '+';
        if (b.back().x == type)
            ++b[b.size() - 1].y;
        else
            b.pb(mp(type, 1));
    }*/
    cout << (get(a.begin(), a.end() - 1, true) ? "Yes" : "No") << endl;
    return;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int q;
    cin >> q;
    forn (0, q)
        solve();

    return 0;
}
/*
3
++- +++
++-- ++++
++-+--+- ++++++++
*/