#define first X
#define second Y
#define push_back pb
#define pop_back pob
#define make_pair mp
#define _p(x, y) pair<x, y>

#include <iostream>
#include <set>
#include <map>
#include <stdio.h>
#include <string>
#include <vector>
#include <queue>
#include <algorithm>
#include <cmath>
#include <iterator>
#include <climits>

using namespace std;

typedef long long i64;
#define endl '\n'

const int INF = 1000000007;
const i64 LINF = 1000000000000000007;

int main() {

#ifdef _DEBUG
	freopen("D.txt", "r", stdin);
#endif

	int n, m;
	scanf("%d%d", &n, &m);

	vector < int > id_a(n), id_b(m);
	vector < i64 > q_a(n), q_b(m);
	i64 ans = 0, sum = 0, bsum = 0;
	int laa = -1, raa = -1, lba = -1, rba = -1;

	for (int i = 0; i < n; i++) {
		scanf("%d", &id_a[i]);
	}

	for (int i = 0; i < n; i++) {
		scanf("%lld", &q_a[i]);
		sum += q_a[i];
	}

	for (int i = 0; i < m; i++) {
		scanf("%d", &id_b[i]);
	}

	for (int i = 0; i < m; i++) {
		scanf("%lld", &q_b[i]);
		bsum += q_b[i];
	}

	ans = sum;
	laa = 0;
	raa = n - 1;
	lba = -1;
	rba = -1;

	if (bsum > ans) {
		ans = bsum;
		laa = raa = -1;
		lba = 0;
		rba = m - 1;
	}

	set < int > ss;
	int last;
	for (int i = 0; i < n; i++) {
		sum = 0;
		ss.clear();
		for (int j = i; j < n; j++) {
			ss.insert(id_a[j]);
			sum += q_a[j];
			bsum = 0;
			last = -1;
			for (int k = 0; k < m; k++) {
				bsum += q_b[k];
				if (ss.find(id_b[k]) != ss.end()) {
					bsum = 0;
					last = k;
				}
				if (ans < sum + bsum) {
					ans = sum + bsum;
					laa = i;
					raa = j;
					lba = last + 1;
					rba = k;
				}
			}
		}
	}

	printf("%lld\n%d %d\n%d %d\n", ans, laa + 1, raa + 1, lba + 1, rba + 1);

	return 0;
}