#include <bits/stdc++.h>

using namespace std;

const long long INF = 10000000000000;

long long n, m;
vector<pair<long long, long long> > dist[15000];
pair<long long, long long> d[15000];

pair<long long, long long> operator + (pair<long long, long long> p1, pair<long long, long long> p2)
{
    return make_pair(p1.first + p2.first, p1.second + p2.second);
}

void dji()
{
    set<pair<pair<long long, long long>, long long> > opts;
    opts.clear();
    for (long long i = 2; i <= n; i++)
    {
        d[i] = make_pair(INF, -INF);
    }
    d[1] = make_pair(0, 0);
    for (long long i = 1; i <= n; i++)
    {
        opts.insert(make_pair(d[i], i));
    }
    while (!opts.empty())
    {
        pair<pair<long long, long long>, long long> cur = *opts.begin();
        opts.erase(cur);
        long long v = cur.second;
        //cout << v << endl;
        for (long long i = 0; i < dist[v].size(); i++)
        {
            long long u = dist[v][i].first, dst = dist[v][i].second;
            if (d[v] + make_pair(dst, -dst * dst) < d[u])
            {
                opts.erase(make_pair(d[u], u));
                d[u] = d[v] + make_pair(dst, -dst * dst);
                opts.insert(make_pair(d[u], u));
                //cout << u << ' ' << d[u].first << ' ' << d[u].second << endl;
            }
        }
    }
}

int main()
{
    cin >> n >> m;
    for (long long i = 0; i < m; i++)
    {
        long long t, st;
        cin >> t >> st;
        for (long long j = 0; j < t; j++)
        {
            long long d, fn;
            cin >> d >> fn;
            dist[st].push_back(make_pair(fn, d));
            st = fn;
        }
    }
    dji();
    cout << d[n].first << ' ' << -d[n].second;
}
