#include <bits/stdc++.h>

using namespace std;

#define endl '\n'
#define int int64_t
#define fi first
#define se second
#define mp make_pair

vector <int> t;
vector <vector <pair <int, pair <int, int> > > > g;
vector <pair <int, int> > dp;

/*void dfs(int v, int pr = -1)
{

}
*/

const int INF = 1000000000000000000;

ostream & operator << (ostream & out, pair <int, int> p)
{
    out << "{" << p.fi << " " << p.se << "}";
    return out;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> & arr)
{
    for (auto x : arr)
        out << x << " ";
    return out;
}

bool operator == (pair <int, int> p1, pair <int, int> p2)
{
    return p1.fi == p2.fi && p1.se == p2.se;
}

signed main()
{
    int n;
    cin >> n;
    t.resize(n);
    dp.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> t[i];
    g.resize(n);
    vector <pair <int, int> > arr(n - 1);
    for (int i = 0; i < n - 1; ++i)
    {
        int l, r;
        cin >> l >> r;
        arr[i] = mp(l, r);
    }
    vector <pair <int, int> > pref(n, mp(-1, INF));
    for (int i = 1; i < n; ++i)
    {
        pair <int, int> p = pref[i - 1];
        if (p == mp(-1ll, -1ll))
        {
            pref[i] = p;
            continue;
        }
        int l = arr[i - 1].fi, r = arr[i - 1].se;
        int l1 = max(l, p.fi);
        int r1 = min(r, p.se);
        if (l1 > r1)
        {
            pref[i] = mp(-1, -1);
            continue;
        }
        pref[i] = mp(l1 - t[i], r1);
    }


    vector <pair <int, int> > suf(n, mp(-1, INF));
    for (int i = 1; i < n; ++i)
    {
        pair <int, int> p = suf[i - 1];
        if (p == mp(-1ll, -1ll))
        {
            suf[i] = p;
            continue;
        }
        int l = arr[n - i - 1].fi, r = arr[n - i - 1].se;
        int l1 = max(l, p.fi);
        int r1 = min(r, p.se);
        if (l1 > r1)
        {
            suf[i] = mp(-1ll, -1ll);
            continue;
        }
        suf[i] = mp(l1 - t[n - 1 - i], r1);
    }
    //cout << "suf: " << suf << endl;
    //cout << "pref: " << pref << endl;
    for (int i = 0; i < n; ++i)
    {
        pair <int, int> p1 = pref[i];
        pair <int, int> p2 = suf[n - i - 1];
        if (p1 == mp(-1ll, -1ll) || p2 == mp(-1ll, -1ll))
        {
            cout << -1 << endl;
            continue;
        }
        int l1 = max(p1.fi, p2.fi);
        int r1 = min(p1.se, p2.se);
        if (l1 > r1)
        {
            cout << -1 << endl;
            continue;
        }
        cout << max(0ll, l1) << endl;
    }
    return 0;
}
