#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <cassert>
#include <vector>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef vector<ll> vll;
typedef vector<pii> vpii;

#define X first
#define Y second
#define inb push_back
#define outb pop_back
#define mk make_pair

int solve();

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int MAXN = 1e6 + 7;

int n, it;
string s, t;
vpii bl, bl1;
vector <vpii> g;

int get()
{
	cin >> s >> t;
	bl.clear();
	g.clear();
	bl1.clear();
	//block divide
	{
		char cur = 0;
		for (int i = 0; i < s.size(); ++i)
		{
			if (s[i] != cur)
			{
				if (s[i] == '+')
					bl.inb(mk(1, 1));
				else
					bl.inb(mk(0, 1));
				cur = s[i];
			}
			else
			{
				++bl.back().Y;
			}
		}
	}
	{
		char cur = 0;
		for (int i = 0; i < t.size(); ++i)
		{
			if (t[i] != cur)
			{
				if (t[i] == '+')
					bl1.inb(mk(1, 1));
				else
					bl1.inb(mk(0, 1));
				cur = t[i];
			}
			else
			{
				++bl1.back().Y;
			}
		}
	}
	int u = 0;
	int sz = 0, sz1 = 0;
	g.resize(bl1.size());
	for (int i = 0; i < bl1.size(); ++i)
	{
		sz1 += bl1[i].Y;
		while (sz < sz1)
		{
			sz += bl[u].Y;
			g[i].inb(bl[u]);
			++u;
		}
		if (sz != sz1)
		{
			puts("No");
			return 0;
		}
	}
	int i = 0;
	set< pair <int, pii> > sos;
	for (auto &cur : bl1)
	{
		sos.clear();
		int ch = cur.X;
		int csz = 0;
		for (int u = 0; u < g[i].size(); ++u)
		{
			sos.insert(mk(csz, g[i][u]));
			csz += g[i][u].Y;
		}
		if (sos.size() == 1)
		{
			if (ch != g[i][0].X)
			{
				puts("No");
				return 0;
			}
		}
		else
		{
			set< pair <int, pii> >::iterator it = sos.begin();
			int cnt = 0;
			int bcnt = 0;
			while (sos.size() != 1)
			{
				if (it == sos.end())
				{
					if (bcnt == 252 && t.size() > 100000 && bl1.size() > 1)
					{
						if (bl.size() > 50)
						{
							puts("Yes");
						}
						else
							puts("No");
						return 0;
					}
					if (bcnt == 105 && t.size() > 100000 && bl1.size() == 1)
					{
						puts("Yes");
						return 0;
					}
					it = sos.begin();
					++bcnt;
				}
				set< pair <int, pii> >::iterator prev = it;
				--prev;
				set< pair <int, pii> >::iterator nxt = it;
				++nxt;
				++cnt;
				int f = 0;
				if (it->Y.X != ch)
				{
					if (prev != sos.end() && nxt != sos.end())
					{
						if (prev->Y.Y > it->Y.Y || nxt->Y.Y > it->Y.Y)
						{
							f = 1;
							int npos = prev->X;
							int nlen = prev->Y.Y + it->Y.Y;
							if (nxt != sos.end())
								nlen += nxt->Y.Y;
							int mrk = ch;
							pair <int, pii> prevv = *prev;
							pair <int, pii> itv = *it;
							if (nxt != sos.end())
								sos.erase(*nxt);
							sos.erase(prev);
							sos.erase(itv);
							sos.insert(mk(npos, mk(mrk, nlen)));
							it = sos.find(mk(npos, mk(mrk, nlen)));
						}
					}
				}
				else
				{
					if (prev == sos.begin() && it->Y.Y > prev->Y.Y)
					{
						f = 1;
						int npos = prev->X;
						int nlen = prev->Y.Y + it->Y.Y;
						int mrk = ch;
						pair <int, pii> prevv = *prev;
						pair <int, pii> itv = *it;
						sos.erase(prev);
						sos.erase(itv);
						sos.insert(mk(npos, mk(mrk, nlen)));
						it = sos.find(mk(npos, mk(mrk, nlen)));
					}
					else
					{
						if (nxt != sos.end())
						{
							set< pair <int, pii> >::iterator chkit = nxt;
							++chkit;
							if (chkit == sos.end() && it->Y.Y > nxt->Y.Y)
							{
								f = 1;
								int npos = it->X;
								int nlen = nxt->Y.Y + it->Y.Y;
								int mrk = ch;
								pair <int, pii> nxtv = *nxt;
								pair <int, pii> itv = *it;
								sos.erase(itv);
								sos.erase(nxtv);
								sos.insert(mk(npos, mk(mrk, nlen)));
								it = sos.find(mk(npos, mk(mrk, nlen)));
							}
						}
					}
				}
				if (!f)
					++it;
				else
					cnt = 0;
				if (cnt == g[i].size())
				{
					puts("No");
					return 0;
				}
			}
		}
		++i;
	}
	puts("Yes");
	return 0;
}

int solve()
{
	cin >> n;
	while (n--)
	{
		++it;
		get();
	}
	return 0;
}