#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = (int) 1e9 + 123;
const ll LINF = (ll) 1e18 + 123;

void run();

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

const int N = 1005;

int n, m;
vector<pair<int, int>> g[N];
pair<ll, ll> dist[N];
bool vis[N];

void run() {
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int s;
		cin >> s;
		assert(s == 1);
		int u, v, l;
		cin >> u >> l >> v;
		g[u].push_back({v, l});
	}
	
	fill(dist, dist + N, make_pair(LINF, LINF));
	dist[1] = {0, 0};
	priority_queue<pair<pair<ll, ll>, int>> q;
	q.push({{0, 0}, 1});
	
	while (!q.empty()) {
		int v = q.top().second;
		q.pop();
		if (vis[v]) continue;
		vis[v] = 1;
		
		for (auto &e : g[v]) {
			int to = e.first;
			ll nlen = dist[v].first + e.second;
			ll nlen2 = dist[v].second + e.second * 1LL * e.second;
			
			if (nlen < dist[to].first || (nlen == dist[to].first && nlen2 > dist[to].second)) {
				dist[to] = {nlen, nlen2};
				q.push({{-nlen, nlen2}, to});
			}
		}
	}
	
	cout << dist[n].first << " " << dist[n].second << "\n";
}
