#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int main() {
    int n;
    cin >> n;
    vector<int> t(n);
    for (int i = 0; i < n; ++i)
        cin >> t[i];
    vector<pair<int, int>> con(n - 1);
    int minr = 1e9 + 7;
    for (int i = 0; i < n - 1; ++i) {
        cin >> con[i].first >> con[i].second;
        minr = min(minr, con[i].second);
    }
    for (int j = 0; j < n; ++j) {
        bool pass = true;
        for (int stime = 0; stime <= minr; ++stime) {
            int cur = j;
            int time = stime;
            pass = true;
            while (cur != n - 1) {
                if (time > con[cur].second || time + t[cur] < con[cur].first) {
                    pass = false;
                    break;
                }
                else {
                    time = max(time, con[cur].first);
                    cur++;
                }
            }
            cur = j;
            time = stime;
            if (pass) {
                while (cur != 0) {
                    if (time > con[cur - 1].second || time + t[cur] < con[cur - 1].first) {
                        pass = false;
                        break;
                    }
                    else {
                        time = max(time, con[cur - 1].first);
                        cur--;
                    }
                }
            }
            if (pass) {
                cout << stime << endl;
                break;
            }
        }
        if (!pass)
            cout << -1 << endl;
    }
}

/*
1
10
*/

/*
2
3 5
6 8
*/

/*
3
1 2 4
7 10
3 5
*/

/*
4
1 0 3 2
4 6
5 5
7 10
*/
