#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

vector < pair <int, long long> > a, b;

vector <int> spa, spb;

set <int> q;
set <int>::iterator it1, it2, it3;
set < pair <long long, pair <int, int> > > p;
set < pair <long long, pair <int, int> > >::iterator it;

inline pair <long long, pair <int, int> > getm() {
	if (p.size() != 0) {
		it = p.end();
		it--;
		return (*it);
	}
	else {
		return make_pair(0, make_pair(0, 0));
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cerr.tie(0);
	int n, m;
	bool ind = 0;
	cin >> n >> m;
	a.assign(n + 10, make_pair(0, 0));
	b.assign(m + 10, make_pair(0, 0));
	spa.assign(m + n + 100, 0);
	spb.assign(m + n + 100, 0);
	a[0] = b[0] = make_pair(0, 0);
	for (int i = 1; i <= n; i++) {
		cin >> a[i].first;
		spa[a[i].first] = i;
	}
	for (int i = 1; i <= n; i++) {
		cin >> a[i].second;
		a[i].second += a[i - 1].second;
	}
	for (int i = 1; i <= m; i++) {
		cin >> b[i].first;
		spb[b[i].first] = i;
	}
	for (int i = 1; i <= m; i++) {
		cin >> b[i].second;
		b[i].second += b[i - 1].second;
	}
	if (n > m) {
		swap(a, b);
		swap(n, m);
		swap(spb, spa);
		ind = 1;
	}
	pair < long long, pair <int, int> > x;
	int ansal, ansar, ansbl, ansbr;
	long long ans;
	if (b[m].second > a[m].second) {
		ans = b[m].second;
		ansal = ansar = 0;
		ansbl = 1;
		ansbr = m;
	}
	else {
		ans = a[m].second;
		ansbl = ansbr = 0;
		ansal = 1;
		ansar = n;
	}
	long long ansi;
	int j;
	for (int i = 1; i <= n; i++) {
		q.clear();
		p.clear();
		q.insert(0);
		q.insert(m + 1);
		p.insert(make_pair(b[m].second - b[0].second, make_pair(1, m)));
		for (j = i; j <= n; j++) {
			ansi = a[j].second - a[i - 1].second;
			if (spb[a[j].first] != 0) {
				q.insert(spb[a[j].first]);
				it1 = q.find(spb[a[j].first]);
				it2 = it3 = it1;
				it2--;
				it3++;
				p.erase(make_pair(b[(*it3) - 1].second - b[(*it2)].second, make_pair((*it2) + 1, (*it3) - 1)));
				if ((*it1) != (*it2) + 1) {
					p.insert(make_pair(b[(*it1) - 1].second - b[(*it2)].second, make_pair((*it2) + 1, (*it1) - 1)));
				}
				if ((*it1) + 1 != (*it3)) {
					p.insert(make_pair(b[(*it3) - 1].second - b[(*it1)].second, make_pair((*it1) + 1, (*it3) - 1)));
				}
			}
			x = getm();
			if (ans < x.first + ansi) {
				ans = x.first + ansi;
				ansal = i;
				ansar = j;
				ansbl = x.second.first;
				ansbr = x.second.second;
			}
		}
	}
	if (ind) {
		swap(ansal, ansbl);
		swap(ansar, ansbr);
	}
	cout << ans << endl << "\n";
	cout << ansal << " " << ansar << "\n";
	cout << ansbl << " " << ansbr;
}