#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>



using namespace std;

typedef long long ll;


const ll INF = 2e9;


#define int ll


int t[200005];
int l[200005];
int r[200005];
pair<int, int> pref[200005], suff[200005];


pair<int, int> inter(pair<int, int> a, pair<int, int> b) {
	return{ max(a.first, b.first), min(a.second, b.second) };
}


int32_t main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ios_base::sync_with_stdio(0);

	int n;
	cin >> n;
	if (n == 1) {
		cout << 0;
		return 0;
	}
	for (int i = 0; i < n; i++) {
		cin >> t[i];
	}
	for (int i = 0; i < n - 1; i++) {
		cin >> l[i] >> r[i];
	}
	pair<int, int> neut = { 0, INF };
	pair<int, int> bad = { INF, -INF };
	pref[0] = neut;
	for (int i = 1; i < n; i++) {
		auto q = inter(pref[i - 1], { l[i - 1], r[i - 1] });
		if (q.first > q.second) {
			pref[i] = bad;
			continue;
		}
		if (pref[i - 1].first > l[i - 1]) {
			pref[i].first = pref[i - 1].first;
		}
		else {
			pref[i].first = l[i - 1] - t[i];
		}
		pref[i].second = min(pref[i - 1].second, r[i - 1]);
	}
	suff[n - 1] = neut;
	for (int i = n - 2; i >= 0; i--) {
		auto q = inter(suff[i + 1], { l[i], r[i] });
		if (q.first > q.second) {
			suff[i] = bad;
			continue;
		}
		if (suff[i + 1].first > l[i]) {
			suff[i].first = suff[i + 1].first;
		}
		else {
			suff[i].first = l[i] - t[i];
		}
		suff[i].second = min(suff[i + 1].second, r[i]);
	}
	for (int i = 0; i < n; i++) {
		auto pr = pref[i];
		auto su = suff[i];
		auto q = inter(su, pr);
		if (q.first > q.second) {
			cout << "-1\n";
		}
		else {
			cout << q.first << '\n';
		}
	}
}