// A.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <vector>
#include <string>
#include <set>

using namespace std;

struct frg
{
	int ln;
	char type;
	bool used;
	//int num;

	frg(int _ln, char _type)//, int _num)
	{
		ln = _ln;
		type = _type;
		used = false;
		//num = _num;
	}

	frg() {}
};

vector<frg> conv(string now)
{
	vector<frg> ret;
	int l = 0, r = 0;
	while (l < now.size())
	{
		while (now[r + 1] == now[r])
		{
			++r;
		}
		ret.push_back(frg(r - l + 1, now[l]));
		l = r + 1;
		r = l;
	}
	return ret;
}

string s;
string f;
vector<frg> arr;

bool check(int ind)
{
	bool ret = false;
	if (ind > 0 && arr[ind - 1].ln > arr[ind].ln)
	{
		ret = true;
	}
	if (ind < arr.size() - 1 && arr[ind + 1].ln > arr[ind].ln)
	{
		ret = true;
	}
	return ret;
}

void refresh(int ind)
{
	arr[ind].used = true;

	int ln1 = -1, ln2 = -1;
	bool changed = true;

	if (ind > 0)
	{
		ln1 = arr[ind - 1].ln;

		arr[ind - 1].ln += arr[ind].ln;

		if (ind < arr.size() - 1)
		{
			arr[ind - 1].ln += arr[ind + 1].ln;
		}
	}

	if (ind < arr.size() - 1)
	{
		ln2 = arr[ind + 1].ln;

		arr[ind + 1].ln += arr[ind].ln;

		if (ind > 0)
		{
			arr[ind + 1].ln += ln1;
		}
	}

	while (changed)
	{
		changed = false;

		if (ind - 1 > 0 && check(ind - 2) && !arr[ind - 2].used)
		{
			refresh(ind - 2);
			changed = true;
		}



		if (ind < arr.size() - 2 && check(ind + 2) && !arr[ind + 2].used)
		{
			refresh(ind + 2);
			changed = true;
		}
	}
}

int main()
{
	int q;
	cin >> q;
	for (int o = 0; o < q; ++o)
	{
		cin >> s >> f;
		arr = conv(s);
		for (int j = 0; j < arr.size(); ++j)
		{
			for (int i = 0; i < arr.size(); ++i)
			{
				if (arr[i].type == '-' && !arr[i].used && check(i))
				{
					refresh(i);
				}
			}
		}

		string res = "Yes";
		for (int i = 0; i < arr.size(); ++i)
		{
			if (arr[i].type == '-' && !arr[i].used)
			{
				res = "No";
			}
		}
		cout << res << endl;
	}
    return 0;
}

