#include <iostream>
#include <vector>
#include <string>
#include <set>
using namespace std;
#define rep(i, n) for (int i = 0; i < n; i++)
#define repp(i, a, b) for (int i = a; i < b; i++)
typedef long long ll;
typedef pair<int, int> pii;
vector<vector<pii>> g;
vector<int> dist;
vector<ll> qual;
const int inf = 2e9;
const ll infl = 1e18;
void dijk(int s) {
	dist[s] = 0;
	set<pii> sp;
	sp.insert({ 0, s });
	while (!sp.empty()) {
		int fr = sp.begin()->second;
		sp.erase(sp.begin());
		for (pii t : g[s]) {
			int to = t.first;
			int w = t.second;
			if (dist[to] > w + dist[fr]) {
				sp.erase({ dist[to], to });
				dist[to] = w + dist[fr];
				qual[to] = w * w + qual[fr];
				sp.insert({ dist[to], to });
			}
		}
	}
}
int main() {
	ios_base::sync_with_stdio(0);
	int n, m;
	cin >> n >> m;
	g.resize(n);
	dist.resize(n, inf);
	qual.resize(n);
	rep(i, m) {
		int q, fr;
		cin >> q >> fr;
		fr--;
		rep(j, q) {
			int w, to;
			cin >> w >> to;
			to--;
			g[fr].push_back({ to, w });
			fr = to;
		}
	}
	dijk(0);
	cout << dist[n - 1] << " " << qual[n - 1];
}