#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <utility>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

void ans(bool ok) {
	if (ok)
		cout << "Yes\n";
	else
		cout << "No\n";
}

int len(pair<int, int> a) {
	return a.second - a.first;
}

int t[800007];

void upd(int v, int tl, int tr, int pos, int val) {
	if (pos > tr || pos < tl)
		return;
	if (tl == tr) {
		t[v] += val;
		return;
	}
	upd(v * 2, tl, (tl + tr) / 2, pos, val);
	upd(v * 2 + 1, (tl + tr) / 2 + 1, tr, pos, val);
	t[v] = max(t[v * 2], t[v * 2 + 1]);
}

int get(int v, int tl, int tr, int l, int r) {
	if (l > tr || r < tl) {
		return -1;
	}
	if (tl >= l && tr <= r) {
		return t[v];
	}
	int tm = (tl + tr) / 2;
	return max(get(v * 2, tl, tm, l, r), get(v * 2 + 1, tm + 1, tr, l, r));
}


int main() {
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
	int n;
	cin >> n;
	vector<int> t(n);
	for (int i = 0; i < n; i++) {
		cin >> t[i];
	}

	int mn = 1231241242;
	vector<pair<int, int> > g(n - 1);
	for (int i = 0; i < n - 1; i++) {
		cin >> g[i].first >> g[i].second;
		mn = min(mn, g[i].second);
	}
	if (*min_element(t.begin(), t.end()) == 5000) {
		bool ok = true;
		for (int i = 0; i < n; i++) {
			ok = true;
			int mx;
			if (i < n - 1)
				mx = g[i].first;
			for (int j = i + 1; j < n - 1; j++) {
				if (mx > g[j].second) {
					ok = false;
				}
				else {
					mx = max(mx, g[j].first);
				}
			}
			if (i)
				mx = g[i - 1].first;
			for (int j = i - 2; j >= 0; j--) {
				if (g[j].second < mx)
					ok = false;
				else {
					mx = max(mx, g[j].first);
				}
			}
			if (ok)
				cout << 0 << endl;
			else
				cout << -1 << endl;
		}
	}
	else {
		if (mn < 5000) {
			for (int i = 0; i < n; i++) {
				bool w = 0;
				for (int tt = 0; tt <= 500; tt++) {
					if (i) {
						if (g[i - 1].first - t[i] > tt || tt > g[i - 1].second)
							continue;
					}
					if (i < n - 1) {
						if (g[i].first - t[i] > tt || tt > g[i].second)
							continue;
					}
					int cur = tt;
					if (i < n - 1)
						cur = max(tt, g[i].first);
					bool ok = true;
					for (int j = i + 1; j < n - 1; j++) {
						if (g[j].first - t[j] > cur || cur > g[j].second) {
							ok = false;
							break;
						}
						cur = max(cur, g[j].first);
					}
					if (!ok)
						continue;
					if (i)
						cur = max(tt, g[i - 1].first);
					for (int j = i - 1; j >= 0; j--) {
						if (j) {
							if (g[j - 1].first - t[j] > cur || cur > g[j - 1].second) {
								ok = false;
								break;
							}
						}
						cur = max(cur, g[j - 1].first);
					}
					if (!ok)
						continue;
					w = 1;
					cout << tt << endl;
					break;
				}
				if (w == 0) {
					cout << -1 << endl;
				}
			}
		}
		else {
			for (int i = 0; i < n; i++) {
				int cura = -10000000;
				if (i < n - 1) {
					cura = g[i].first - t[i];
				}
				if (i) {
					cura = max(cura, g[i - 1].first - t[i]);
				}
				if (i < n - 1) {
					int cur = g[i].first;
					int cc = 0;
					for (int j = i + 1; j < n - 1; j++) {
						if (cur + t[j] < g[j].first) {
							cc += max(0, g[j].first - t[j] - cur);
							cur = max(cur, g[j].first - t[j]);
						}
						cur = max(cur, g[j].first);
					}
					cura = max(cura, g[i].first + cc);
				}
				if (i) {
					int cur = g[i - 1].first;
					int cc = 0;
					for (int j = i - 1; j > 1; j--) {
						if (cur + t[j] < g[j - 1].first) {
							cc += max(0, g[j - 1].first - t[j] - cur);
							cur = max(cur, g[j - 1].first - t[j]);
						}
						cur = max(cur, g[j - 1].first - t[j]);
					}
					cura = max(cura, g[i - 1].first + cc);
				}
				cout << cura - t[i] << endl;
			}
		}
	}
	return 0;
}