#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < n; i++)
#define pb push_back
#define mp make_pair
#define x first
#define y second
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef pair < int, int > pii;
typedef pair < ll, ll > pll;

const int INF = 2e9;
const ll INF64 = 2e18;
const int N = 500010;
const int M = 1010;

int n, m, a[N], b[N];
ll x[N], y[N], ans, sum_x[N], sum_y[N];
pii aa, bb;

inline void read() {
    cin >> n >> m;
    forn(i, n) {
        scanf("%d", &a[i]);
    }
    forn(i, n) {
        scanf("%lld", &x[i]);
        if (i)
            sum_x[i] = sum_x[i - 1];
        sum_x[i] += x[i];
    }
    forn(i, m) {
        scanf("%d", &b[i]);
    }
    forn(i, m) {
        scanf("%lld", &y[i]);
        if (i)
            sum_y[i] = sum_y[i - 1];
        sum_y[i] += y[i];
    }
}

int use[N + N];

inline void solve_n3() {
    for (int i = 0; i < n; i++) {
        for (int l = 0; l < m; l++) {
            fill(use, use + n + m + 1, 0);
            ll sum = 0;
            int r = m - 1;
            for (int u = l; u <= r; u++) {
                sum += y[u];
                use[b[u]]++;
            }
            for (int j = i; j < n; j++) {
                use[a[j]]++;
                sum += x[j];
                while (l <= r && use[a[j]] > 1) {
                    use[b[r]]--;
                    sum -= y[r];
                    r--;
                }
                if (l > r)
                    break;
                if (sum > ans) {
                    ans = sum;
                    aa = mp(i, j); bb = mp(l, r);
                }
            }
        }
    }
}

int nn, ind[N], mark[N], max_left[N], max_right[N];

inline ll get(ll *sum, int l, int r) {
    ll ans = sum[r];
    if (l)
        ans -= sum[l - 1];
    return ans;
}

inline void solve_n2() {
    nn = n + m;
    fill(ind, ind + nn + 1, -1);
    forn(i, n) {
        ind[a[i]] = i;
        a[i] = i;
    }
    forn(i, m)
        b[i] = ind[b[i]];
    //=========================
    fill(mark, mark + n, INF);
    forn(i, m)
        if (b[i] != -1)
            mark[b[i]] = i;
    forn(i, n) {
        max_left[i] = i - 1;
        max_right[i] = i + 1;
        while (max_left[i] >= 0 && mark[max_left[i]] > mark[i])
            max_left[i]--;
        while (max_right[i] < n && mark[max_right[i]] > mark[i])
            max_right[i]++;
    }
    /*
    forn(i, n)
        cout << "==  " << max_left[i] << ' ' << max_right[i] << endl;
    */
    //=====================
    for (int l = 0; l < m; l++) {
        pii cc;
        ll maxi = -INF64;
        for (int i = 0; i < n; i++)
            if (mark[i] == INF) {
                int j = i;
                while (j < n && mark[j] == INF)
                    j++;
                ll sum = get(sum_x, i, j - 1);
                if (sum > maxi) {
                    maxi = sum;
                    cc = mp(i, j - 1);
                }
                sum += get(sum_y, l, m - 1);
                if (sum > ans) {
                    ans = sum;
                    aa = mp(i, j - 1); bb = mp(l, m - 1);
                }
                i = j - 1;
            }
        //==================
        for (int r = m - 1; r > l; r--)
            if (b[r] != -1) {
                int v = b[r];
                int tl = max_left[v], tr = max_right[v];
                ll sum = get(sum_x, tl + 1, tr - 1);
                if (sum > maxi) {
                    maxi = sum;
                    cc = mp(tl + 1, tr - 1);
                }
                sum = get(sum_y, l, r - 1);
                if (maxi + sum > ans) {
                    ans = maxi + sum;
                    aa = cc; bb = mp(l, r - 1);
                }
            }
        // ------------
        if (b[l] != -1) {
            int v = b[l];
            mark[v] = INF;
            for (int i = v; i < n; i++) {
                while (max_left[i] >= 0 && mark[max_left[i]] > mark[i])
                    max_left[i]--;
            }
            for (int i = v; i >= 0; i--) {
                while (max_right[i] < n && mark[max_right[i]] > mark[i])
                    max_right[i]++;
            }
        }
        //-------------
    }
}

int main() {
    read();
    ans = sum_x[n - 1];
    aa = mp(0, n - 1); bb = mp(-1, -1);
    if (sum_y[m - 1] > ans) {
        ans = sum_y[m - 1];
        aa = mp(-1, -1); bb = mp(0, m - 1);
    }
    // ====================================
    //solve_n3();
    solve_n2();
    // ====== answer =======
    cout << ans << endl;
    cout << aa.x + 1 << ' ' << aa.y + 1 << endl;
    cout << bb.x + 1 << ' ' << bb.y + 1 << endl;
    return 0;
}


/*





*/



