import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class B2 {

	private int get(final int[] z0, final int[] z1, int m) {
		int ans = 0;
		for (int i = m - 1; i >= 0; i--) {
			ans <<= 1;
			if (z1[i] == 0) {
				continue;
			}
			if (z0[i] != 0) {
				return -1;
			}
			ans++;
		}
		return ans;
	}
	
	private void solve() throws IOException {
		final int n = nextInt(), m = 32;
		final int[] q = new int[n];
		for (int i = 0; i < n; i++) {
			q[i] = nextInt();
		}
		final int w = nextInt();
		final int[] z0 = new int[m], z1 = new int[m];
		for (int i = 1; i < n; i++) {
			if (q[i - 1] == q[i]) {
				continue;
			}
			final int k = 32 - Integer.numberOfLeadingZeros(Integer.highestOneBit(q[i - 1] ^ q[i]) - 1);
			if ((q[i - 1] & (1 << k)) != 0) {
				z1[k]++;
			} else {
				z0[k]++;
			}
		}
		out.println(get(z0, z1, m));
		for (int i = 0; i < w; i++) {
			final int p = nextInt() - 1, v = nextInt();
			if (p != 0 && q[p - 1] != q[p]) {
				final int k = 32 - Integer.numberOfLeadingZeros(Integer.highestOneBit(q[p - 1] ^ q[p]) - 1);
				if ((q[p - 1] & (1 << k)) != 0) {
					z1[k]--;
				} else {
					z0[k]--;
				}
			}
			if (p != n - 1 && q[p] != q[p + 1]) {
				final int k = 32 - Integer.numberOfLeadingZeros(Integer.highestOneBit(q[p] ^ q[p + 1]) - 1);
				if ((q[p] & (1 << k)) != 0) {
					z1[k]--;
				} else {
					z0[k]--;
				}
			}
			q[p] = v;
			if (p != 0 && q[p - 1] != q[p]) {
				final int k = 32 - Integer.numberOfLeadingZeros(Integer.highestOneBit(q[p - 1] ^ q[p]) - 1);
				if ((q[p - 1] & (1 << k)) != 0) {
					z1[k]++;
				} else {
					z0[k]++;
				}
			}
			if (p != n - 1 && q[p] != q[p + 1]) {
				final int k = 32 - Integer.numberOfLeadingZeros(Integer.highestOneBit(q[p] ^ q[p + 1]) - 1);
				if ((q[p] & (1 << k)) != 0) {
					z1[k]++;
				} else {
					z0[k]++;
				}
			}
			out.println(get(z0, z1, m));
		}
	}
	
	private final BufferedReader in;
	private final PrintWriter out;
	private StringTokenizer st;
	
	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	
	private B2() throws IOException {
		in = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);
		
		solve();
		
		in.close();
		out.close();
	}
	
	public static void main(final String[] args) throws IOException {
		new B2();
	}

}
/*
3
0 1 4
3
2 7
3 3
1 4
*/