#include <iostream>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <set>

using namespace std;

const int INF = 1000000113;

vector <pair <int, int> > gr[100113];

int d[100113], ans[100113];

int main() {
	int n, m;

	cin >> n >> m;

	for (int i = 0; i < m; i++) {
		int p, u, w, v;

		cin >> p >> u >> w >> v;

		gr[u].push_back(make_pair(v, w));
	}

	for (int i = 1; i <= n; i++)
		d[i] = INF;

	d[1] = 0;

	set <pair <int, int> > q;

	q.insert(make_pair(d[1], 1));

	while (!q.empty()) {
		int v = q.begin()->second;

		q.erase(q.begin());

		for (int i = 0; i < gr[v].size(); i++) {
			int to = gr[v][i].first, len = gr[v][i].second;

			if (d[to] >= d[v] + len && ans[to] < ans[v] + len * len) {
				q.erase(make_pair(d[to], to));
				d[to] = d[v] + len;
				ans[to] = ans[v] + len * len;
				q.insert(make_pair(d[to], to));
			}

		}
	}

	cout << d[n] << ' ' << ans[n];
	return 0;
}