#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<stack>

using namespace std;
typedef long long ll;
const ll INF = 1e18;

int main() {
	int n, m;
	cin >> n >> m;
	vector<vector<pair<ll, ll>>> g(n);
	for (int i = 0; i < m; ++i) {
		int k;
		cin >> k;
		int last;
		cin >> last;
		for (int j = 0; j < k; ++j) {
			int t, y;
			cin >> t >> y;
			g[last - 1].push_back({ y - 1, t });
			last = y;
		}
	}
	vector<ll> dist(n, INF), used(n), ans(n, 0);
	dist[0] = 0;
	for (int i = 0; i < n; ++i) {
 		ll d = INF, in = -1;
		for (int j = 0; j < n; ++j)
			if (used[j] == 0 & dist[j] < d) {
				d = dist[j];
				in = j;
			}
		if (in == n - 1)
			break;
		used[in] = 1;
		for (int j = 0; j < g[in].size(); ++j) {
 			if (dist[g[in][j].first] >= dist[in] + g[in][j].second) {
				if (dist[g[in][j].first] == dist[in] + g[in][j].second) {
					ans[g[in][j].first] = max(ans[g[in][j].first], ans[in] + g[in][j].second * g[in][j].second);
				}
				else {
					ans[g[in][j].first] = ans[in] + g[in][j].second * g[in][j].second;
				}
				dist[g[in][j].first] = min(dist[g[in][j].first], dist[in] + g[in][j].second);
			}
		}
	}
	cout << dist[n - 1] << ' ' << ans[n - 1];
	return 0;
}