#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#define ll long long

using namespace std;
//ifstream cin("input.txt"); ofstream cout("output.txt");

void solve() {
	string s, t;
	cin >> s >> t;
	vector<int> a, b;
	int n = s.size();
	for (int i = 0; i < n - 1; i++) {
		if (s[i] != s[i + 1] && s[i] != t[i] && t[i] != t[i + 1]) {
			cout << "No" << endl;
			return;
		}
	}
	for (int i = 0; i < n;) {
		int c = i;
		while (i<n && s[i] == s[c]) {
			c++;
		}
		a.push_back(c - i);
		if (s[i] == '-') a.back() = -1 * a.back();
		i = c;
	}
	for (int i = 0; i < n;) {
		int c = i;
		while (i<n && t[i] == t[c]) {
			c++;
		}
		b.push_back(c - i);
		if (t[i] == '-') b.back() = -1 * b.back();
		i = c;
	}
	int cur = 0;
	for (int i = 0; i < b.size(); i++) {
		int sum = 0, c = cur;
		set<int> p;
		while (sum < abs(b[i])) {
			sum += abs(a[cur]);
			p.insert(abs(a[cur]));
			cur++;
		}
		if (sum != abs(b[i]) || p.size() == 1 && cur - c != 1) {
			cout << "No" << endl;
			return;
		}
	}
	cout << "Yes" << endl;
}
int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
	return 0;
}
