#include <bits/stdc++.h>
typedef long long ll;
#define v1 (2 * v + 1)
#define v2 (2 * v + 2)
using namespace std;

const ll N = 2000;
const ll inf = 1000000000000000000;
vector <pair <ll, ll> > p[N];
map <ll, ll> w[N];
pair <ll, ll> d[N];

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);

    ll n, m;
    cin >> n >> m;

    d[1] = {0, 0};

    for (ll i = 2; i < N; i++) d[i].first = d[i].second = inf;

    for (ll i = 0; i < m; i++) {
        ll s;
        cin >> s;
        p[i].resize(s + 1);
        ll x;
        cin >> x;
        w[i][x] = 0;
        p[i][0] = {x, 0};
        for (ll j = 1; j <= s; j++) {
            ll x, t;
            cin >> t >> x;
            w[i][x] = j;
            p[i][j] = {x, t};
        }
    }

    for (ll i = 1; i < n; i++) {
        if (d[i].first >= inf) continue;
        for (ll j = 0; j < m; j++) {
            if (!w[j].count(i)) continue;
            ll t = 0;
            for (ll k = w[j][i] + 1; k < p[j].size(); k++) {
                t += p[j][k].second;
                if (d[p[j][k].first].first > d[i].first + t) {
                    d[p[j][k].first] = {d[i].first + t, d[i].second + t * t};
                }
                if (d[p[j][k].first].first == d[i].first + t) {
                    d[p[j][k].first] = max(d[p[j][k].first], {d[i].first + t, d[i].second + t * t});
                }
            }
        }
    }

    cout << d[n].first << " " << d[n].second << endl;

    return 0;
}