#include <bits/stdc++.h>

using namespace std;

struct seg
{
	int l, r;
	seg(int l, int r)
		: l(l), r(r)
	{}
	seg()
		: l(-1), r(-1)
	{}
	bool good()
	{
		return r >= l;
	}
};
seg inter(seg a, seg b)
{
	return seg(max(a.l, b.l), min(a.r, b.r));
}

int main()
{
	int n;
	scanf("%d", &n);
	vector<int> t(n);
	for (auto& x : t)
		scanf("%d", &x);
	vector<seg> bou(n - 1);
	for (int i = 0; i < n - 1; ++i)
		scanf("%d %d", &bou[i].l, &bou[i].r);
	vector<seg> dpl(n), dpr(n);
	int INF = 2000000000;
	dpl[0] = seg(0, INF);
	dpr[n - 1] = seg(0, INF);
	for (int i = 1; i < n; ++i)
	{
		auto b1 = bou[i - 1];
		b1.l -= t[i];
		dpl[i] = inter(b1, dpl[i - 1]);
	}
	for (int i = n - 2; i >= 0; --i)
	{
		auto b1 = bou[i];
		b1.l -= t[i];
		dpr[i] = inter(b1, dpr[i + 1]);
	}
	for (int i = 0; i < n; ++i)
	{
		auto mem = inter(dpl[i], dpr[i]);
		if (!mem.good())
			cout << -1 << '\n';
		else
			cout << mem.l << '\n';
		/*
		cout << i << endl;
		if (!dpl[i].good())
			cout << -1 << endl;
		else
			cout << dpl[i].l << ' ' << dpl[i].r << endl;
		if (!dpr[i].good())
			cout << -1 << endl;
		else
			cout << dpr[i].l << ' ' << dpr[i].r << endl;
		*/
	}
}
