#include <iostream>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

#define int long long
#define mp make_pair

const int p = 1000000000;
const int inf = p * 2000000 + 100;

struct node
{
	int l, r, c;
	node() {}
};

int d1[2000001];
int n;
vector<node> typs;

int solve(int a)
{
	if (d1[a] != -1)
		return d1[a];
	int best = 0;
	for (int i = 0; i < n; i++)
	{
		if (a >= typs[i].r)
		{
			int ans = inf;
			for (int j = typs[i].l; j <= typs[i].r; j++)
				if (a - j >= 0)
					ans = min(ans, solve(a - j) + j * p - typs[i].c);
			if (ans == inf)
				ans = 0;
			best = max(best, ans);
		}
	}
	return d1[a] = best;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int a;
	cin >> n >> a;

	typs.resize(n);

	bool p1 = true;
	for (int i = 0; i <= 2000000; i++)
		d1[i] = -1;
	for (int i = 0; i < n; i++)
	{
		cin >> typs[i].l >> typs[i].r >> typs[i].c;
		if (typs[i].l != typs[i].r)
			p1 = false;
	}

	cout << solve(a);


	system("pause");
}