#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:512000000")

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <vector>
#include <unordered_set>
#include <unordered_map>
#include <cassert>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#define pk push_back
#define mk make_pair
#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define for1(i, n) for(int i = 1; i <=(int)(n); i++)

void solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int MAXN = (int)2e5 + 7;
const int INF = (int)1e9;

struct seg {
	int l, r;

	void inter(seg s) {
		l = max(l, s.l);
		r = min(r, s.r);
		if (l > r) {
			l = INF, r = -INF;
		}
	}
} a[MAXN], pref[MAXN], suff[MAXN];


int t[MAXN];

void uin(int &x, int y) {
	x = min(x, y);
}

void uax(int &x, int y) {
	x = max(x, y);
}

int get(int i) {
	int l = max(pref[i].l, suff[i].l);
	int r = min(pref[i].r, suff[i].r);
	if (l > r) return -1;
	if (l >= 0) return l;
	if (r < 0) return -1;
	return 0;
}
void solve() {
	int n;
	scanf("%d", &n);
	for1(i, n) scanf("%d", t + i);
	for1(i, n - 1) scanf("%d%d", &a[i].l, &a[i].r);

	pref[1] = { -INF, +INF };
	for (int i = 2; i <= n; i++) {
		seg go = a[i - 1];
		seg nxt = pref[i - 1];

		suff[i] = nxt;
		if (go.r < go.l - t[i]) {
			pref[i].l = +INF;
			pref[i].r = -INF;
		}
		else {
			if (go.l >= nxt.l) {
				pref[i].l = go.l - t[i];
			}
			else {
				pref[i].l = max(nxt.l, go.l - t[i]);
			}
			if (pref[i].l > go.r || pref[i].l < go.l - t[i]) {
				pref[i].l = INF;
			}

			if (go.l <= nxt.r) {
				pref[i].r = min(go.r, nxt.r);
			}
			else {
				pref[i].r = -INF;
			}

			if (pref[i].r > go.r || pref[i].r < go.l - t[i]) {
				pref[i].r = -INF;
			}
		}

		if (pref[i].l > pref[i].r) pref[i] = { INF, -INF };
	}

	suff[n] = { -INF, +INF };
	for (int i = n - 1; i >= 1; i--) {
		seg go = a[i];
		seg nxt = suff[i + 1];

		suff[i] = nxt;
		if (go.r < go.l - t[i]) {
			suff[i].l = +INF;
			suff[i].r = -INF;
		}
		else {
			if (go.l >= nxt.l) {
				suff[i].l = go.l - t[i];
			}
			else {
				suff[i].l = max(nxt.l, go.l - t[i]);
			}
			if (suff[i].l > go.r || suff[i].l < go.l - t[i]) {
				suff[i].l = INF;
			}

			if (go.l <= nxt.r) {
				suff[i].r = min(go.r, nxt.r);
			}
			else {
				suff[i].r = -INF;
			}

			if (suff[i].r > go.r || suff[i].r < go.l - t[i]) {
				suff[i].r = -INF;
			}
		}

		if (suff[i].l > suff[i].r) suff[i] = { INF, -INF };
	}


	for (int i = 1; i <= n; i++) {
		int ans = get(i);
		printf("%d\n", ans);
	}
}