#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <iomanip>
using namespace std;

const long long len = 10000;
long long x;
pair < long long, long long > a[len];

long long cnt(long long x) {
	long long ans = 0;
	for (long long i = 0; i < x; i++) {
		for (long long j = i + 1; j < x; j++) {
			for (long long k = j + 1; k < x; k++) {
				ans++;
			}
		}
	}
	return ans;
}

pair < long long, long long > operator - (pair < long long, long long > a, pair < long long, long long > b) {
	return{ a.first - b.first, a.second - b.second };
}

long long operator * (pair < long long, long long > a, pair < long long, long long > b) {
	return abs(a.first * b.second - a.second * b.first);
}

long long operator % (pair < long long, long long > a, pair < long long, long long > b) {
	return (a.first * b.second - a.second * b.first);
}

bool ins(long long i, long long j, long long k, int f) {
	return (a[i] - a[f]) * (a[j] - a[f]) + (a[i] - a[f]) * (a[k] - a[f]) + (a[k] - a[f]) * (a[j] - a[f]) == (a[j] - a[i]) * (a[k] - a[i]);
}

bool good(long long i, long long j, long long k) {
	for (long long f = 0; f < x; f++) {
		if (i != f && j != f && k != f) {
			if ((a[i] - a[f]) * (a[j] - a[f]) + (a[i] - a[f]) * (a[k] - a[f]) + (a[k] - a[f]) * (a[j] - a[f]) == (a[j] - a[i]) * (a[k] - a[i]))
				return false;
		}
	}
	return true;
}

bool ask(long long i, long long j, long long k) {
	cout << "? " << 3 << ' ' << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
	string res;
	cin >> res;
	return res == "Yes";
}

int st[len];
pair < long long, long long > mn;

int p[len];

bool cmp(int l, int r) {
	return ((a[l] - a[p[0]]) % (a[r] - a[p[0]])) < 0;
}

int main() {
	cin >> x;
	for (long long i = 0; i < x; i++) {
		cin >> a[i].first >> a[i].second;
		p[i] = i;
	}
	mn = { 1 << 30, 1 << 30 };

	for (int i = 0; i < x; i++)
		mn = min(mn, a[i]);

	for (int i = 0; i < x; i++) {
		if (a[i] == mn) {
			swap(p[i], p[0]);
			break;
		}
	}
	sort(p + 1, p + x, cmp);

	int tp = 0;
	for (int i = 0; i < x; i++) {
		while (tp - 2 >= 0 && (a[p[st[tp - 1]]] - a[p[st[tp - 2]]]) % (a[p[i]] - a[p[st[tp - 1]]]) > 0)
			tp--;
		st[tp++] = p[i];
	}

	long long q;
	cin >> q;
	while (q--) {
		int l = 1, r = tp - 1;
		while (r - l > 1) {
			int m = r + l >> 1;
			cout << "? ";
			vector < int > as;
			as.push_back(st[0]);
			for (int i = m; i < tp; i++) {
				as.push_back(st[i]);
			}
			for (auto k : as)
				cout << k + 1 << ' ';
			cout << endl;
			string ans;
			cin >> ans;
			if (ans == "Yes")
				l = m;
			else
				r = m;
		}
		if (good(0, l, l + 1)) {
			cout << "! " << 1 << ' ' << l + 1 << ' ' << l + 2 << endl;
		}
		else {
			int a = st[0], b = st[l], c = st[l + 1];
			while (!good(a, b, c)) {
				for (int i = 0; i < x; i++) {
					if (i != a && i != b && i != c) {
						if (ins(a, b, c, i)) {
							if (ask(a, b, i)) {
								c = i;
							}
							else {
								if (ask(b, c, i)) {
									a = i;
								}
								else {
									b = i;
								}
							}
						}
					}
				}
			}
			cout << "! " << a + 1 << ' ' << b + 1 << ' ' << c + 1 << endl;
		}
		/*bool found = false;
		for (long long i = 0; i < x && !found; i++) {
			for (long long j = i + 1; j < x && !found; j++) {
				for (long long k = j + 1; k < x && !found; k++) {
					if (good(i, j, k) && !found) {
						bool ok = ask(i, j, k);
						if (ok) {
							cout << "! " << 3 << ' ' << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
							found = true;
						}
					}
				}
			}
		}*/
	}
	cin >> x;
}