#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;

const int len = 6000;
const int inf = 1 << 30;
int x;
int t[len];
int l[len], r[len];

int gl[6000][6000], gr[6000][6000];

bool goleft(int pos, int tme) {
	if (gl[pos][tme] != 0)
		return gl[pos][tme] - 1;
	if (pos == 0) {
		gl[pos][tme] = 2;
		return true;
	}
	if (tme > r[pos - 1]) {
		gl[pos][tme] = 1;
		return false;
	}
	if (tme + t[pos] < l[pos - 1]) {
		gl[pos][tme] = 1;
		return false;
	}
	bool res = goleft(pos - 1, max(tme, l[pos - 1]));
	if (res) {
		gl[pos][tme] = 2;
		return true;
	}
	gl[pos][tme] = 1;
	return false;
}

bool goright(int pos, int tme) {
	if (gr[pos][tme] != 0)
		return gr[pos][tme] - 1;
	if (pos == x - 1) {
		gr[pos][tme] = 2;
		return true;
	}
	if (tme > r[pos]) {
		gr[pos][tme] = 1;
		return false;
	}
	if (tme + t[pos] < l[pos]) {
		gr[pos][tme] = 1;
		return false;
	}
	bool res = goright(pos + 1, max(tme, l[pos]));
	if (res) {
		gr[pos][tme] = 2;
		return true;
	}
	gr[pos][tme] = 1;
	return false;
}

bool can(int i, int j){
	return goleft(i, j) && goright(i, j);
}

int l1[len], l2[len], r1[len], r2[len];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("servers.in", "r", stdin);
	freopen("servers.out", "w", stdout);
#endif
	cin >> x;
	for (int i = 0; i < x; i++) {
		cin >> t[i];
	}
	for (int i = 0; i < x - 1; i++)
		cin >> l[i] >> r[i];

	l1[0] = 0;
	r1[0] = inf;
	for (int i = 1; i < x; i++) {
		if (max(l1[i - 1], l[i - 1]) <= min(r1[i - 1], r[i - 1])){
			if (l1[i - 1] <= l[i - 1]) {
				l1[i] = l[i - 1] - t[i];
			}
			else {
				l1[i] = max({ r[i], l1[i - 1] });
			}
			r1[i] = min(r[i - 1], r1[i - 1]);
		}
		else {
			l1[i] = inf;
			r1[i] = 0;
		}
		//if (max(l1[i - 1], l[i - 1]) <= min(r1[i - 1], r[i - 1])) {
		//	l1[i] = max(l[i - 1] - t[i], l1[i - 1]);
		//	r1[i] = min(r[i - 1], r1[i - 1]);
		/*}
		else {
			l1[i] = inf;
			r1[i] = 0;
		}*/
	}
	l2[x - 1] = 0;
	r2[x - 1] = inf;
	for (int i = x - 2; i >= 0; i--) {
		if (min(l2[i + 1], l[i]) <= max(r2[i + 1], r[i])) {
			//l2[i] = max(l[i] - t[i], l2[i + 1]);
			if (l2[i + 1] <= l[i]) {
				l2[i] = l[i] - t[i];
			}
			else {
				l2[i] = max({ r[i], l2[i + 1] });
			}
			r2[i] = min(r[i], r2[i + 1]);
		}
		else {
			l2[i] = inf;
			r2[i] = 0;
		}
	}
	for (int i = 0; i < x; i++) {
		//cout << l1[i] << ' ' << r1[i] << endl;
		//cout << l2[i] << ' ' << r2[i] << endl;
		//cout << endl;
		if (max(l1[i], l2[i]) <= min(r1[i], r2[i])) {
			cout << max(l1[i], l2[i]) << endl;
		}
		else {
			cout << -1 << endl;
		}
	}
	return 0;
	cout << endl;

	for (int i = 0; i < x; i++) {
		bool found = false;
		for (int j = 0; j <= 5000; j++) {
			if (goleft(i, j))
				cout << j << ' ';
			/*if (can(i, j)) {
				found = true;
				cout << j << ' ';
			}*/
		}
		cout << endl;
		if(!found)
			cout << -1 << endl;
	}
}