#include <bits/stdc++.h>

using namespace std;
typedef long long LL;

int find_elder_bit(LL a, LL b)
{
    bitset<32> a1 = a;
    bitset<32> a2 = b;
    for (int i = 30; i >= 0; --i)
    {
        if (a1[i] != a2[i])  return i;
    }
    return -1;
}

LL get_result(vector <set<int> > & yes, vector <set <int> > & no)
{
    LL res = 0;
    for (int i = 0; i < 31; ++i)
    {
        if (yes[i].size() > 0)
        {
            if (no[i].size() > 0)
            {
                res = -1;
                break;
            }
            else res += (1 << i);
        }
    }


    return res;
}

int main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);


    int n,q;
    cin >> n;
    vector <set <int> > yes(32);
    vector <set <int> > no(32);
    vector <LL> a(n + 1);
    for (int i = 1; i < n + 1; ++i)
    {
        cin >> a[i];
    }

    for (int i = 1; i < n; ++i)
    {
        int bt = find_elder_bit(a[i],a[i + 1]);
        if (bt == -1) continue;
        if (a[i] > a[i + 1])
        {
            yes[bt].insert(i);
        }
        else
        {
            no[bt].insert(i);
        }
    }

    cout << get_result(yes,no) << '\n';

    /*
     for (int i = 0; i < 31; ++i)
    {
        cout << yes[i].size() << " " << no[i].size() << endl;
    }
    */

    cin >> q;
    for (int i = 0; i < q; ++i)
    {
        int pos, v;
        cin >> pos >> v;
        for (int j = 0; j < 31; ++j)
        {
            no[j].erase(pos - 1);
            no[j].erase(pos);
            yes[j].erase(pos - 1);
            yes[j].erase(pos);
        }
         a[pos] = v;

        if (pos > 1)
        {
            int bt = find_elder_bit(a[pos - 1], a[pos]);
            //cout << "BT: " <<bt << endl;
             if (bt != -1)
             if (a[pos - 1] > a[pos])
            {
                yes[bt].insert(pos - 1);
            }
            else
            {
                no[bt].insert(pos - 1);
            }

        }
        if (pos < n)
        {
            int bt = find_elder_bit(a[pos], a[pos + 1]);
            //cout << "BT: " << bt << endl;
            if (bt != -1)
             if (a[pos] > a[pos + 1])
            {
                yes[bt].insert(pos);
            }
            else
            {
                if (bt != -1) no[bt].insert(pos);
            }
        }

        cout << get_result(yes,no) << '\n';

        /*
        cout << "BITS: " << endl;
         for (int i = 0; i < 31; ++i)
        {
            cout << yes[i].size() << " " << no[i].size() << endl;
        }
        */
    }

    return 0;
}
