#pragma comment(linker, "/Stack:768000000")
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <string>
#include <cstring>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long LL;

void revert() {
  LL x;
  if (scanf("%I64d", &x) != 1) return;
  revert();
  cout << x << ' ';
}

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#elif 1
# define PROB "sequence"
  freopen(PROB".in", "r", stdin);
  freopen(PROB".out", "w", stdout);
#endif
  cin.tie(0);
  cin.sync_with_stdio(0);

  const int MAXN = 1000;
  
  vector<vector<int>> dist(MAXN, vector<int>(MAXN));
  for (int i = 0; i < MAXN; ++i)
    for (int j = 0; j < MAXN; ++j)
      dist[i][j] = rand();

  for (int i = 0; i < MAXN; ++i)
    for (int j = 0; j < MAXN; ++j) {
      if (i == j) continue;
      for (int k = 0; k < MAXN; ++k) {
        if (i == k || j == k) continue;
        dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
      }
    }

  revert();

  return 0;
}