#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <map>
#include <string>
#include <set>

using namespace std;

typedef long long ll;

#define first X
#define second Y

const int MAXN = (int)1e5 + 7;

int n;

char a[MAXN];

bool ask(int l, int r)
{
	cout << '?' << ' ' << l << ' ' << r << endl;
	string x;
	cin >> x;
	return (x == "Yes");
}

int main()
{
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif // _DEBUG
	cin >> n;
	for (int i = 0; i < n; i++)
		a[i] = '?';
	a[0] = '?';
	vector<int> last;
	for (int i = 0; i < n; i++)
	{
		if (last.size() == 0)
		{
			last.push_back(i);
			a[i] = '(';
			continue;
		}
		else
		{
			if (ask(last.back() + 1, i + 1))
			{
				a[i] = ')';
				last.pop_back();
			}
			else
			{
				a[i] = '(';
				last.push_back(i);
			}
		}
	}
	cout << "! ";
	for (int i = 0; i < n; i++)
		cout << a[i];
}